/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: CommandB.c,v $
 * Revision 1.1.2.1  1994/06/02  15:32:46  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:53:58  marty]
 *
 * Revision 1.1.4.10  1994/04/14  19:47:31  rosenberg
 * 	Changed warning comment at front of program for CR 8570
 * 	[1994/04/14  15:29:22  rosenberg]
 * 
 * Revision 1.1.4.9  1994/04/06  16:34:36  daniel
 * 	remove border_width use, not needed
 * 	[1994/04/06  16:34:15  daniel]
 * 
 * Revision 1.1.4.8  1994/04/05  21:35:09  rosenberg
 * 	Changed action names under drk's guidance
 * 	[1994/04/05  21:34:48  rosenberg]
 * 
 * Revision 1.1.4.7  1994/04/05  20:22:27  rosenberg
 * 	Changed the name of the action methods.  They now
 * 	have ExmCommandButton as a prefix.
 * 	[1994/04/05  20:22:05  rosenberg]
 * 
 * Revision 1.1.4.6  1994/04/04  13:41:55  rosenberg
 * 	Removed extern declaration of ExmCreateCommandButton from CommandB.c.
 * 	Added #include <Xm/TraitP.h>.  These fixes for CR 8394.
 * 	[1994/03/31  21:10:45  rosenberg]
 * 
 * Revision 1.1.4.5  1994/03/31  20:31:29  rosenberg
 * 	Fixed ShowAsDefault trait method for CR 7971.
 * 	[1994/03/31  20:30:17  rosenberg]
 * 
 * Revision 1.1.4.4  1994/03/29  21:17:04  rosenberg
 * 	Added XmConst support for CR 8416
 * 	[1994/03/29  21:15:37  rosenberg]
 * 
 * Revision 1.1.4.3  1994/03/25  21:39:21  rosenberg
 * 	Corrected name of primClassExtRec and made it static
 * 	[1994/03/25  21:38:08  rosenberg]
 * 
 * Revision 1.1.4.2  1994/02/26  18:46:45  rosenberg
 * 	Got rid of pesky Warnings due to not casting
 * 	XtIsRealized and XtIsManaged to a pure widget.
 * 	[1994/02/26  18:43:25  rosenberg]
 * 
 * Revision 1.1.4.1  1994/02/26  18:36:09  rosenberg
 * 	Added colons to front of osfMumble translations and changed order of translations; CR 7490
 * 	[1994/02/26  18:34:51  rosenberg]
 * 
 * 	Simple.c
 * 
 * Revision 1.1.2.1  1993/10/05  21:00:31  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:00:27  yak]
 * 
 * Revision 1.1.2.6  1993/07/21  20:42:45  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:19:06  yak]
 * 
 * Revision 1.1.2.5  1993/06/30  21:18:18  rosenberg
 * 	Tried to fix ShowAsDefault.  Did not succeed.
 * 	Did a few minor things to bring widget in line with
 * 	its superclass (ExmString).
 * 	[1993/06/30  21:17:01  rosenberg]
 * 
 * Revision 1.1.2.4  1993/06/15  14:36:25  rosenberg
 * 	Added reconfigure to Primitive class record.
 * 	[1993/06/15  14:34:15  rosenberg]
 * 
 * Revision 1.1.2.3  1993/05/26  21:34:49  rosenberg
 * 	Ready for initial code review, but widget still needs some work.
 * 	[1993/05/26  21:34:11  rosenberg]
 * 
 * 	Fixed some bugs.
 * 	[1993/05/26  17:15:26  rosenberg]
 * 
 * Revision 1.1.2.2  1993/02/26  21:05:27  al
 * 	Initial version
 * 	[1993/02/26  20:59:34  al]
 * 
 * $EndLog$
 */
/************************************ WARNING **********************************
 *
 * ExmCommandButton is a demonstration widget.  OSF provides this widget
 * solely to teach programmers how to write their own Motif widgets.
 * OSF does not support this widget in any way." 
 *
 ************************************ WARNING *********************************/


/*******************************************************************************
 *
 * CommandB.c - ExmCommandButton widget.  This widget displays a button that,
 *              when activated, initiates a callback.
 *              This widget demonstrates how to
 *                  * create Motif-style button visuals.
 *                  * establish Motif-style actions for buttons. 
 *                  * establish the XmQTactivatable trait.
 *                  * establish the XmQTtakesDefault trait.
 *                  * establish a simple Motif callback.
 *              See the "OSF/Motif Widget Writer's Guide" for details.
 *
 ******************************************************************************/

/* Include appropriate files. */
#include <Exm/CommandBP.h> /* private header file for ExmCommandButton widget */
#include <Xm/DrawP.h>  /* header file for Xme drawing functions */
#include <Xm/TraitP.h> /* header file for XmeTraitSet and XmeTraitGet. */
#include <Xm/ActivatableT.h> /* header file for XmQTactivatable trait */
#include <Xm/TakesDefT.h> /* header file for XmQTtakesDefault trait */
#include <Xm/SpecRenderT.h> /* header file for render table constants */

/* The VISUAL_DELAY constant holds a time in milliseconds. */
static XmConst unsigned long  VISUAL_DELAY = 100;

/* Declare all static functions. */
#ifdef _NO_PROTO
static void Initialize();
static void ClassPartInitialize();
static void Destroy();
static Boolean SetValues();
static void DrawShadow();
static void ExmCommandButtonEnter();
static void ExmCommandButtonLeave();
static void ExmCommandButtonArmAndActivate();
static void ExmCommandButtonArm();
static void ExmCommandButtonActivate();
static void ExmCommandButtonDisarm();
static void VisualDisarm();
static void ChangeCB();
static void ShowAsDefault();
#else
static void Initialize (
                        Widget request_w,
                        Widget new_w,
                        ArgList args,
                        Cardinal *num_args);
static void ClassPartInitialize(
                        WidgetClass widgetclass);
static void Destroy (
                        Widget w);
static Boolean SetValues (
                        Widget old_w,
                        Widget request_w,
                        Widget new_w,
                        ArgList args,
                        Cardinal *num_args);
static void DrawShadow ( 
                        Widget w);

static void ExmCommandButtonEnter (
                        Widget w,
                        XEvent *event,
                        String *params,
                        Cardinal *num_params);
static void ExmCommandButtonLeave (
                        Widget w,
                        XEvent *event,
                        String *params,
                        Cardinal *num_params);
static void ExmCommandButtonArmAndActivate (
                        Widget w,
                        XEvent *event,
                        String *params,
                        Cardinal *num_params);
static void ExmCommandButtonArm (
                        Widget w,
                        XEvent *event,
                        String *params,
                        Cardinal *num_params);
static void ExmCommandButtonActivate (
                        Widget w,
                        XEvent *event,
                        String *params,
                        Cardinal *num_params);
static void ExmCommandButtonDisarm (
                        Widget w,
                        XEvent *event,
                        String *params,
                        Cardinal *num_params);
static void VisualDisarm (
                        XtPointer cd,
                        XtIntervalId *id);
static void ChangeCB(
                        Widget w,
                        XtCallbackProc activCB,
                        XtPointer closure,
                        Boolean setunset);
static void ShowAsDefault(
                        Widget w,
                        XtEnum state);
#endif

/* Define the translations for the ExmCommandButton widget. 
   The first four translations will be handled by the XmPrimitive
   widget; the last six translations will be handled by the
   ExmCommandButton widget itself. */
static char defaultTranslations[] =
"<EnterWindow>:		ExmCommandButtonEnter()\n\
<LeaveWindow>:		ExmCommandButtonLeave()\n\
~c <Btn1Down>:		ExmCommandButtonArm()\n\
<Btn1Up>:		ExmCommandButtonActivate() ExmCommandButtonDisarm()\n\
:<Key>osfActivate:	PrimitiveParentActivate()\n\
:<Key>osfCancel:	PrimitiveParentCancel()\n\
:<Key>osfHelp:		PrimitiveHelp()\n\
:<Key>osfSelect:	ExmCommandButtonArmAndActivate()\n\
~s ~m ~a <Key>space:	ExmCommandButtonArmAndActivate()\n\
~s ~m ~a <Key>Return:	PrimitiveParentActivate()";

/* Declare the actions array. */
static XtActionsRec actions[] = {
    {"ExmCommandButtonEnter",		ExmCommandButtonEnter},
    {"ExmCommandButtonLeave",		ExmCommandButtonLeave},
    {"ExmCommandButtonArmAndActivate",	ExmCommandButtonArmAndActivate},
    {"ExmCommandButtonArm",		ExmCommandButtonArm},
    {"ExmCommandButtonActivate",	ExmCommandButtonActivate},
    {"ExmCommandButtonDisarm",		ExmCommandButtonDisarm}
};


/* Define the resources for the ExmCommandButton widget.  This widget supports
   one new resource: XmNactivateCallback.   In addition, this widget overrides 
   the default values of two resources in XmPrimitive:
   XmNshadowThickness and XmNtraversalOn. */
static XtResource resources[] = 
{
    {
	XmNshadowThickness,
	XmCShadowThickness,
	XmRHorizontalDimension,
	sizeof (Dimension),
	XtOffsetOf( ExmCommandButtonRec, primitive.shadow_thickness),
	XmRImmediate,
	(XtPointer) 3  
    },
    {
	XmNtraversalOn,
	XmCTraversalOn,
	XmRBoolean,
	sizeof (Boolean),
	XtOffsetOf( ExmCommandButtonRec, primitive.traversal_on),
	XmRImmediate, 
	(XtPointer) True
    },
    {
	XmNactivateCallback,
	XmCCallback,
	XmRCallback,
	sizeof(XtCallbackList),
	XtOffsetOf( ExmCommandButtonRec, command_button.activate_callback),
	XmRPointer, 
        (XtPointer) NULL
    },
};

/* ExmCommandButton does not treat any of its resources 
   as synthetic resources. */


/* Here is the primitive class extension record. */
static XmPrimitiveClassExtRec primClassExtRec = {
    /* next_extension */             NULL,
    /* record_type */                NULLQUARK,
    /* version */                    XmPrimitiveClassExtVersion,
    /* record_size */                sizeof(XmPrimitiveClassExtRec),
    /* widget_baseline */            XmInheritBaselineProc,
    /* widget_display_rect */        XmInheritDisplayRectProc, 
    /* widget_margins */             NULL,
};


/* Define the widget class record.  See Chapter 3 of the
   "OSF/Motif Widget Writer's Guide" for details. */
externaldef (exmcommandbuttonclassrec) ExmCommandButtonClassRec 
exmCommandButtonClassRec = {
  {    
    /* superclass */                 (WidgetClass)&exmStringClassRec,
    /* class_name */                 "ExmCommandButton",
    /* widget_size */                sizeof(ExmCommandButtonRec),
    /* class_initialize */           NULL,
    /* class_part_initialize */      ClassPartInitialize,
    /* class_inited */               FALSE,
    /* initialize */                 Initialize,
    /* initialize_hook */            NULL,
    /* realize */                    XtInheritRealize,
    /* actions */                    actions,
    /* num_actions */                XtNumber(actions),
    /* resources */                  resources,
    /* num_resources */              XtNumber(resources),
    /* xrm_class */                  NULLQUARK,
    /* compress_motion */            TRUE,
    /* compress_exposure */          XtExposeCompressMaximal,
    /* compress_enterleave */        TRUE,
    /* visible_interest */           FALSE,
    /* destroy */                    Destroy,
    /* resize */                     XtInheritResize,
    /* expose */                     XtInheritExpose,
    /* set_values */                 SetValues,
    /* set_values_hook */            NULL,
    /* set_values_almost */          XtInheritSetValuesAlmost,
    /* get_values_hook */            NULL,
    /* accept_focus */               NULL,
    /* version */                    XtVersion,
    /* callback_private */           NULL,
    /* tm_table */                   defaultTranslations,
    /* query_geometry */             XtInheritQueryGeometry,
    /* display_accelerator */        NULL,
    /* extension */                  NULL,
  },    
  { /* XmPrimitive */
    /* border_highlight */           XmInheritBorderHighlight,
    /* border_unhighlight */         XmInheritBorderUnhighlight,
    /* translations */               XtInheritTranslations,
    /* arm_and_activate */           ExmCommandButtonArmAndActivate,
    /* syn_resources */              NULL,
    /* num_syn_resources */          0,
    /* extension */                  (XtPointer)&primClassExtRec, 
  },    
  { /* ExmSimple */ 
    /* draw_visual */                ExmInheritDrawVisual,
    /* draw_shadow */                DrawShadow,
    /* create_gc */                  ExmInheritCreateGC,
    /* destroy_gc */                 ExmInheritDestroyGC,
    /* select_gc */                  ExmInheritSelectGC,
    /* calc_visual_size */           ExmInheritCalcVisualSize,
    /* calc_widget_size */           ExmInheritCalcWidgetSize,
    /* reconfigure */                ExmInheritReconfigure,
    /* extension */                  NULL,
  },    
  { /* ExmString */ 
    /* default_render_table_type */  XmBUTTON_RENDER_TABLE,
    /* extension */                  NULL,
  },    
  { /* ExmCommandButton */ 
    /* extension */                  NULL,
  },    
};    

/* Establish the widget class name as an externally accessible symbol.
   Use the "externaldef" macro rather than the "extern" keyword. */
externaldef( exmcommandbuttonwidgetclass) WidgetClass
	exmCommandButtonWidgetClass = (WidgetClass) &exmCommandButtonClassRec;

/* Declare an Activatable Trait record variable. */
static XmConst XmActivatableTraitRec commandButtonAT = {
  0,            /* version */
  ChangeCB,
};

/* Declare a Takes Default record variable. */
static XmConst XmTakesDefaultTraitRec  commandButtonTDT = {
  0,            /* version */
  ShowAsDefault,
};

/*******************************************************************************
 *
 * Initialize:
 *     Called by the Intrinsics when this widget is instantiated.
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
Initialize (request_w, new_w, args, num_args)
        Widget request_w;
        Widget new_w;
        ArgList args;
        Cardinal *num_args;
#else
Initialize (
        Widget request_w,
        Widget new_w,
        ArgList args,
        Cardinal *num_args
           )
#endif
{
 ExmCommandButtonWidgetClass wc =(ExmCommandButtonWidgetClass)XtClass(new_w);
 ExmCommandButtonWidget nw = (ExmCommandButtonWidget) new_w;

 /* Initialize the three private fields of the ExmCommandButton widget. */
   nw->command_button.armed = False;
   nw->command_button.visual_armed = False;
   nw->command_button.visual_timer = 0;

 /* Reconfigure if necessary. 
    (This Reconfigure method is defined in the ExmSimple widget.) */
   if (wc->simple_class.reconfigure)
     (*(wc->simple_class.reconfigure))(exmCommandButtonWidgetClass, 
                                       new_w, NULL);
}


/************************************************************************
 *
 *  ClassPartInitialize
 *      Called by the Intrinsics when this widget or a subclass of this
 *      widget is instantiated.  
 *
 ************************************************************************/
static void 
#ifdef _NO_PROTO
ClassPartInitialize( widgetclass )
        WidgetClass widgetclass ;
#else
ClassPartInitialize(
        WidgetClass widgetclass )
#endif 
{
 /* Install the XmQTactivatable trait on CommandButton and its subclasses. */
   XmeTraitSet((XtPointer) widgetclass, XmQTactivatable, 
               (XtPointer) &commandButtonAT);

 /* Install the XmQTtakesDefault trait on CommandButton and its subclasses. */
   XmeTraitSet((XtPointer) widgetclass, XmQTtakesDefault, 
               (XtPointer) &commandButtonTDT);
}


/*******************************************************************************
 *
 *  Destroy:
 *      Called by the Intrinsics when this widget is deallocated. 
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
Destroy (w)
        Widget w;
#else
Destroy (
        Widget w
        )
#endif
{
 ExmCommandButtonWidget cw = (ExmCommandButtonWidget)w;

 /* If the widget is deallocated during the middle of a time out, remove
    the time out.  (In other words, if we didn't do this, then we could
    only deallocate the widget after any time outs had expired. */ 
   if (cw->command_button.visual_timer != 0)
     XtRemoveTimeOut (cw->command_button.visual_timer);
}



/*******************************************************************************
 *
 *  SetValues:
 *      Called by the Intrinsics in response to a change in a resource value. 
 *
 ******************************************************************************/
static Boolean 
#ifdef _NO_PROTO
SetValues (old_w, request_w, new_w, args, num_args)
        Widget old_w;
        Widget request_w;
        Widget new_w;
        ArgList args;
        Cardinal *num_args;
#else
SetValues (
        Widget old_w,
        Widget request_w,
        Widget new_w,
        ArgList args,
        Cardinal *num_args
          )
#endif
{
 ExmCommandButtonWidgetClass wc =(ExmCommandButtonWidgetClass)XtClass(new_w);
 ExmCommandButtonWidget nw = (ExmCommandButtonWidget)new_w;
 Boolean redisplayFlag = False;

 /* If the simple.reconfigure flag changes, trigger a redisplay. */ 
   if (nw->simple.need_to_reconfigure == True) {
     if (wc->simple_class.reconfigure)
       (*(wc->simple_class.reconfigure))(exmCommandButtonWidgetClass,
                                         new_w, old_w);
     redisplayFlag = True;
   }

   return (redisplayFlag);
}



/*******************************************************************************
 *
 *  DrawShadow:
 *      Called by the ExmCommandButtonEnter, ExmCommandButtonLeave, 
 *      ExmCommandButtonArmAndActivate, ExmCommandButtonArm, 
 *      ExmCommandButtonDisarm, and VisualDisarm methods. 
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
DrawShadow (w)
        Widget w;
#else
DrawShadow (
        Widget w
           )
#endif
{
 ExmCommandButtonWidget cw = (ExmCommandButtonWidget)w;
 unsigned int  shadow_type;

 /* This routine draws the "inner shadow" of the widget.  Unlike the other
    subclasses of \*LExmSimple\*O, the \*LExmCommandButton\*O draws two
    shadows.  One shadow, the one drawn by this routine, is always displayed.
    The other shadow is only displayed when the widget is the default button.

    The inner shadow is drawn inside the margins.  In other words, the inner
    shadow will hug the text it encloses.  The outer shadow is drawn by the
    ShowAsDefault trait method. */
   if (cw->core.width > 2 * cw->primitive.highlight_thickness &&
       cw->core.height > 2 * cw->primitive.highlight_thickness &&
       cw->primitive.shadow_thickness > 0) {
     XmeDrawShadows (XtDisplay (cw), XtWindow (cw),
   	             cw->primitive.top_shadow_GC,
   	             cw->primitive.bottom_shadow_GC,
   	             cw->primitive.highlight_thickness + 
                       cw->simple.margin_width,
   	             cw->primitive.highlight_thickness +
                       cw->simple.margin_height,
   	             cw->core.width - (2 * cw->primitive.highlight_thickness)
                       - (2 * cw->simple.margin_width),
   	             cw->core.height - (2 * cw->primitive.highlight_thickness)
                       - (2 * cw->simple.margin_height),
   	             cw->primitive.shadow_thickness,
                     cw->command_button.visual_armed ? XmSHADOW_ETCHED_IN :
                                                       XmSHADOW_ETCHED_OUT); 
   }

}



/*******************************************************************************
 *
 * ExmCommandButtonEnter:
 *     Called by the Intrinsics whenever the cursor enters a window.  
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
ExmCommandButtonEnter (w, event, params, num_params)
        Widget w;
        XEvent *event;
        String *params;
        Cardinal *num_params;
#else
ExmCommandButtonEnter (
        Widget w,
        XEvent *event,
        String *params,
        Cardinal *num_params
            )
#endif
{
 ExmCommandButtonWidgetClass wc = (ExmCommandButtonWidgetClass)XtClass(w);
 ExmCommandButtonWidget cw = (ExmCommandButtonWidget)w;

   if (cw->command_button.armed == True) {
     /* In order for this code to be executed, the user had to have just 
        performed the following steps:
           1. moved the cursor into the widget window.
           2. armed the widget.
           3. moved the cursor out of the widget window.
           4. moved the cursor back into the widget window.  */
     cw->command_button.visual_armed = True;

     if (wc->simple_class.draw_shadow) 
       (*(wc->simple_class.draw_shadow)) (w);
   }

 /* Call the PrimitiveEnter function defined by the XmPrimitive widget. */
   XtCallActionProc (w, "PrimitiveEnter", event, params, *num_params);
}



/*******************************************************************************
 *
 * ExmCommandButtonLeave:
 *     Called by the Intrinsics whenever the cursor leaves the widget's window. 
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
ExmCommandButtonLeave (w, event, params, num_params)
        Widget w;
        XEvent *event;
        String *params;
        Cardinal *num_params;
#else
ExmCommandButtonLeave (
        Widget w,
        XEvent *event,
        String *params,
        Cardinal *num_params
            )
#endif
{
 ExmCommandButtonWidgetClass wc = (ExmCommandButtonWidgetClass)XtClass(w);
 ExmCommandButtonWidget cw = (ExmCommandButtonWidget)w;

   if (cw->command_button.armed == True) {
     /* In order for this code to be executed, the user had to have:
           1. moved the cursor into the widget window.
           2. armed the widget.
           3. moved the cursor out of the widget window. */
     cw->command_button.visual_armed = False;

     if (wc->simple_class.draw_shadow) 
       (*(wc->simple_class.draw_shadow)) (w);
   }

   XtCallActionProc (w, "PrimitiveLeave", event, params, *num_params);
}



/*******************************************************************************
 *
 * ExmCommandButtonArmAndActivate:
 *    Called by the Intrinsics whenever the user presses <Key>osfSelect or
 *    <Key>space.
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
ExmCommandButtonArmAndActivate (w, event, params, num_params)
        Widget w;
        XEvent *event;
        String *params;
        Cardinal *num_params;
#else
ExmCommandButtonArmAndActivate (
        Widget w,
        XEvent *event,
        String *params,
        Cardinal *num_params
               )
#endif

{
 ExmCommandButtonWidgetClass wc = (ExmCommandButtonWidgetClass)XtClass(w);
 ExmCommandButtonWidget cw = (ExmCommandButtonWidget)w;
 XmAnyCallbackStruct cb;

 /* Call DrawShadow. */ 
   cw->command_button.visual_armed = True;
   if (wc->simple_class.draw_shadow) 
     (*(wc->simple_class.draw_shadow)) (w);

 /* Eliminate any data waiting in the X Window's output buffer. */
   XFlush (XtDisplay (cw));

 /* Assuming that the XmNactivateCallback resource is set to True, call the 
    callback routine. */
   if (cw->command_button.activate_callback) {
     cb.reason = XmCR_ACTIVATE;
     cb.event = event;
     XtCallCallbackList ((Widget)cw, cw->command_button.activate_callback, &cb);
   }

 /* Provide a short delay prior to the appearance of any new windows created 
    by the callback.  The net effect is that the ExmCommandButton will appear
    to flash on and off immediately prior to the appearance of any window that
    may overwrite it. */ 
   if ((cw->core.being_destroyed == False) &&
       (cw->command_button.visual_timer == 0))
     cw->command_button.visual_timer = 
           XtAppAddTimeOut(XtWidgetToApplicationContext((Widget)cw),
   			   (unsigned long) VISUAL_DELAY,
   			   VisualDisarm,
   			   (XtPointer)(cw)); /* pass this arg to VisualDisarm */
}



/*******************************************************************************
 *
 * ExmCommandButtonArm:
 *     Called by the Intrinsics in response to a <Btn1Down> event.
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
ExmCommandButtonArm (w, event, params, num_params)
        Widget w;
        XEvent *event;
        String *params;
        Cardinal *num_params;
#else
ExmCommandButtonArm (
        Widget w,
        XEvent *event,
        String *params,
        Cardinal *num_params
    )
#endif
{
 ExmCommandButtonWidgetClass wc = (ExmCommandButtonWidgetClass)XtClass(w);
 ExmCommandButtonWidget cw = (ExmCommandButtonWidget)w;
 
 /* Make this ExmCommandButton widget the current widget.  (Highlight its
    border, if appropriate. */
   XmProcessTraversal (w, XmTRAVERSE_CURRENT);

 /* Redraw the shadow to indicate arming. */
   cw->command_button.armed = True;
   cw->command_button.visual_armed = True;
   if (wc->simple_class.draw_shadow) 
     (*(wc->simple_class.draw_shadow))(w);
}



/*******************************************************************************
 *
 * ExmCommandButtonActivate:
 *     Called by the Intrinsics in response to a <Btn1Up> event.
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
ExmCommandButtonActivate (w, event, params, num_params)
        Widget w;
        XEvent *event;
        String *params;
        Cardinal *num_params;
#else
ExmCommandButtonActivate (
        Widget w,
        XEvent *event,
        String *params,
        Cardinal *num_params
                     )
#endif
{
 ExmCommandButtonWidget cw = (ExmCommandButtonWidget)w;
 XmAnyCallbackStruct cb;

 if (cw->command_button.activate_callback) {
     cb.reason = XmCR_ACTIVATE;
     cb.event = event;
     XFlush (XtDisplay(cw));
     XtCallCallbackList (w, cw->command_button.activate_callback, &cb);
 }
}



/*******************************************************************************
 *
 * ExmCommandButtonDisarm:
 *    Called by the Intrinsics after every call to the Activate method. 
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
ExmCommandButtonDisarm (w, event, params, num_params)
        Widget w;
        XEvent *event;
        String *params;
        Cardinal *num_params;
#else
ExmCommandButtonDisarm (
        Widget w,
        XEvent *event,
        String *params,
        Cardinal *num_params
       )
#endif
{
 ExmCommandButtonWidgetClass cbwc = (ExmCommandButtonWidgetClass)XtClass(w);
 ExmCommandButtonWidget cbw = (ExmCommandButtonWidget)w;

 /* Change the appearance of the shadow to indicate that the widget is no
    longer armed. */ 
   cbw->command_button.armed = False;
   cbw->command_button.visual_armed = False;

   if (cbwc->simple_class.draw_shadow) 
     (*(cbwc->simple_class.draw_shadow)) (w);
}


/*******************************************************************************
 *
 * VisualDisarm:
 *     Called by ExmCommandButtonArmAndActivate. 
 *
 ******************************************************************************/
static void  
#ifdef _NO_PROTO
VisualDisarm (client_data, id)
        XtPointer client_data;
        XtIntervalId *id;
#else
VisualDisarm (
        XtPointer client_data,
        XtIntervalId *id
             )
#endif
{
 ExmCommandButtonWidget cw = (ExmCommandButtonWidget)client_data;
 ExmCommandButtonWidgetClass wc = (ExmCommandButtonWidgetClass)XtClass(cw);
 
 /* Change back the shadow appearance at the end of the timeout period. */ 
   cw->command_button.visual_timer = 0;
   cw->command_button.visual_armed = False;

   if (XtIsRealized ((Widget)cw) && XtIsManaged ((Widget)cw))
     if (wc->simple_class.draw_shadow)
       (*(wc->simple_class.draw_shadow)) ((Widget)cw);

   XFlush (XtDisplay (cw));
}


/************************************************************************
 *
 *  Trait methods --------
 *      
 ************************************************************************/

/************************************************************************
 *
 *  ChangeCB:
 *       Called by a parent widget of ExmCommandButton to update the
 *       callback list. 
 *      
 ************************************************************************/
static void 
#ifdef _NO_PROTO
ChangeCB(w, activCB, closure, setunset)
         Widget w; 
	 XtCallbackProc activCB;
         XtPointer closure;
         Boolean setunset;
#else
ChangeCB(
	 Widget w, 
	 XtCallbackProc activCB,
	 XtPointer closure,
	 Boolean setunset)
#endif /* _NO_PROTO */
{
   if (setunset)   /* Add to the callback list. */
     XtAddCallback (w, XmNactivateCallback, activCB, closure);
   else            /* Remove from the callback list. */
     XtRemoveCallback (w, XmNactivateCallback, activCB, closure);
}


/************************************************************************
 *
 *  ShowAsDefault
 *	set up the default visual
 *      
 ************************************************************************/
static void 
#ifdef _NO_PROTO
ShowAsDefault(w, state)
         Widget w; 
	 XtEnum state;
#else
ShowAsDefault(Widget w, 
	      XtEnum state)
#endif /* _NO_PROTO */
{
 ExmCommandButtonWidgetClass cbwc = (ExmCommandButtonWidgetClass)XtClass(w);
 ExmCommandButtonWidget cbw = (ExmCommandButtonWidget)w;
 Position   start_x_of_outer_shadow,  start_y_of_outer_shadow; 
 Dimension  margin_push_out;
 Dimension  width_of_outer_shadow, height_of_outer_shadow; 
 int   dx, dy, width, height;
 GC    top_GC, bottom_GC;
 Dimension outer_shadow_thickness;
 int       outer_shadow_type;
 int       margins_were_pushed_out=0;
#define MARGIN_BETWEEN_HIGHLIGHT_AND_OUTER_SHADOW 2
 

   start_x_of_outer_shadow = cbw->primitive.highlight_thickness +
                               MARGIN_BETWEEN_HIGHLIGHT_AND_OUTER_SHADOW;
   start_y_of_outer_shadow = cbw->primitive.highlight_thickness +
                               MARGIN_BETWEEN_HIGHLIGHT_AND_OUTER_SHADOW;
   width_of_outer_shadow   = cbw->core.width - (2 * start_x_of_outer_shadow);
   height_of_outer_shadow  = cbw->core.height - (2 * start_y_of_outer_shadow);
   outer_shadow_thickness  = 3;

   switch (state) {
     case XmDEFAULT_READY:
         /* Push out the margins to make room for subsequent increases in the 
            shadow thickness.  The request to push out the margins will increase
            the size of the CommandButton widget assuming that its manager has
            the space to spare. */ 
          
          if (cbw->primitive.shadow_thickness < 5)
            margin_push_out = 5;
          else
            margin_push_out = cbw->primitive.shadow_thickness; 
          margins_were_pushed_out = 1;
          XtVaSetValues((Widget)cbw, 
                   XmNmarginWidth,  cbw->simple.margin_width + margin_push_out, 
                   XmNmarginHeight, cbw->simple.margin_height + margin_push_out, 
                   NULL); 
	  break ;
     case XmDEFAULT_ON :
         /* Draw an outer shadow.  The outer shadow is drawn outside the
            widget's margins but inside the border highlight. 
            The inner shadow is drawn by the DrawShadow method. */ 
          top_GC = cbw->primitive.top_shadow_GC;
          bottom_GC = cbw->primitive.bottom_shadow_GC;
          outer_shadow_type = cbw->command_button.visual_armed ? 
                                                    XmSHADOW_ETCHED_IN :
                                                    XmSHADOW_ETCHED_OUT; 
          XmeDrawShadows(XtDisplay(w), XtWindow(w),
                         top_GC, 
                         bottom_GC,
                         start_x_of_outer_shadow,
                         start_y_of_outer_shadow,
                         width_of_outer_shadow,
                         height_of_outer_shadow,
                         outer_shadow_thickness, 
                         outer_shadow_type);
	  break ;
     case XmDEFAULT_OFF :
        /* Erase the outer shadow when the widget is no longer the default. */
          XmeClearBorder(XtDisplay(w), XtWindow(w),
                         start_x_of_outer_shadow,
                         start_y_of_outer_shadow,
                         width_of_outer_shadow,
                         height_of_outer_shadow,
                         outer_shadow_thickness);
	  break ;
     case XmDEFAULT_FORGET :
     default :
        /* The widget is not a potential default button.  If XmDEFAULT_FORGET
           is called at some point after XmDEFAULT_READY was called, then
           we have to restore the margins back to their original size. */
          if (margins_were_pushed_out)
            XtVaSetValues((Widget)cbw, 
                     XmNmarginWidth,  cbw->simple.margin_width - margin_push_out,
                     XmNmarginHeight, cbw->simple.margin_height - margin_push_out,
                     NULL); 
	  break ;
    }
}
	


/************************************************************************
 *
 *		Application Accessible External Functions
 *
 ************************************************************************/

/*******************************************************************************
 *
 *  ExmCreateCommandButton:
 *      Called by an application.
 *
 ******************************************************************************/
Widget 
#ifdef _NO_PROTO
ExmCreateCommandButton (parent, name, arglist, argCount)
        Widget parent;
        char *name;
        Arg *arglist;
        Cardinal argCount;
#else
ExmCreateCommandButton (
        Widget parent,
        char *name,
        Arg *arglist,
        Cardinal argCount
                       )
#endif

{
 /* Convenience function to instantiate an ExmCommandButton widget. */
   return (XtCreateWidget(name,exmCommandButtonWidgetClass,
                          parent,arglist,argCount));
}

