/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: CommandB.h,v $
 * Revision 1.1.2.1  1994/06/02  15:32:49  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:10  marty]
 *
 * Revision 1.1.4.1  1994/03/25  18:55:57  rosenberg
 * 	Added API _NO_PROTOs for CR 8387
 * 	[1994/03/25  18:21:48  rosenberg]
 * 
 * Revision 1.1.2.1  1993/10/05  21:00:32  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:00:29  yak]
 * 
 * Revision 1.1.2.5  1993/07/21  20:42:47  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:19:09  yak]
 * 
 * Revision 1.1.2.4  1993/06/30  21:18:20  rosenberg
 * 	Changed #include to <Exm/ etc...
 * 	[1993/06/11  21:50:12  rosenberg]
 * 
 * Revision 1.1.2.3  1993/05/26  21:41:04  rosenberg
 * 	Added comments.
 * 	[1993/05/26  18:14:41  rosenberg]
 * 
 * Revision 1.1.2.2  1993/02/26  21:06:39  al
 * 	Initial version
 * 	[1993/02/26  20:51:37  al]
 * 
 * $EndLog$
 */

/*******************************************************************************
 *
 * CommandB.h: The widget public header file for the ExmCommandButton 
 *             demonstration widget.
 *
 ******************************************************************************/


/* Ensure that the file be included only once. */
#ifndef _ExmCommandB_h
#define _ExmCommandB_h


/* Include appropriate files. */
#include <Exm/String.h>  /* public header file for the ExmString widget */


/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif


/* Define the widget class and widget record. */
externalref WidgetClass exmCommandButtonWidgetClass;

typedef struct _ExmCommandButtonClassRec *ExmCommandButtonWidgetClass;
typedef struct _ExmCommandButtonRec *ExmCommandButtonWidget;



/* Define an IsSubclass macro. */
#ifndef ExmIsCommandButton
#define ExmIsCommandButton(w) XtIsSubclass(w, exmCommandButtonWidgetClass)
#endif


/* Specify the API for this widget. */
#ifdef _NO_PROTO
extern Widget ExmCreateCommandButton();
#else
extern Widget ExmCreateCommandButton(Widget    parent,
                                     char     *name,
                                     Arg      *arglist,
                                     Cardinal  argCount);
#endif /* _NO_PROTO */


/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

/* Ensure that the file be included only once. */
#endif /* _ExmCommandB_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
