/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: ExmMrm.c,v $
 * Revision 1.1.2.1  1994/06/02  15:32:52  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:53:59  marty]
 *
 * Revision 1.1.2.1  1993/10/05  21:00:37  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:00:38  yak]
 * 
 * Revision 1.1.2.5  1993/07/21  20:42:54  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:19:33  yak]
 * 
 * Revision 1.1.2.4  1993/07/08  21:36:14  rom
 * 	Register ExmStringTransfer class.
 * 	[1993/07/08  21:24:43  rom]
 * 
 * Revision 1.1.2.3  1993/05/21  20:03:12  rosenberg
 * 	Added descriptions of ExmTabButton and ExmPanner widgets.
 * 	[1993/05/21  20:02:44  rosenberg]
 * 
 * Revision 1.1.2.2  1993/02/26  21:05:34  al
 * 	Initial version
 * 	[1993/02/26  20:59:41  al]
 * 
 * $EndLog$
 */

#include <stdio.h>
#include <Xm/Xm.h>
#include <Mrm/MrmPublic.h>

#include <Exm/Simple.h>
#include <Exm/String.h>
#include <Exm/StringTrans.h>
#include <Exm/CommandB.h>
#include <Exm/MenuB.h>
#include <Exm/Grid.h>
#include <Exm/TabB.h>
#include <Exm/Panner.h>

/**********************************************************************
 *
 * ExmMrmInitialize - register Exm widget classes with Mrm
 *
 *********************************************************************/

int ExmMrmInitialize()
{
    MrmRegisterClass (MrmwcUnknown, "ExmSimple",
			"ExmCreateSimple", ExmCreateSimple,
			exmSimpleWidgetClass);
    MrmRegisterClass (MrmwcUnknown, "ExmString",
			"ExmCreateString", ExmCreateString,
			exmStringWidgetClass);
    MrmRegisterClass (MrmwcUnknown, "ExmStringTransfer",
			"ExmCreateStringTransfer", ExmCreateStringTransfer,
			exmStringTransferWidgetClass);
    MrmRegisterClass (MrmwcUnknown, "ExmGrid",
			"ExmCreateGrid", ExmCreateGrid,
			exmGridWidgetClass);
    MrmRegisterClass (MrmwcUnknown, "ExmCommandButton",
			"ExmCreateCommandButton", ExmCreateCommandButton,
			exmCommandButtonWidgetClass);
    MrmRegisterClass (MrmwcUnknown, "ExmMenuButton",
			"ExmCreateMenuButton", ExmCreateMenuButton,
			exmMenuButtonWidgetClass);
    MrmRegisterClass (MrmwcUnknown, "ExmTabButton",
			"ExmCreateTabButton", ExmCreateTabButton,
			exmTabButtonWidgetClass);
    MrmRegisterClass (MrmwcUnknown, "ExmPanner",
			"ExmCreatePanner", ExmCreatePanner,
			exmPannerWidgetClass);
    return (0);
}

