/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: Grid.h,v $
 * Revision 1.1.2.1  1994/06/02  15:32:56  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:12  marty]
 *
 * Revision 1.1.4.2  1994/03/25  18:56:11  rosenberg
 * 	Added API _NO_PROTOs for CR 8387
 * 	[1994/03/25  18:21:56  rosenberg]
 * 
 * Revision 1.1.4.1  1994/03/15  16:52:12  rosenberg
 * 	Created ExmCreateGridDialog function for CR 8270.
 * 	[1994/03/15  16:51:41  rosenberg]
 * 
 * Revision 1.1.2.1  1993/10/05  21:00:41  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:00:44  yak]
 * 
 * Revision 1.1.2.4  1993/07/21  20:43:01  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:19:51  yak]
 * 
 * Revision 1.1.2.3  1993/05/26  21:50:12  rosenberg
 * 	Added comments.
 * 	[1993/05/26  18:13:52  rosenberg]
 * 
 * Revision 1.1.2.2  1993/02/26  21:07:12  al
 * 	Initial version
 * 	[1993/02/26  20:52:00  al]
 * 
 * $EndLog$
 */


/*******************************************************************************
 *
 * Grid.h: The widget public header file for the ExmGrid demonstration
 *         widget.
 *
 ******************************************************************************/


/* Ensure that the file be included only once. */
#ifndef _ExmGrid_h
#define _ExmGrid_h


/* Include appropriate files. */
#include <Xm/Xm.h> /* widget public header file for XmManager */


/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif


/* Define the widget class and widget record. */
externalref WidgetClass exmGridWidgetClass;

typedef struct _ExmGridClassRec * ExmGridWidgetClass;
typedef struct _ExmGridRec      * ExmGridWidget;


/* Define an IsSubclass macro. */
#ifndef ExmIsGrid
#define ExmIsGrid(w) XtIsSubclass(w, exmGridWidgetClass)
#endif


/* Define string equivalents of new resource names. */
#define ExmNgridMarginWidthWithinCell "gridMarginWidthWithinCell"
#define ExmNgridMarginHeightWithinCell "gridMarginHeightWithinCell"

#define ExmCGridMarginWidthWithinCell  "GridMarginWidthWithinCell"
#define ExmCGridMarginHeightWithinCell "GridMarginHeightWithinCell"


/* Specify the API for this widget. */
#ifdef _NO_PROTO
extern Widget ExmCreateGrid();
extern Widget ExmCreateGridDialog();
#else
extern Widget ExmCreateGrid(
			Widget parent,
			char   *name,
			ArgList arglist,
			Cardinal argcount);
extern Widget ExmCreateGridDialog(
			Widget parent,
			char   *name,
			ArgList arglist,
			Cardinal argcount);
#endif

/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


/* Ensure that the file be included only once. */
#endif /* _ExmGrid_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */

