/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: MenuB.h,v $
 * Revision 1.1.2.1  1994/06/02  15:33:02  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:14  marty]
 *
 * Revision 1.1.4.1  1994/03/25  18:56:13  rosenberg
 * 	Added API _NO_PROTOs for CR 8387
 * 	[1994/03/25  18:22:00  rosenberg]
 * 
 * Revision 1.1.2.1  1993/10/05  21:00:47  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:00:50  yak]
 * 
 * Revision 1.1.2.4  1993/07/21  20:43:08  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:20:14  yak]
 * 
 * Revision 1.1.2.3  1993/06/11  21:56:29  rosenberg
 * 	Added <Exm/ prefix to #include directives.
 * 	[1993/06/11  21:56:07  rosenberg]
 * 
 * Revision 1.1.2.2  1993/02/26  21:07:25  al
 * 	Initial version
 * 	[1993/02/26  20:52:15  al]
 * 
 * $EndLog$
 */

/* Ensure that the file be included only once. */
#ifndef _ExmMenuB_h
#define _ExmMenuB_h


/* Include appropriate files. */
#include <Exm/String.h> /* public header file for immediate superclass */


/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif

/* Define the widget class and widget record. */
externalref WidgetClass exmMenuButtonWidgetClass;

typedef struct _ExmMenuButtonClassRec *ExmMenuButtonWidgetClass;
typedef struct _ExmMenuButtonRec *ExmMenuButtonWidget;


/* Define an IsSubclass macro. */
#ifndef ExmIsMenuButton
#define ExmIsMenuButton(w) XtIsSubclass(w, exmMenuButtonWidgetClass)
#endif

/* Define string equivalents of new resource names. */
      /* None. */


/* Specify the API for this widget. */
#ifdef _NO_PROTO
extern Widget ExmCreateMenuButton();
#else
extern Widget ExmCreateMenuButton(Widget    parent,
                                  char     *name,
                                  Arg      *arglist,
                                  Cardinal  argCount);
#endif /* _NO_PROTO */


/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _ExmMenuB_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
