/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: MenuBP.h,v $
 * Revision 1.1.2.1  1994/06/02  15:33:03  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:14  marty]
 *
 * Revision 1.1.4.2  1994/03/26  18:23:17  daniel
 * 	add resolve part Index
 * 	[1994/03/26  18:22:06  daniel]
 * 
 * Revision 1.1.4.1  1994/03/15  21:59:40  drand
 * 	Add mnemonic and accelerator support
 * 	[1994/03/15  21:59:24  drand]
 * 
 * Revision 1.1.2.1  1993/10/05  21:00:48  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:00:51  yak]
 * 
 * Revision 1.1.2.5  1993/07/21  20:43:10  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:20:19  yak]
 * 
 * Revision 1.1.2.4  1993/06/16  18:06:21  drand
 * 	Added new field for skipping callback on Activate (menu EntryCallback
 * 	support).
 * 	[1993/06/16  18:05:42  drand]
 * 
 * Revision 1.1.2.3  1993/06/11  21:54:01  rosenberg
 * 	Added Exm/ prefix to #include directives.
 * 	[1993/06/11  21:53:43  rosenberg]
 * 
 * Revision 1.1.2.2  1993/02/26  21:07:33  al
 * 	Initial version
 * 	[1993/02/26  20:52:19  al]
 * 
 * $EndLog$
 */

#ifndef _ExmMenuBP_h
#define _ExmMenuBP_h

#include <Exm/MenuB.h>
#include <Exm/StringP.h>

typedef struct _ExmMenuButtonClassPart
{
	XtPointer		extension;
} ExmMenuButtonClassPart;

typedef struct _ExmMenuButtonClassRec
{
	CoreClassPart        	core_class;
	XmPrimitiveClassPart	primitive_class;
	ExmSimpleClassPart	simple_class;
	ExmStringClassPart	string_class;
	ExmMenuButtonClassPart	menu_button_class;
} ExmMenuButtonClassRec;

extern ExmMenuButtonClassRec exmMenuButtonClassRec;

typedef struct _ExmMenuButtonPart
{
	XtCallbackList		activate_callback;

	Boolean			armed;
	Boolean			skip_callback;
	XtIntervalId		visual_timer;

	KeySym			mnemonic;
	XmStringCharSet		mnemonic_charset;
	char*			accelerator;
	XmString		accelerator_text;
} ExmMenuButtonPart;


typedef struct _ExmMenuButtonRec
{
	CorePart		core;
	XmPrimitivePart		primitive;
	ExmSimplePart		simple;
	ExmStringPart		string;
	ExmMenuButtonPart	menu_button;
} ExmMenuButtonRec;


/* Define the subclassing level index to be used with ResolvePartOffset */
#define ExmMenuButtonIndex (ExmCommandIndex + 1)

/********    Private Function Declarations    ********/
/********    End Private Function Declarations    ********/


#endif /* _ExmMenuBP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
