/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: Panner.c,v $
 * Revision 1.1.2.1  1994/06/02  15:33:04  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:03  marty]
 *
 * Revision 1.1.4.14  1994/04/14  19:47:37  rosenberg
 * 	Changed warning comment at front of program for CR 8570
 * 	[1994/04/14  15:29:31  rosenberg]
 * 
 * Revision 1.1.4.13  1994/04/08  17:40:14  inca
 * 	Make knob dragging look smoother. Make DRAW_TMP a function,
 * 	DrawRubberBand. Fix bug when rubberband is not erased before drawing
 * 	knob.
 * 	[1994/04/07  17:03:26  inca]
 * 
 * Revision 1.1.4.12  1994/04/06  18:47:58  rosenberg
 * 	Write prototypes.
 * 	[1994/04/06  18:47:21  rosenberg]
 * 
 * Revision 1.1.4.11  1994/04/06  18:37:21  rosenberg
 * 	Added function prototypes
 * 	[1994/04/06  18:22:15  rosenberg]
 * 
 * Revision 1.1.4.10  1994/04/06  16:12:30  rosenberg
 * 	Made slight adjustments in action method names to fit
 * 	drk's ideal naming schemes; added comment headers to
 * 	those action method functions that needed them.
 * 	Prototyping still needed.
 * 	[1994/04/06  16:12:07  rosenberg]
 * 
 * Revision 1.1.4.9  1994/04/05  15:50:33  daniel
 * 	fix build issue on hp
 * 	[1994/04/05  15:49:57  daniel]
 * 
 * Revision 1.1.4.8  1994/04/04  16:20:46  daniel
 * 	fix traversal translation
 * 	[1994/04/04  16:20:30  daniel]
 * 
 * Revision 1.1.4.7  1994/03/29  21:17:08  rosenberg
 * 	Added XmConst support for CR 8416
 * 	[1994/03/29  21:15:49  rosenberg]
 * 
 * Revision 1.1.4.6  1994/03/28  16:27:53  daniel
 * 	more translation work
 * 	[1994/03/28  16:27:30  daniel]
 * 
 * Revision 1.1.4.5  1994/03/26  21:05:12  daniel
 * 	clean up Panner
 * 	[1994/03/26  21:03:45  daniel]
 * 
 * Revision 1.1.4.4  1994/02/26  18:36:13  rosenberg
 * 	Added colons to front of osfMumble translations and changed order of translations; CR 7490
 * 	[1994/02/26  18:35:02  rosenberg]
 * 
 * 	Simple.c
 * 
 * Revision 1.1.4.3  1994/02/03  21:00:17  rosenberg
 * 	Added copyright for CR 7093
 * 	[1994/02/03  20:59:44  rosenberg]
 * 
 * Revision 1.1.4.2  1994/01/26  15:22:18  daniel
 * 	check in new navigator code
 * 	[1994/01/26  15:18:39  daniel]
 * 
 * Revision 1.1.4.1  1994/01/12  19:31:40  rosenberg
 * 	Added M.I.T. copyright, changed comments a little.
 * 	[1994/01/06  22:25:47  rosenberg]
 * 
 * Revision 1.1.2.3  1993/11/15  21:57:47  daniel
 * 	move NO_PROTO forcing before include files
 * 	[1993/11/15  21:57:38  daniel]
 * 
 * Revision 1.1.2.2  1993/11/09  16:01:38  daniel
 * 	work on actions
 * 	[1993/11/09  16:01:17  daniel]
 * 
 * Revision 1.1.2.1  1993/10/05  21:00:49  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:28:20  yak]
 * 
 * Revision 1.1.4.1  1993/10/05  17:24:18  rosenberg
 * 	Formatted resource arrays to be consistent with other Exm widgets.
 * 	[1993/10/05  17:24:02  rosenberg]
 * 
 * Revision 1.1.2.7  1993/07/21  20:43:12  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:20:25  yak]
 * 
 * Revision 1.1.2.6  1993/06/11  22:04:31  rosenberg
 * 	Added <Exm prefix to #include directive.
 * 	[1993/06/11  22:04:17  rosenberg]
 * 
 * Revision 1.1.2.5  1993/05/21  19:07:18  daniel
 * 	more clean up
 * 	[1993/05/21  19:06:30  daniel]
 * 
 * Revision 1.1.2.4  1993/05/20  02:12:33  daniel
 * 	subclass of Simple now
 * 	[1993/05/20  02:10:33  daniel]
 * 
 * Revision 1.1.2.3  1993/05/04  18:36:08  daniel
 * 	more work
 * 	[1993/05/04  18:24:08  daniel]
 * 
 * Revision 1.1.2.2  1993/05/03  20:31:57  daniel
 * 	add ExmPanner
 * 	[1993/05/03  20:31:06  daniel]
 * 
 * $EndLog$
 */

/* The following copyright notice solves CR 7093. */
/*
 *
 * Copyright 1989 Massachusetts Institute of Technology
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of M.I.T. not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  M.I.T. makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * M.I.T. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL M.I.T.
 * BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

/************************************ WARNING **********************************
 *
 * ExmPanner is a demonstration widget.  OSF provides this widget
 * solely to teach programmers how to write their own Motif widgets.
 * OSF does not support this widget in any way
 *
 ************************************ WARNING *********************************/


/*************************************************************************
 * 
 * Panner.c - ExmPanner widget.  This widget lets a user pan a
 *            ScrolledWindow (or any other scrollFrame widget)
 *            in two-dimensions.  The ExmPanner widget is similar 
 *            to the Athena Panner widget.  ExmPanner demonstrates:
 *               * how to install the XmQTnavigator trait.   
 * 
 *********************************************************************/

#include <Xm/XmP.h>
#include <Xm/TraitP.h>
#include <Xm/NavigatorT.h>
#include <Xm/DrawP.h>
#include <Xm/RepType.h>
#include <Exm/PannerP.h>


/* Define macros and constants. */
static XmConst int DEFAULT_WIDTH=100;
static XmConst int DEFAULT_HEIGHT=100;

static XmConst int DEFAULT_CANVAS_WIDTH=100;
static XmConst int DEFAULT_CANVAS_HEIGHT=100;

static XmConst int PANNER_OUTOFRANGE = (-30000);

#define PANNER_HSCALE(pw,val) ((pw)->panner.haspect * ((double) (val)))
#define PANNER_VSCALE(pw,val) ((pw)->panner.vaspect * ((double) (val)))

#ifdef _NO_PROTO
static void ClassPartInitialize() ;
static void Initialize();		
static void Resize();			
static Boolean SetValues();		
static void DrawVisual();		
static void CreateGC();			
static void DestroyGC();
static void DrawRubberBand();			
static void CheckKnob();
static void ScaleKnob();
static Boolean GetEventXY ();
static void ExmPannerStart();
static void ExmPannerStop();
static void ExmPannerAbort();
static void ExmPannerMove();
static int ParsePageString ();
static void ExmPannerPage();
static void ExmPannerNotify();
static void ExmPannerSet();
static void NavigChangeMoveCB() ;
static void NavigSetValue() ;
static void NavigGetValue() ;

#else
static void ClassPartInitialize(
    WidgetClass wc );
static void Initialize(
    Widget greq,
    Widget gnew,
    ArgList args,
    Cardinal *num_args);
static void Resize (
    Widget gw);
static Boolean SetValues(
    Widget gcur,
    Widget greq,
    Widget gnew,
    ArgList args,
    Cardinal *num_args);
static void DrawVisual(
    Widget gw);
static void CreateGC(
    Widget w);
static void DestroyGC(
    Widget w);
static void DrawRubberBand(
    ExmPannerWidget pw);
static void CheckKnob(
    register ExmPannerWidget pw,
    Boolean knob);
static void ScaleKnob (
    ExmPannerWidget pw,
    Boolean location,
    Boolean size);
static void ExmPannerStart (
    Widget gw,
    XEvent *event,
    String *params,
    Cardinal *num_params);
static void ExmPannerStop (
    Widget gw,
    XEvent *event,
    String *params,
    Cardinal *num_params);
static void ExmPannerAbort (
    Widget gw,
    XEvent *event,
    String *params,
    Cardinal *num_params);
static void ExmPannerMove (
    Widget gw,
    XEvent *event,
    String *params,
    Cardinal *num_params);
static void ExmPannerNotify (
    Widget gw,
    XEvent *event,
    String *params,
    Cardinal *num_params);
static void ExmPannerSet (
    Widget gw,
    XEvent *event,
    String *params,
    Cardinal *num_params);
static Boolean GetEventXY (
    ExmPannerWidget pw,
    XEvent *event,
    int *x,
    int *y);
static int ParsePageString (
    register char *s,
    int pagesize,
    int canvassize,
    Boolean *relative);
static void ExmPannerPage (
    Widget gw,
    XEvent *event,
    String *params,
    Cardinal *num_params);
static void NavigChangeMoveCB(
    Widget nav, 
    XtCallbackProc moveCB,
    XtPointer closure,
    Boolean setunset);
static void NavigSetValue(
    Widget nav, 
    XmNavigatorData nav_data,
    Boolean notify);
static void NavigGetValue(
    Widget nav,
    XmNavigatorData nav_data);
#endif


/* Define the translations. */
static char defaultTranslations[] = 
"<Unmap>:			PrimitiveUnmap()\n\
<Enter>:			PrimitiveEnter()\n\
<Leave>:			PrimitiveLeave()\n\
<FocusIn>:			PrimitiveFocusIn()\n\
<FocusOut>:			PrimitiveFocusOut()\n\
:<Key>osfActivate:		PrimitiveParentActivate()\n\
:<Key>osfHelp:	        	PrimitiveHelp()\n\
:<Key>osfCancel:	        ExmPannerAbort()\n\
~s ~c ~m ~a <Btn1Down>:		ExmPannerStart(1) \n\
~s ~c ~m ~a <Btn1Motion>:	ExmPannerMove() \n\
~s ~c ~m ~a <Btn1Up>:		ExmPannerNotify() ExmPannerStop() \n\
~s ~c ~m ~a <Btn2Down>:         ExmPannerStart(2) \n\
~s ~c ~m ~a <Btn2Motion>:    	ExmPannerMove() \n\
~s ~c ~m ~a <Btn2Up>:           ExmPannerNotify() ExmPannerStop() \n\
:<Key>space:         		ExmPannerSet(rubberband,toggle) \n\
:<Key>osfPageUp:     		ExmPannerPage(+0, -1p) \n\
:c <Key>osfPageUp:     		ExmPannerPage(+0, -1c) \n\
:<Key>osfPageDown:   		ExmPannerPage(+0, +1p) \n\
:c <Key>osfPageDown:   		ExmPannerPage(+0, +1c) \n\
:<Key>osfPageLeft:   		ExmPannerPage(-1p, +0) \n\
:c <Key>osfPageLeft:   		ExmPannerPage(-1c, +0) \n\
:<Key>osfPageRight:  		ExmPannerPage(+1p, +0) \n\
:c <Key>osfPageRight:  		ExmPannerPage(+1c, +0) \n\
:<Key>osfLeft:     		ExmPannerPage(-1, +0) \n\
:c <Key>osfLeft:     		ExmPannerPage(-1p, +0) \n\
:<Key>osfRight:    		ExmPannerPage(+1, +0) \n\
:c <Key>osfRight:    		ExmPannerPage(+1p, +0) \n\
:<Key>osfUp:       		ExmPannerPage(+0, -1) \n\
:c <Key>osfUp:       		ExmPannerPage(+0, -1p) \n\
:<Key>osfDown:     		ExmPannerPage(+0, +1) \n\
:c <Key>osfDown:     		ExmPannerPage(+0, +1p) \n\
:<Key>osfEndLine:     		ExmPannerPage(+1c, +1c) \n\
:<Key>osfBeginLine:     	ExmPannerPage(0,0)\n\
~s ~m ~a <Key>Return:   	PrimitiveParentActivate()\n\
s ~m ~a <Key>Tab:	   	PrimitivePrevTabGroup()\n\
~m ~a <Key>Tab:	   		PrimitiveNextTabGroup()";


/* Define the actions array. */
static XtActionsRec actions[] = {
  {"ExmPannerStart", ExmPannerStart},  /* start tmp graphics */
  {"ExmPannerStop",  ExmPannerStop},   /* stop tmp graphics */
  {"ExmPannerAbort", ExmPannerAbort},  /* abort panning */ 
  {"ExmPannerMove",  ExmPannerMove},   /* move tmp graphics on Motion event */
  {"ExmPannerPage",  ExmPannerPage},   /* page around usually from keyboard */
  {"ExmPannerNotify",ExmPannerNotify}, /* callback new position */
  {"ExmPannerSet",   ExmPannerSet}     /* set various parameters */
};


/* Define the resources. */
#define poff(field) XtOffsetOf(ExmPannerRec, panner.field)

static XtResource resources[] = 
{
    { 
	ExmNreportCallback, 
	ExmCReportCallback, 
	XtRCallback, 
	sizeof(XtPointer),
	poff(report_callbacks), 
	XtRCallback, 
	(XtPointer) NULL 
    },
    { 
	ExmNrubberBand, 
	ExmCRubberBand, 
	XtRBoolean, 
	sizeof(Boolean),
	poff(rubber_band), 
	XtRImmediate, 
	(XtPointer) FALSE 
    },
    { 
	ExmNcanvasWidth, 
	ExmCCanvasWidth, 
	XmRHorizontalDimension, 
	sizeof(Dimension),
	poff(canvas_width), 
	XtRImmediate, 
	(XtPointer) 0 
    },
    { 
	ExmNcanvasHeight, 
	ExmCCanvasHeight, 
        XmRVerticalDimension, 
	sizeof(Dimension),
	poff(canvas_height), 
	XtRImmediate, 
	(XtPointer) 0 
    },
    { 
	ExmNsliderX, 
	ExmCSliderX, 
        XmRHorizontalPosition, 
	sizeof(Position),
	poff(slider_x), 
	XtRImmediate, 
	(XtPointer) 0 
    },
    { 
	ExmNsliderY, 
	ExmCSliderY, 
        XmRVerticalPosition, 
	sizeof(Position),
	poff(slider_y), 
	XtRImmediate, 
	(XtPointer) 0 
    },
    { 
	ExmNsliderWidth, 
	ExmCSliderWidth, 
	XmRHorizontalDimension, 
	sizeof(Dimension),
	poff(slider_width), 
	XtRImmediate, 
	(XtPointer) 0 
    },
    { 
	ExmNsliderHeight, 
	ExmCSliderHeight, 
	XmRVerticalDimension, 
	sizeof(Dimension),
	poff(slider_height), 
	XtRImmediate, 
	(XtPointer) 0 
    },
    { 
	XmNnavigationType, 
	XmCNavigationType, 
	XmRNavigationType,
	sizeof(unsigned char),
	XtOffsetOf(ExmPannerRec, primitive.navigation_type),
	XmRImmediate, 
        (XtPointer) XmSTICKY_TAB_GROUP
    },
};


/* 6 of the 8 resources have corresponding synthetic resources. */ 
static XmSyntheticResource syn_resources[] =
{
   {	ExmNcanvasWidth,
	sizeof (Dimension), 
	poff(canvas_width),
	XmeFromHorizontalPixels, 
	XmeToHorizontalPixels 
   },
   { 	ExmNcanvasHeight,
	sizeof (Dimension), 
	poff(canvas_height),
     	XmeFromVerticalPixels, 
	XmeToVerticalPixels 
   },
   {	ExmNsliderX,
	sizeof (Position),
	poff(slider_x), 
	XmeFromHorizontalPixels, 
	XmeToHorizontalPixels 
   },
   {	ExmNsliderY, 
	sizeof (Position), 
	poff(slider_y),
	XmeFromVerticalPixels, 
	XmeToVerticalPixels 
   },
   {	ExmNsliderWidth,
	sizeof (Dimension), 
	poff(slider_width),
	XmeFromHorizontalPixels, 
	XmeToHorizontalPixels 
   },
   {	ExmNsliderHeight,
	sizeof (Dimension), 
	poff(slider_height),
	XmeFromVerticalPixels, 
        XmeToVerticalPixels 
   },
};
#undef poff


/* Define the widget class record. */
externaldef(exmpannerclassrec) ExmPannerClassRec exmPannerClassRec = {
  { /* Following is the Core class record. */ 
    /* superclass		*/	(WidgetClass) &exmSimpleClassRec,
    /* class_name		*/	"ExmPanner",
    /* widget_size		*/	sizeof(ExmPannerRec),
    /* class_initialize		*/	NULL,
    /* class_part_initialize	*/	ClassPartInitialize,
    /* class_inited		*/	FALSE,
    /* initialize		*/	Initialize,
    /* initialize_hook		*/	NULL,
    /* realize			*/	XtInheritRealize,
    /* actions			*/	actions,
    /* num_actions		*/	XtNumber(actions),
    /* resources		*/	resources,
    /* num_resources		*/	XtNumber(resources),
    /* xrm_class		*/	NULLQUARK,
    /* compress_motion		*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest		*/	FALSE,
    /* destroy			*/	NULL,
    /* resize			*/	Resize,
    /* expose			*/	XtInheritExpose,
    /* set_values		*/	SetValues,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus		*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private		*/	NULL,
    /* tm_table			*/	defaultTranslations,
    /* query_geometry		*/	NULL,
    /* display_accelerator	*/	XtInheritDisplayAccelerator,
    /* extension		*/	NULL
  },
  { /* Following is the XmPrimitive class record. */ 
    /* border_highlight */              XmInheritWidgetProc,
    /* border_unhighlight */            XmInheritWidgetProc,
    /* translations */                  NULL,
    /* arm_and_activate */              (XtActionProc)NULL,
    /* syn_resources */                 syn_resources,
    /* num_syn_resources */             XtNumber(syn_resources),
    /* extension */                     NULL,
   },
  { /* Following is the ExmSimple class record. */ 
    /* draw_visual */                   DrawVisual,
    /* draw_shadow */                   NULL,
    /* create_gc */                     CreateGC,
    /* destroy_gc */                    DestroyGC,
    /* select_gc */                     ExmInheritSelectGC,
    /* calc_visual_size */              ExmInheritCalcVisualSize,
    /* calc_widget_size */              ExmInheritCalcWidgetSize,
    /* extension */                     NULL,
  },
  { /* Following is the ExmPanner class record. */
    /* extension */                     NULL
  }
};

externaldef(exmpannerwidgetclass) 
    WidgetClass exmPannerWidgetClass = (WidgetClass) &exmPannerClassRec;



/* Navigator Trait record for Panner */

static XmConst XmNavigatorTraitRec pannerNT = {
  0,         /* version */
  NavigChangeMoveCB,
  NavigSetValue,
  NavigGetValue,
};





/*********************************************************************
 *
 *  ClassPartInitialize
 *     Initialize navigator trait
 *
 *********************************************************************/
static void 
#ifdef _NO_PROTO
ClassPartInitialize( wc )
        WidgetClass wc ;
#else
ClassPartInitialize(
        WidgetClass wc )
#endif /* _NO_PROTO */
{
    /* Install the navigator trait. */
    XmeTraitSet((XtPointer)wc, XmQTnavigator, (XtPointer) &pannerNT);
}





/*********************************************************************
 *
 *  Initialize
 *
 *********************************************************************/
static void 
#ifdef _NO_PROTO
Initialize (greq, gnew, args, num_args)
    Widget greq; 
    Widget gnew;
    ArgList args;
    Cardinal *num_args;
#else
Initialize(
    Widget greq,
    Widget gnew,
    ArgList args,
    Cardinal *num_args)
#endif 
{
 ExmPannerWidget req = (ExmPannerWidget) greq, 
                 new = (ExmPannerWidget) gnew;

    if (req->panner.canvas_width < 1) 
	new->panner.canvas_width = DEFAULT_CANVAS_WIDTH;
    if (req->panner.canvas_height < 1) 
	new->panner.canvas_height = DEFAULT_CANVAS_HEIGHT;

    if (greq->core.width == 0) gnew->core.width = DEFAULT_WIDTH;
    if (greq->core.height == 0) gnew->core.height = DEFAULT_HEIGHT;

    new->panner.tmp.doing = FALSE;
    new->panner.tmp.showing = FALSE;

    /* call the resize method to get an initial size */
    (* (gnew->core.widget_class->core_class.resize)) (gnew);

    /* Simple Initialize already created the GCs */
}



/*********************************************************************
 *
 *  Resize
 *
 *********************************************************************/
static void 
#ifdef _NO_PROTO
Resize (gw)
    Widget gw;
#else
Resize (
    Widget gw)
#endif
{
 ExmPannerWidget pw = (ExmPannerWidget)gw;

    int hpad = pw->simple.margin_width * 2;
    int vpad = pw->simple.margin_height * 2;

    if (pw->panner.canvas_width < 1)
      pw->panner.canvas_width = pw->core.width;
    if (pw->panner.canvas_height < 1)
      pw->panner.canvas_height = pw->core.height;

    if ((int)pw->core.width <= hpad) hpad = 0;
    if ((int)pw->core.height <= vpad) vpad = 0;

    pw->panner.haspect = ((double) pw->core.width - hpad) /
			  (double) pw->panner.canvas_width;
    pw->panner.vaspect = ((double) pw->core.height - vpad) /
			  (double) pw->panner.canvas_height;

    ScaleKnob (pw, TRUE, TRUE);
}

/*********************************************************************
 *
 *  SetValues
 *
 *********************************************************************/
static Boolean 
#ifdef _NO_PROTO
SetValues (gcur, greq, gnew, args, num_args)
    Widget gcur, greq, gnew;
    ArgList args;
    Cardinal *num_args;
#else
SetValues(
    Widget gcur,
    Widget greq,
    Widget gnew,
    ArgList args,
    Cardinal *num_args)
#endif
{
 ExmPannerWidget cur = (ExmPannerWidget) gcur;
 ExmPannerWidget new = (ExmPannerWidget) gnew;
 Boolean redisplay = FALSE;

    if (cur->panner.rubber_band != new->panner.rubber_band) {
	if (new->panner.tmp.doing) redisplay = TRUE;
    }

    if (cur->panner.canvas_width != new->panner.canvas_width ||
	cur->panner.canvas_height != new->panner.canvas_height ||
	cur->simple.margin_width != new->simple.margin_width ||
	cur->simple.margin_height != new->simple.margin_height) {
	Resize (gnew);			/* does a ScaleKnob as well */
	redisplay = TRUE;
    } else {
	Boolean loc = (cur->panner.slider_x != new->panner.slider_x ||
		       cur->panner.slider_y != new->panner.slider_y);
	Boolean siz = (cur->panner.slider_width != 
		       new->panner.slider_width ||
		       cur->panner.slider_height != 
		       new->panner.slider_height);
	if (loc || siz) {
	    ScaleKnob (new, loc, siz);
	    redisplay = TRUE;
	}
    }

    return redisplay;
}



/*********************************************************************
 *
 *  DrawVisual
 *      an ExmSimple class method
 *
 *********************************************************************/
static void 
#ifdef _NO_PROTO
DrawVisual (gw)
    Widget gw;
#else 
DrawVisual(
    Widget gw)
#endif
{
 ExmSimpleWidgetClass wc = (ExmSimpleWidgetClass)XtClass(gw);
 ExmPannerWidget pw = (ExmPannerWidget) gw;
 int kx = pw->panner.knob_x + pw->simple.margin_width;
 int ky = pw->panner.knob_y + pw->simple.margin_height;
 int lx = pw->panner.last_x + pw->simple.margin_width;
 int ly = pw->panner.last_y + pw->simple.margin_height;

    /* Clear rubberband */
    if (pw->panner.tmp.doing && pw->panner.rubber_band && pw->panner.tmp.showing) 
      DrawRubberBand (pw);

    /* Only clear areas that need clearing. This minimizes flickering while
       dragging. */
    if (pw->panner.last_y != PANNER_OUTOFRANGE &&
	pw->panner.last_x != PANNER_OUTOFRANGE) {
      int height = 0;
      /* Clear horizontal areas */
      if (ly < ky) {
	/* Clear area above new panner position */
	height = ky - ly;
	XClearArea (XtDisplay(gw), XtWindow(gw), 
		    lx, ly,
		    (unsigned int) pw->panner.knob_width,
		    (unsigned int) height,
		    False);
      } else if (ky < ly) {
	/* Clear area under new panner */
	height = ly - ky;
	XClearArea (XtDisplay(gw), XtWindow(gw), 
		    lx, ky + pw->panner.knob_height - 1,
		    (unsigned int) pw->panner.knob_width,
		    (unsigned int) height,
		    False);
      }
      /* Clear vertical areas. Try not to clear the same area twice. */
      height = pw->panner.knob_height - height;
      if (height > 0) {
	if (lx < kx) {
	/* Clear area to the left of new panner position */
	  XClearArea (XtDisplay(gw), XtWindow(gw), 
		      lx, ly > ky ? ly : ky,
		      (unsigned int) kx - lx,
		      (unsigned int) height,
		      False);
	} else if (kx < lx) {
	  /* Clear area to the right of new panner */
	  XClearArea (XtDisplay(gw), XtWindow(gw), 
		      kx + pw->panner.knob_width - 1, ly > ky ? ly : ky,
		      (unsigned int) lx - kx,
		      (unsigned int) height,
		      False);
	}
      }
    }

    pw->panner.last_x = pw->panner.knob_x;
    pw->panner.last_y = pw->panner.knob_y;

    /* use Simple class method to fetch either a normal GC or an 
       insensitive GC. Draw a rectangle inside the shadow. */
    XFillRectangle (XtDisplay(gw), XtWindow(gw), 
		    wc->simple_class.select_gc(gw), 
		    kx + pw->primitive.shadow_thickness, 
		    ky + pw->primitive.shadow_thickness,
		    pw->panner.knob_width - 2 * pw->primitive.shadow_thickness - 1, 
		    pw->panner.knob_height - 2 * pw->primitive.shadow_thickness - 1);

    XmeDrawShadows (XtDisplay (gw), XtWindow(gw),
		    pw->primitive.top_shadow_GC,
		    pw->primitive.bottom_shadow_GC, 
		    kx, ky,
		    pw->panner.knob_width - 1, pw->panner.knob_height - 1,
		    pw->primitive.shadow_thickness,
		    XmSHADOW_OUT);

    /* if in the middle of rubber_banding, redisplay it as well */
    if (pw->panner.tmp.doing && pw->panner.rubber_band) 
      DrawRubberBand (pw);
}


/*********************************************************************
 *
 *  CreateGC  
 *      an ExmSimple class method
 *
 *********************************************************************/
static void 
#ifdef _NO_PROTO
CreateGC (w)	
   Widget w;
#else
CreateGC(
   Widget w)
#endif
{
    ExmPannerWidget pw = (ExmPannerWidget) w ;
    XtGCMask valuemask = (GCForeground | GCFunction);
    XGCValues values;
	
    /* Envelop our superclass method to get the normal
       and the insensitive GC and then add our rubber_band GC */
    (*(exmSimpleClassRec.simple_class.create_gc))(w);

    values.foreground = pw->primitive.foreground ^ 
	pw->core.background_pixel;
    values.function = GXxor;
    pw->panner.xor_gc = XtGetGC ((Widget) pw, valuemask, &values);
}


/*********************************************************************
 *
 *  DestroyGC  
 *      an ExmSimple class method
 *
 *********************************************************************/
static void 
#ifdef _NO_PROTO
DestroyGC(w)	
   Widget w;
#else
DestroyGC(
   Widget w)
#endif
{
 ExmPannerWidget pw = (ExmPannerWidget) w ;

  /* Envelop our superclass method to destroy the normal
     and the insensitive GC, and then release our Xor GC */
    (*(exmSimpleClassRec.simple_class.destroy_gc))(w);

    XtReleaseGC ((Widget) pw, pw->panner.xor_gc);
}


/*********************************************************************
 *
 *  DrawRubberBand
 *      Draw the rubberband rectangle when rubberband dragging is used.
 *
 *********************************************************************/

static void 
#ifdef _NO_PROTO
DrawRubberBand(pw)
    ExmPannerWidget pw;
#else
DrawRubberBand(
    ExmPannerWidget pw)
#endif
{ 
  XDrawRectangle (XtDisplay(pw), XtWindow(pw), 
		  pw->panner.xor_gc, 
		  (int) (pw->panner.tmp.x - 1 + pw->simple.margin_width), 
		  (int) (pw->panner.tmp.y - 1 + pw->simple.margin_height), 
		  (unsigned int) (pw->panner.knob_width), 
		  (unsigned int) (pw->panner.knob_height)); 
  pw->panner.tmp.showing = !pw->panner.tmp.showing; 
}


/*********************************************************************
 *
 *  CheckKnob 
 *      Called by several action methods.     
 *
 *********************************************************************/
static void 
#ifdef _NO_PROTO
CheckKnob(pw, knob)
    register ExmPannerWidget pw;
    Boolean knob;
#else
CheckKnob(
    register ExmPannerWidget pw,
    Boolean knob)
#endif
{
 Position maxx = (((Position) pw->core.width) - 
		     pw->simple.margin_width * 2 -
		     ((Position) pw->panner.knob_width));
 Position maxy = (((Position) pw->core.height) - 
		     pw->simple.margin_height * 2 -
		     ((Position) pw->panner.knob_height));
 Position *x = (knob ? &pw->panner.knob_x : &pw->panner.tmp.x);
 Position *y = (knob ? &pw->panner.knob_y : &pw->panner.tmp.y);

    /* Note that positions are already normalized (i.e. margins
       have been subtracted out).  */
    if (*x < 0) *x = 0;
    if (*x > maxx) *x = maxx;

    if (*y < 0) *y = 0;
    if (*y > maxy) *y = maxy;

    if (knob) {
	pw->panner.slider_x = (Position) (((double) pw->panner.knob_x) /
					  pw->panner.haspect + 0.5);
	pw->panner.slider_y = (Position) (((double) pw->panner.knob_y) /
					  pw->panner.vaspect + 0.5);
	pw->panner.last_x = pw->panner.last_y = PANNER_OUTOFRANGE;
    }
}


/*********************************************************************
 *
 *  ScaleKnob 
 *      Called by Resize and SetValues.  This function sets the knob
 *      size and/or its location.
 *
 *********************************************************************/
static void 
#ifdef _NO_PROTO
ScaleKnob (pw, location, size)  
    ExmPannerWidget pw;
    Boolean location; 
    Boolean size;
#else
ScaleKnob (
    ExmPannerWidget pw,
    Boolean location,
    Boolean size)
#endif
{
  if (location) {
    pw->panner.knob_x = (Position) PANNER_HSCALE(pw, pw->panner.slider_x);
    pw->panner.knob_y = (Position) PANNER_VSCALE(pw, pw->panner.slider_y);
  }

  if (size) {
    Dimension width, height;

      if (pw->panner.slider_width < 1) {
        pw->panner.slider_width = pw->panner.canvas_width;
      }

      if (pw->panner.slider_height < 1) {
        pw->panner.slider_height = pw->panner.canvas_height;
      }

      width = (pw->panner.slider_width < pw->panner.canvas_width)?
      pw->panner.slider_width : pw->panner.canvas_width;
      height = (pw->panner.slider_height < pw->panner.canvas_height)?
      pw->panner.slider_height : pw->panner.canvas_height ;

      pw->panner.knob_width = (Dimension) PANNER_HSCALE(pw, width);
      pw->panner.knob_height = (Dimension) PANNER_VSCALE(pw, height);
  }

  CheckKnob (pw, TRUE);
}



/***************************************************************************
 *                                                                          *
 * 		      Panner action procs                                   *
 *                                                                          *
 **************************************************************************/




/************************************************************************
 *
 *  ExmPannerStart
 * 	
 *      
 ************************************************************************/
static void 
#ifdef _NO_PROTO
ExmPannerStart (gw, event, params, num_params)
    Widget gw;
    XEvent *event;
    String *params;	  /* unused */
    Cardinal *num_params; /* unused */
#else
ExmPannerStart (
    Widget gw,
    XEvent *event,
    String *params,	  /* unused */
    Cardinal *num_params  /* unused */ )
#endif
{
 ExmPannerWidget pw = (ExmPannerWidget) gw;
 int x, y;

    if (!GetEventXY (pw, event, &x, &y)) {
	XBell (XtDisplay(gw), 0);	/* should do error message */
	return;
    }

    if (*num_params != 1) {
	XBell (XtDisplay(gw), 0);
	return;
    }
    
    if (XmeNamesAreEqual (params[0], "1"))
	(void) XmProcessTraversal (gw, XmTRAVERSE_CURRENT);
  
    pw->panner.tmp.doing = TRUE;
    pw->panner.tmp.startx = pw->panner.knob_x;
    pw->panner.tmp.starty = pw->panner.knob_y;
    pw->panner.tmp.dx = (((Position) x) - pw->panner.knob_x);
    pw->panner.tmp.dy = (((Position) y) - pw->panner.knob_y);
    pw->panner.tmp.x = pw->panner.knob_x;
    pw->panner.tmp.y = pw->panner.knob_y;
    if (pw->panner.rubber_band) 
      DrawRubberBand (pw);
}


/************************************************************************
 *
 *  ExmPannerStop
 * 	
 *      
 ************************************************************************/
static void 
#ifdef _NO_PROTO
ExmPannerStop (gw, event, params, num_params)
    Widget gw;
    XEvent *event;
    String *params;	 /* unused */
    Cardinal *num_params;/* unused */
#else
ExmPannerStop (
    Widget gw,
    XEvent *event,
    String *params,	 /* unused */
    Cardinal *num_params /* unused */)
#endif
{
 ExmPannerWidget pw = (ExmPannerWidget) gw;
 int x, y;

    if (GetEventXY (pw, event, &x, &y)) {
      pw->panner.tmp.x = ((Position) x) - pw->panner.tmp.dx;
      pw->panner.tmp.y = ((Position) y) - pw->panner.tmp.dy;
      CheckKnob (pw, FALSE);
    }

    if (pw->panner.rubber_band && pw->panner.tmp.showing) 
      DrawRubberBand(pw);

    pw->panner.tmp.doing = FALSE;
}



/************************************************************************
 *
 *  ExmPannerAbort:
 *       Restores slider to the position it had at ExmPannerStart. 
 *      
 ************************************************************************/
static void 
#ifdef _NO_PROTO
ExmPannerAbort (gw, event, params, num_params)
    Widget gw;
    XEvent *event;
    String *params;			/* unused */
    Cardinal *num_params;		/* unused */
#else
ExmPannerAbort (
    Widget gw,
    XEvent *event,
    String *params,			/* unused */
    Cardinal *num_params		/* unused */)
#endif
{
 ExmPannerWidget pw = (ExmPannerWidget) gw;

    if (!pw->panner.tmp.doing) 
      return;

    if (pw->panner.rubber_band && pw->panner.tmp.showing) 
      DrawRubberBand (pw);

    if (!pw->panner.rubber_band) {	/* restore old position */
      pw->panner.tmp.x = pw->panner.tmp.startx;
      pw->panner.tmp.y = pw->panner.tmp.starty;
      ExmPannerNotify (gw, event, params, num_params);
    }
    pw->panner.tmp.doing = FALSE;
}


/************************************************************************
 *
 *  ExmPannerMove
 * 	
 *      
 ************************************************************************/
static void 
#ifdef _NO_PROTO
ExmPannerMove (gw, event, params, num_params)
    Widget gw;
    XEvent *event;			/* must be a motion event */
    String *params;			/* unused */
    Cardinal *num_params;		/* unused */
#else
ExmPannerMove (
    Widget gw,
    XEvent *event,			/* must be a motion event */
    String *params,			/* unused */
    Cardinal *num_params 		/* unused */)
#endif
{
 ExmPannerWidget pw = (ExmPannerWidget) gw;
 int x, y;

    if (!pw->panner.tmp.doing) 
      return;

    if (!GetEventXY (pw, event, &x, &y)) {
	XBell (XtDisplay(gw), 0);	/* should do error message */
	return;
    }

    if (pw->panner.rubber_band && pw->panner.tmp.showing) 
      DrawRubberBand (pw);

    pw->panner.tmp.x = ((Position) x) - pw->panner.tmp.dx;
    pw->panner.tmp.y = ((Position) y) - pw->panner.tmp.dy;

    if (!pw->panner.rubber_band) {
	ExmPannerNotify (gw, event, params, num_params);  /* does a check */
    } else {
	CheckKnob (pw, FALSE);
	DrawRubberBand (pw);
    }
}



/************************************************************************
 *
 *  ExmPannerNotify
 * 	
 *      
 ************************************************************************/
static void 
#ifdef _NO_PROTO
ExmPannerNotify (gw, event, params, num_params)
    Widget gw;
    XEvent *event;			/* unused */
    String *params;			/* unused */
    Cardinal *num_params;		/* unused */
#else
ExmPannerNotify (
    Widget gw,
    XEvent *event,			/* unused */
    String *params,			/* unused */
    Cardinal *num_params		/* unused */)
#endif
{
 ExmSimpleWidgetClass wc = (ExmSimpleWidgetClass)XtClass(gw);
 ExmPannerWidget pw = (ExmPannerWidget) gw;
 Position tmp;
	
	
    if (!pw->panner.tmp.doing) 
      return;

    CheckKnob (pw, FALSE);
    pw->panner.knob_x = pw->panner.tmp.x;
    pw->panner.knob_y = pw->panner.tmp.y;

    pw->panner.slider_x = (Position) (((double) pw->panner.knob_x) /
				      pw->panner.haspect + 0.5);
    pw->panner.slider_y = (Position) (((double) pw->panner.knob_y) /
				      pw->panner.vaspect + 0.5);
    /* check knob */
    if (pw->panner.slider_x >
	(tmp = (((Position) pw->panner.canvas_width) - 
		((Position) pw->panner.slider_width))))
	  pw->panner.slider_x = tmp;
    if (pw->panner.slider_x < 0) pw->panner.slider_x = 0;
    if (pw->panner.slider_y >
	(tmp = (((Position) pw->panner.canvas_height) - 
		((Position) pw->panner.slider_height))))
	pw->panner.slider_y = tmp;
    if (pw->panner.slider_y < 0) pw->panner.slider_y = 0;
   
    /* call callback if needed */
    if (pw->panner.last_x != pw->panner.knob_x ||
	pw->panner.last_y != pw->panner.knob_y) {
	ExmPannerCallbackStruct rep;

	wc->core_class.expose (gw, (XEvent*) NULL, (Region) NULL);
	rep.changed = (ExmPRSliderX | ExmPRSliderY);
	rep.slider_x = pw->panner.slider_x;
	rep.slider_y = pw->panner.slider_y;
	rep.slider_width = pw->panner.slider_width;
	rep.slider_height = pw->panner.slider_height;
	rep.canvas_width = pw->panner.canvas_width;
	rep.canvas_height = pw->panner.canvas_height;
	XtCallCallbackList (gw, pw->panner.report_callbacks, 
			    (XtPointer) &rep);
    }
}


/************************************************************************
 *
 *  ExmPannerSet 
 * 	
 *      
 ************************************************************************/
static void 
#ifdef _NO_PROTO
ExmPannerSet (gw, event, params, num_params)
    Widget gw;
    XEvent *event;			/* unused */
    String *params;
    Cardinal *num_params;
#else
ExmPannerSet (
    Widget gw,
    XEvent *event,			/* unused */
    String *params,
    Cardinal *num_params)
#endif
{
 ExmPannerWidget pw = (ExmPannerWidget) gw;
 Boolean rb;

    if (*num_params < 2 ||
	!XmeNamesAreEqual (params[0], "rubberband")) {
	XBell (XtDisplay(gw), 0);
	return;
    }

    if (XmeNamesAreEqual (params[1], "on")) {
	rb = TRUE;
    } else if (XmeNamesAreEqual (params[1], "off")) {
	rb = FALSE;
    } else if (XmeNamesAreEqual (params[1], "toggle")) {
	rb = !pw->panner.rubber_band;
    } else {
	XBell (XtDisplay(gw), 0);
	return;
    }

    if (rb != pw->panner.rubber_band) {
	XtVaSetValues (gw, ExmNrubberBand, rb, NULL);
    }
}


/************************************************************************
 *
 *  GetEventXY 
 * 	
 *      
 ************************************************************************/
static Boolean 
#ifdef _NO_PROTO
GetEventXY (pw, event, x, y)
    ExmPannerWidget pw;
    XEvent *event;
    int *x; 
    int *y;
#else
GetEventXY (
    ExmPannerWidget pw,
    XEvent *event,
    int *x,
    int *y)
#endif
{
    switch (event->type) {
      case ButtonPress:
      case ButtonRelease:
	*x = event->xbutton.x - pw->simple.margin_width;
	*y = event->xbutton.y - pw->simple.margin_height;
	return TRUE;

      case KeyPress:
      case KeyRelease:
	*x = event->xkey.x - pw->simple.margin_width;
	*y = event->xkey.y - pw->simple.margin_height;
	return TRUE;

      case EnterNotify:
      case LeaveNotify:
	*x = event->xcrossing.x - pw->simple.margin_width;
	*y = event->xcrossing.y - pw->simple.margin_height;
	return TRUE;

      case MotionNotify:
	*x = event->xmotion.x - pw->simple.margin_width;
	*y = event->xmotion.y - pw->simple.margin_height;
	return TRUE;
    }

    return FALSE;
}


/************************************************************************
 *
 *  ParsePageString 
 * 	
 *      
 ************************************************************************/
static int 
#ifdef _NO_PROTO
ParsePageString (s, pagesize, canvassize, relative)
    register char *s;
    int pagesize; 
    int canvassize;
    Boolean *relative;
#else
ParsePageString (
    register char *s,
    int pagesize,
    int canvassize,
    Boolean *relative)
#endif
{
 char *cp;
 int val = 1;
 Boolean rel = FALSE;

    /* Syntax:    spaces [+-] number spaces [pc\0] spaces  */

    for (; isascii(*s) && isspace(*s); s++) ;	/* skip white space */

    if (*s == '+' || *s == '-') {	/* deal with signs */
	rel = TRUE;
	if (*s == '-') val = -1;
	s++;
    }

    if (!*s) {				/* if null then return nothing */
	*relative = TRUE;
	return 0;
    }

					/* skip over numbers */
    for (cp = s; isascii(*s) && isdigit(*s); s++) ;
    val *= atoi (cp);

					/* skip blanks */
    for (; isascii(*s) && isspace(*s); s++) ;

    if (*s) {				/* if units */
	switch (s[0]) {
	  case 'p': case 'P':
	    val *= pagesize;
	    break;

	  case 'c': case 'C':
	    val *= canvassize;
	    break;
	}
    }
    *relative = rel;
    return (val);
}




/************************************************************************
 *
 *  ExmPannerPage 
 *     
 *      
 ************************************************************************/
static void 
#ifdef _NO_PROTO
ExmPannerPage (gw, event, params, num_params)
    Widget gw;
    XEvent *event;			/* unused */
    String *params;
    Cardinal *num_params;		/* unused */
#else
ExmPannerPage (
    Widget gw,
    XEvent *event,			/* unused */
    String *params,
    Cardinal *num_params		/* unused */)
#endif
{
 ExmPannerWidget pw = (ExmPannerWidget) gw;
 Cardinal zero = 0;
 Boolean isin = pw->panner.tmp.doing;
 int x, y;
 Boolean relx, rely;

    if (*num_params != 2) {
	XBell (XtDisplay(gw), 0);
	return;
    }

    x = ParsePageString (params[0], (int) pw->panner.knob_width,
			   ((int) pw->core.width) - 
			 pw->simple.margin_width*2, &relx);
    y = ParsePageString (params[1], (int) pw->panner.knob_height,
			   ((int) pw->core.height) -  
			 pw->simple.margin_height*2, &rely);

    if (relx) x += pw->panner.knob_x;
    if (rely) y += pw->panner.knob_y;

    if (isin) {				/* if in, then use move */
	XEvent ev;
	ev.xbutton.type = ButtonPress;
	ev.xbutton.x = x;
	ev.xbutton.y = y;
	ExmPannerMove (gw, &ev, (String *) NULL, &zero);
    } else {				/* else just do it */
	pw->panner.tmp.doing = TRUE;
	pw->panner.tmp.x = x;
	pw->panner.tmp.y = y;
	ExmPannerNotify (gw, event, (String *) NULL, &zero);
	pw->panner.tmp.doing = FALSE;
    }
}


/***************************************************************************
 *                                                                         *
 * 		      XmQTnavigator Trait Methods                          *
 *                                                                         *
 **************************************************************************/


/************************************************************************
 *
 *  NavigChangeMoveCB
 *	store or remove the callback list to be called on any move.
 *      
 ************************************************************************/
static void 
#ifdef _NO_PROTO
NavigChangeMoveCB(nav, moveCB, closure, setunset)
           Widget nav; 
	   XtCallbackProc moveCB;
           XtPointer closure; 
           Boolean setunset;
#else
NavigChangeMoveCB(
           Widget nav, 
	   XtCallbackProc moveCB,
           XtPointer closure,
           Boolean setunset)
#endif /* _NO_PROTO */
{
    if (setunset)
	XtAddCallback (nav, ExmNreportCallback, moveCB, closure);
    else 
	XtRemoveCallback (nav, ExmNreportCallback, moveCB, closure);
}




/************************************************************************
 *
 *  NavigSetValue
 *	change the value and possibly call the callbacks
 *
 ************************************************************************/
static void 
#ifdef _NO_PROTO
NavigSetValue(nav, nav_data, notify)
           Widget nav; 
	   XmNavigatorData nav_data; 
           Boolean notify ;
#else
NavigSetValue(
           Widget nav, 
	   XmNavigatorData nav_data,
           Boolean notify)
#endif /* _NO_PROTO */
{
 ExmPannerWidget pw = (ExmPannerWidget) nav;
 Arg arglist[6];
 Cardinal n ;
 int hsave_value, vsave_value ;

    if (nav_data->valueMask & NavDimMask) {
	pw->panner.dimMask = nav_data->dimMask ;
    }

    /* Panner is a two dimensional navigator, it expects
       one or two dimension to be set, either case should match
       the ones registered using the NavDimMask flag as aboce. */

    if (!(pw->panner.dimMask & nav_data->dimMask)) return ;

    hsave_value = pw->panner.slider_x ;
    vsave_value = pw->panner.slider_y ;

    n = 0;
    if (nav_data->dimMask & NavigDimensionX) {
	if ((nav_data->valueMask & NavValue) &&
	    (pw->panner.slider_x != nav_data->value.x)) {
	    XtSetArg (arglist[n], ExmNsliderX, nav_data->value.x);	n++;
	}
	if ((nav_data->valueMask & NavMaximum) &&
	    (pw->panner.canvas_width != nav_data->maximum.x)) {
	    XtSetArg (arglist[n], ExmNcanvasWidth,nav_data->maximum.x); n++;
	}
	if ((nav_data->valueMask & NavSliderSize) &&
	    (pw->panner.slider_width != nav_data->slider_size.x) &&
	    (nav_data->slider_size.x != 0)) {
	    XtSetArg (arglist[n], ExmNsliderWidth, nav_data->slider_size.x); 
	    n++;
	}
    }

    if (nav_data->dimMask & NavigDimensionY) {
	if ((nav_data->valueMask & NavValue) &&
	    (pw->panner.slider_y != nav_data->value.y)) {
	    XtSetArg (arglist[n], ExmNsliderY, nav_data->value.y);	n++;
	}
	if ((nav_data->valueMask & NavMaximum) &&
	    (pw->panner.canvas_height != nav_data->maximum.y)) {
	    XtSetArg (arglist[n], ExmNcanvasHeight, nav_data->maximum.y);n++;
	}
	if ((nav_data->valueMask & NavSliderSize) &&
	    (pw->panner.slider_height != nav_data->slider_size.y) &&
	    (nav_data->slider_size.y != 0)) {
	    XtSetArg (arglist[n], ExmNsliderHeight, nav_data->slider_size.y);
	    n++;
	}
    }

    if (n) XtSetValues (nav, arglist, n);

    if (notify && ((pw->panner.slider_x != hsave_value) || 
		   (pw->panner.slider_y != vsave_value))) {
	ExmPannerCallbackStruct rep;

	rep.changed = (ExmPRSliderX | ExmPRSliderY); /* not always both */
	rep.slider_x = pw->panner.slider_x;
	rep.slider_y = pw->panner.slider_y;
	rep.slider_width = pw->panner.slider_width;
	rep.slider_height = pw->panner.slider_height;
	rep.canvas_width = pw->panner.canvas_width;
	rep.canvas_height = pw->panner.canvas_height;
	XtCallCallbackList (nav, pw->panner.report_callbacks, 
			    (XtPointer) &rep);
    }
}


/************************************************************************
 *
 *  NavigGetValue
 *	reports the all the data for this navigator scrollbar
 *
 ************************************************************************/
static void
#ifdef _NO_PROTO
NavigGetValue(nav, nav_data)
    Widget nav;
    XmNavigatorData nav_data; 
#else
NavigGetValue(
    Widget nav,
    XmNavigatorData nav_data)
#endif
{
    ExmPannerWidget pw = (ExmPannerWidget) nav;

    nav_data->dimMask =  pw->panner.dimMask;

    if (nav_data->valueMask & 
	(NavValue|NavMinimum|NavMaximum|
	 NavSliderSize|NavIncrement|NavPageIncrement)) {

	nav_data->value.x = pw->panner.slider_x ;
	nav_data->value.y = pw->panner.slider_y ;
	nav_data->maximum.x = pw->panner.canvas_width ;
	nav_data->maximum.y = pw->panner.canvas_height ;
	nav_data->slider_size.x = pw->panner.slider_width ;
	nav_data->slider_size.y = pw->panner.slider_height ;

    }
}



/************************************************************************
 *
 *		Application Accessible External Functions
 *
 ************************************************************************/


/************************************************************************
 *
 *  ExmCreatePanner
 *	Create an instance of a Panner and return the widget id.
 *
 ************************************************************************/
Widget 
#ifdef _NO_PROTO
ExmCreatePanner( parent, name, arglist, argcount )
        Widget parent ;
        char *name ;
        ArgList arglist ;
        Cardinal argcount ;
#else
ExmCreatePanner(
        Widget parent,
        char *name,
        ArgList arglist,
        Cardinal argcount )
#endif /* _NO_PROTO */
{
   return (XtCreateWidget (name, exmPannerWidgetClass, 
                           parent, arglist, argcount));
}



/************************************************************************
 *
 *  ExmPannerSetValues
 *	Set some Panner values.
 *
 ************************************************************************/
void 
#ifdef _NO_PROTO
ExmPannerSetValues( w, hvalue, vvalue, notify)
        Widget w ;
        int hvalue ;
        int vvalue ;
        Boolean notify ;
#else
ExmPannerSetValues(
        Widget w,
        int hvalue,
        int vvalue,
#if NeedWidePrototypes
        int notify )
#else
        Boolean notify )
#endif /* NeedWidePrototypes */
#endif /* _NO_PROTO */
{
 ExmPannerWidget pw = (ExmPannerWidget) w;
 int       hsave_value, vsave_value;

   hsave_value = pw->panner.slider_x ;
   vsave_value = pw->panner.slider_y ;

   XtVaSetValues (w, ExmNsliderX, hvalue, ExmNsliderY, vvalue, NULL);

   if (notify && ((pw->panner.slider_x != hsave_value) || 
		  (pw->panner.slider_y != vsave_value))) {
       ExmPannerCallbackStruct rep;

       rep.changed = (ExmPRSliderX | ExmPRSliderY); /* not always both..*/
       rep.slider_x = pw->panner.slider_x;
       rep.slider_y = pw->panner.slider_y;
       rep.slider_width = pw->panner.slider_width;
       rep.slider_height = pw->panner.slider_height;
       rep.canvas_width = pw->panner.canvas_width;
       rep.canvas_height = pw->panner.canvas_height;
       XtCallCallbackList (w, pw->panner.report_callbacks, (XtPointer) &rep);
    }
}

