/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: Panner.h,v $
 * Revision 1.1.2.1  1994/06/02  15:33:06  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:15  marty]
 *
 * Revision 1.1.4.1  1994/03/26  21:05:14  daniel
 * 	clean up Panner
 * 	[1994/03/26  21:03:46  daniel]
 * 
 * Revision 1.1.2.1  1993/10/05  21:00:52  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:00:55  yak]
 * 
 * Revision 1.1.2.5  1993/07/21  20:43:14  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:20:33  yak]
 * 
 * Revision 1.1.2.4  1993/06/28  17:03:37  rosenberg
 * 	Changed #include <Exm.h> to #include <Exm/Simple.h>
 * 	[1993/06/28  17:03:17  rosenberg]
 * 
 * Revision 1.1.2.3  1993/05/20  02:12:35  daniel
 * 	subclass of Simple now
 * 	[1993/05/20  02:10:39  daniel]
 * 
 * Revision 1.1.2.2  1993/05/03  20:32:07  daniel
 * 	add ExmPanner
 * 	[1993/05/03  20:31:11  daniel]
 * 
 * $EndLog$
 */
/* Ensure that this file be included only once. */
#ifndef _ExmPanner_h
#define _ExmPanner_h

/* Include appropriate header file(s). */
#include <Exm/Simple.h>  /* public header file for the ExmSimple widget */


/* Allow for compilation by C++. */
#ifdef __cplusplus
extern "C" {
#endif

#define ExmNcanvasWidth "canvasWidth"
#define ExmCCanvasWidth "CanvasWidth"
#define ExmNcanvasHeight "canvasHeight"
#define ExmCCanvasHeight "CanvasHeight"
#define ExmNrubberBand "rubberBand"
#define ExmCRubberBand "RubberBand"
#define ExmNsliderX "sliderX"
#define ExmCSliderX "SliderX"
#define ExmNsliderY "sliderY"
#define ExmCSliderY "SliderY"
#define ExmNsliderWidth "sliderWidth"
#define ExmCSliderWidth "SliderWidth"
#define ExmNsliderHeight "sliderHeight"
#define ExmCSliderHeight "SliderHeight"
#define ExmNreportCallback "reportCallback"
#define ExmCReportCallback "reportCallback"


/*
 * ExmPannerReport - this structure is used by the reportCallback of the
 * Panner, Porthole, Viewport, and Scrollbar widgets to report its position.
 * All fields must be filled in, although the changed field may be used as
 * a hint as to which fields have been altered since the last report.
 */
typedef struct {
    int     reason;
    XEvent  *event;
    Mask changed;		/* mask, see below */
    Position slider_x, slider_y;	/* location of slider within outer */
    Dimension slider_width, slider_height;  /* size of slider */
    Dimension canvas_width, canvas_height;  /* size of canvas */
} ExmPannerCallbackStruct;

#define ExmPRSliderX		(1 << 0)
#define ExmPRSliderY		(1 << 1)
#define ExmPRSliderWidth	(1 << 2)
#define ExmPRSliderHeight	(1 << 3)
#define ExmPRCanvasWidth	(1 << 4)
#define ExmPRCanvasHeight	(1 << 5)

/* external declarations */
externalref WidgetClass exmPannerWidgetClass;

typedef struct _ExmPannerClassRec *ExmPannerWidgetClass;
typedef struct _ExmPannerRec      *ExmPannerWidget;


/* Define an IsSubclass macro. */
#ifndef ExmIsPanner
#define ExmIsPanner(w)	XtIsSubclass(w, exmPannerWidgetClass)
#endif 

/********    Public Function Declarations    ********/
#ifdef _NO_PROTO

extern Widget ExmCreatePanner() ;
extern void ExmPannerSetValues() ;

#else

extern Widget ExmCreatePanner( 
                        Widget parent,
                        char *name,
                        ArgList arglist,
                        Cardinal argcount) ;
extern void ExmPannerSetValues( 
                        Widget w,
                        int hvalue,
                        int vvalue,
#if NeedWidePrototypes
                        int notify) ;
#else
                        Boolean notify) ;
#endif /* NeedWidePrototypes */

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


#endif /* _ExmPanner_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
