/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: PannerP.h,v $
 * Revision 1.1.2.1  1994/06/02  15:33:07  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:16  marty]
 *
 * Revision 1.1.4.2  1994/03/26  21:05:15  daniel
 * 	clean up Panner
 * 	[1994/03/26  21:03:47  daniel]
 * 
 * Revision 1.1.4.1  1994/03/26  18:23:18  daniel
 * 	add resolve part Index
 * 	[1994/03/26  18:22:07  daniel]
 * 
 * Revision 1.1.2.1  1993/10/05  21:00:53  yak
 * 	Fixed include lines.
 * 	[1993/10/05  19:58:56  yak]
 * 
 * 	Moved the file from demos/widgets/Exm
 * 
 * Revision 1.1.2.4  1993/07/21  20:43:16  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:20:40  yak]
 * 
 * Revision 1.1.2.3  1993/05/20  02:12:37  daniel
 * 	subclass of Simple now
 * 	[1993/05/20  02:10:44  daniel]
 * 
 * Revision 1.1.2.2  1993/05/03  20:32:02  daniel
 * 	add ExmPanner
 * 	[1993/05/03  20:31:16  daniel]
 * 
 * $EndLog$
 */
#ifndef _ExmPannerP_h
#define _ExmPannerP_h

#include <Exm/Panner.h>
#include <Exm/SimpleP.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _ExmPannerClassPart {	/* new fields in widget class */
    XtPointer extension;
} ExmPannerClassPart;

typedef struct _ExmPannerClassRec {	/* Panner widget class */
    CoreClassPart        core_class;
    XmPrimitiveClassPart primitive_class;
    ExmSimpleClassPart   simple_class;
    ExmPannerClassPart   panner_class;
} ExmPannerClassRec;

typedef struct {			/* new fields in widget */
    /* resources... */
    XtCallbackList report_callbacks;	/* callback/Callback */
    Dimension canvas_width;		/* canvasWidth/CanvasWidth */
    Dimension canvas_height;		/* canvasHeight/CanvasHeight */
    Position slider_x;			/* sliderX/SliderX */
    Position slider_y;			/* sliderY/SliderY */
    Dimension slider_width;		/* sliderWidth/SliderWidth */
    Dimension slider_height;		/* sliderHeight/SliderHeight */

    /* private data... */
    GC xor_gc;				/* for doing XOR tmp graphics */
    double haspect, vaspect;		/* aspect ratio of core to canvas */
    Boolean rubber_band;		/* true = rubber band, false = move */
    struct {
	Boolean doing;			/* tmp graphics in progress */
	Boolean showing;		/* true if tmp graphics displayed */
	Position startx, starty;	/* initial position of slider */
	Position dx, dy;		/* offset loc for tmp graphics */
	Position x, y;			/* location for tmp graphics */
    } tmp;
    Position knob_x, knob_y;		/* real upper left of knob in canvas */
    Dimension knob_width, knob_height;	/* real size of knob in canvas */
    Position last_x, last_y;		/* previous location of knob */

    Mask dimMask ;                      /* navigator mask */
} ExmPannerPart;

typedef struct _ExmPannerRec {
    CorePart core;
    XmPrimitivePart primitive;
    ExmSimplePart simple;
    ExmPannerPart panner;
} ExmPannerRec;

/* Define the subclassing level index to be used with ResolvePartOffset */
#define ExmPannerIndex (ExmSimpleIndex + 1)

/*
 * external declarations
 */
externalref ExmPannerClassRec exmPannerClassRec;

/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

#else

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _ExmPannerP_h */
