/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: Simple.h,v $
 * Revision 1.1.2.2  1994/06/03  18:38:15  daniel
 * 	fix resource reptype naming
 * 	[1994/06/03  18:38:02  daniel]
 *
 * Revision 1.1.2.1  1994/06/02  15:33:10  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:17  marty]
 * 
 * Revision 1.1.4.1  1994/03/25  18:56:18  rosenberg
 * 	Added API _NO_PROTOs for CR 8387
 * 	[1994/03/25  18:22:05  rosenberg]
 * 
 * Revision 1.1.2.1  1993/10/05  21:00:58  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:01:01  yak]
 * 
 * Revision 1.1.2.5  1993/07/21  20:43:23  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:20:57  yak]
 * 
 * Revision 1.1.2.4  1993/05/26  21:45:18  rosenberg
 * 	Added comments.
 * 	[1993/05/26  18:14:11  rosenberg]
 * 
 * Revision 1.1.2.3  1993/05/12  20:42:43  rosenberg
 * 	Removed #include "Exm.h"; changed names of resources.
 * 	[1993/05/12  20:42:20  rosenberg]
 * 
 * Revision 1.1.2.2  1993/02/26  21:07:39  al
 * 	Initial version
 * 	[1993/02/26  20:52:26  al]
 * 
 * $EndLog$
 */

/*******************************************************************************
 *
 * Simple.h: The widget public header file for the ExmSimple demonstration
 *           widget.
 *
 ******************************************************************************/


/* Ensure that the file be included only once. */
#ifndef _ExmSimple_h
#define _ExmSimple_h


/* Include appropriate files. */
#include <Xm/Xm.h>  /* public header file for the XmPrimitive widget */


/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif


/* Define the widget class and widget record. */
externalref WidgetClass exmSimpleWidgetClass;

typedef struct _ExmSimpleClassRec *ExmSimpleWidgetClass;
typedef struct _ExmSimpleRec *ExmSimpleWidget;


/* Define an IsSubclass macro. */
#ifndef ExmIsSimple
#define ExmIsSimple(w) XtIsSubclass(w, exmSimpleWidgetClass)
#endif

/* Define string equivalents of new resource names. */
#define ExmNsimpleShape "simpleShape"
#define ExmCSimpleShape "SimpleShape"
#define ExmRSimpleShape "ExmSimpleShape"

/* Specify new enumerated constants for resources. */ 
enum { ExmSHAPE_OVAL=0, ExmSHAPE_RECTANGLE=1 };


/* Specify the API for this widget. */
#ifdef _NO_PROTO
extern Widget ExmCreateSimple();
#else
extern Widget ExmCreateSimple(Widget    parent,
                              char     *name,
                              Arg      *arglist,
                              Cardinal  argCount);
#endif /* _NO_PROTO */


/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


#endif /* _ExmSimple_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */

