/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: String.c,v $
 * Revision 1.1.2.4  1994/07/11  14:48:56  rosenberg
 * 	Changed cast in DefaultFont for CR 9720
 * 	[1994/07/11  14:29:32  rosenberg]
 *
 * Revision 1.1.2.3  1994/07/06  21:43:14  drand
 * 	Remove references to XmeStringUpdate
 * 	[1994/07/06  21:42:40  drand]
 * 
 * Revision 1.1.2.2  1994/06/06  18:18:20  rosenberg
 * 	Fixed num_syn_resources field
 * 	[1994/06/06  18:17:52  rosenberg]
 * 
 * Revision 1.1.2.1  1994/06/02  15:33:13  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:06  marty]
 * 
 * Revision 1.1.5.15  1994/04/18  21:19:20  drand
 * 	Update C++ widgets and fix some bugs
 * 	[1994/04/18  21:18:37  drand]
 * 
 * Revision 1.1.5.14  1994/04/14  19:47:47  rosenberg
 * 	Changed warning comment at front of program for CR 8570
 * 	[1994/04/14  15:29:43  rosenberg]
 * 
 * Revision 1.1.5.13  1994/04/08  17:40:17  inca
 * 	Updated some comments. Remove #ifdef FAT.
 * 	[1994/04/07  17:05:44  inca]
 * 
 * Revision 1.1.5.12  1994/03/30  22:34:12  rosenberg
 * 	Added synthetic resource
 * 	[1994/03/30  22:33:47  rosenberg]
 * 
 * Revision 1.1.5.11  1994/03/30  21:16:48  rosenberg
 * 	Fixed problems in XmQTaccessTextual trait methods
 * 	[1994/03/30  21:16:29  rosenberg]
 * 
 * Revision 1.1.5.10  1994/03/29  21:17:10  rosenberg
 * 	Added XmConst support for CR 8416
 * 	[1994/03/29  21:15:57  rosenberg]
 * 
 * Revision 1.1.5.9  1994/03/25  21:44:53  rosenberg
 * 	Added missing 'case' statements to StringSetValue
 * 	[1994/03/25  21:44:38  rosenberg]
 * 
 * Revision 1.1.5.8  1994/03/25  21:39:19  rosenberg
 * 	Corrected name of primClassExtRec and made it static
 * 	[1994/03/25  21:38:04  rosenberg]
 * 
 * Revision 1.1.5.7  1994/03/25  20:00:32  rosenberg
 * 	Implemented the proper insensitiveStippleBitmap
 * 	[1994/03/25  20:00:11  rosenberg]
 * 
 * Revision 1.1.5.6  1994/02/26  18:36:15  rosenberg
 * 	Added colons to front of osfMumble translations and changed order of translations; CR 7490
 * 	[1994/02/26  18:35:05  rosenberg]
 * 
 * 	Simple.c
 * 
 * Revision 1.1.5.5  1994/02/25  16:17:32  rosenberg
 * 	Added a few casts to eliminate some compiler warnings
 * 	[1994/02/25  16:17:13  rosenberg]
 * 
 * Revision 1.1.5.4  1994/02/23  22:14:07  rosenberg
 * 	Fixed XmQTaccessTextual getValue yet again.
 * 	[1994/02/23  22:13:37  rosenberg]
 * 
 * Revision 1.1.5.3  1994/02/08  21:24:31  rosenberg
 * 	I forgot to mention that the GetValue and SetValue fixes are for CR 7743
 * 	[1994/02/08  21:24:16  rosenberg]
 * 
 * Revision 1.1.5.2  1994/02/02  18:54:21  rosenberg
 * 	Updated accessTextual trait methods; rewrote calls to _Xm function, etc.
 * 	[1994/02/02  18:54:02  rosenberg]
 * 
 * Revision 1.1.5.1  1994/01/12  19:29:47  rosenberg
 * 	Changed XmQTaccessTextual trait methods; more like XmLabel now
 * 	[1994/01/12  19:29:10  rosenberg]
 * 
 * Revision 1.1.2.3  1993/11/05  20:37:49  rosenberg
 * 	Removed XmNstringDirection resource; added
 * 	support for XmNlayoutDirection resource.
 * 	[1993/11/05  20:37:10  rosenberg]
 * 
 * Revision 1.1.2.2  1993/10/28  20:32:16  daniel
 * 	add some trait and cleanup
 * 	[1993/10/28  20:31:14  daniel]
 * 
 * Revision 1.1.2.1  1993/10/05  21:01:07  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  19:20:45  yak]
 * 
 * Revision 1.1.5.3  1993/10/05  17:33:49  rosenberg
 * 	Commented out a call to XmeStringUpdate.
 * 	[1993/10/05  17:33:33  rosenberg]
 * 
 * Revision 1.1.5.2  1993/09/03  15:55:07  drand
 * 	Tried to fix geometry.
 * 	[1993/09/03  15:54:08  drand]
 * 
 * Revision 1.1.2.12  1993/07/23  21:35:46  drk
 * 	Fixup _NO_PROTO definitions.
 * 	[1993/07/23  21:23:36  drk]
 * 
 * 	Work around aggregate problems on Suns.
 * 	[1993/07/23  19:49:11  drk]
 * 
 * Revision 1.1.2.11  1993/07/21  20:43:27  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:21:10  yak]
 * 
 * Revision 1.1.2.10  1993/07/09  16:51:51  rom
 * 	Copy compound string and render table in Initialize.
 * 	[1993/07/09  16:46:12  rom]
 * 
 * Revision 1.1.2.9  1993/07/08  18:53:55  rom
 * 	Fix need_to_recompute logic in SetValues().
 * 	[1993/07/08  18:53:34  rom]
 * 
 * Revision 1.1.2.8  1993/07/08  16:53:56  rom
 * 	Copy new ExmNcompoundString when the value changes.
 * 	[1993/07/08  16:53:23  rom]
 * 
 * Revision 1.1.2.7  1993/06/30  20:29:21  rosenberg
 * 	"Improved" Resizing policy.
 * 	[1993/06/30  20:28:04  rosenberg]
 * 
 * Revision 1.1.2.6  1993/06/15  14:35:40  rosenberg
 * 	Added reconfigure method to primitive class record.
 * 	[1993/06/15  14:33:57  rosenberg]
 * 
 * Revision 1.1.2.5  1993/06/14  22:13:07  rosenberg
 * 	Redid alignment, margins, resizing.
 * 	Still needs some improvement.
 * 	[1993/06/14  22:12:48  rosenberg]
 * 
 * 	class_part_initialize in core class record was set to
 * 	NULL; I've set it to ClassPartInitialize.
 * 	[1993/06/08  15:46:57  rosenberg]
 * 
 * Revision 1.1.2.4  1993/05/28  16:32:06  rosenberg
 * 	Added the XmQTaccessTextual trait.
 * 	[1993/05/28  16:10:18  rosenberg]
 * 
 * Revision 1.1.2.3  1993/05/26  21:38:25  rosenberg
 * 	Ready for initial code review.
 * 	[1993/05/26  21:38:07  rosenberg]
 * 
 * 	Fixed some bugs.
 * 	[1993/05/26  17:10:59  rosenberg]
 * 
 * 	Added a widget baselines method.
 * 	[1993/05/25  20:03:40  rosenberg]
 * 
 * 	Converted font lists to Render Tables; added comments;
 * 	still need to debug WidgetBaselines and WidgetDisplayRect
 * 	methods.
 * 	[1993/05/25  17:16:38  rosenberg]
 * 
 * Revision 1.1.2.2  1993/02/26  21:06:23  al
 * 	Initial version
 * 	[1993/02/26  21:00:17  al]
 * 
 * $EndLog$
 */
/************************************ WARNING **********************************
 *
 * ExmString is a demonstration widget.  OSF provides this widget
 * solely to teach programmers how to write their own Motif widgets.
 * OSF does not support this widget in any way
 ************************************ WARNING *********************************/


/*******************************************************************************
 *
 * String.c - ExmString widget.  This widget renders a compound string.
 *            The ExmString widget demonstrates how to work with strings
 *            in Motif widgets.  Functionally, the widget is similar to
 *            XmLabel, except that XmLabel can render both pixmaps and
 *            compound strings.  The ExmString widget manipulates the 
 *            resources and traits used by other Motif string-oriented 
 *            widgets.  See the "OSF/Motif Widget Writer's Guide" for details.
 *
 ******************************************************************************/

/* Include appropriate header files. */
#include <Xm/XmP.h>   /* private header file for the XmPrimitive widget */
#include <Xm/XmosP.h>  /* header file for MB_CUR_MAX */ 
#include <Exm/StringP.h>  /* private header file for the ExmString widget */
#include <Xm/RepType.h> /* header file for representation type facility */
#include <Xm/TraitP.h>  /* header file for installing traits */
#include <Xm/AccTextT.h> /* header file for AccessTextual trait */
#include <Xm/SpecRenderT.h> /* header file for XmLABEL_RENDER_TABLE */
#include <Xm/Screen.h>   /* header file for screen information */
#include <Xm/DrawP.h>   /* header file for Draw routines */


/* Declare all static functions. */
#ifdef _NO_PROTO
static void DefaultFont();
static void GetValuesCompoundString();
static void ClassInitialize();
static void ClassPartInitialize();
static void Initialize();
static void Destroy();
static void Resize();
static void AlignmentDirection();
static Boolean SetValues();
static XtGeometryResult QueryGeometry();
static void DrawVisual();
static void CalcVisualSize();
static void CreateGC();
static Boolean WidgetBaselines();
static Boolean WidgetDisplayRect();
static void StringSetValue();
static XtPointer StringGetValue();
static int StringPreferredFormat();

#else
static void DefaultFont (
                        Widget w,
                        int offset,
                        XrmValue *value
                        );
static void GetValuesCompoundString(
                        Widget w,
                        int resource,
                        XtArgVal *value);
static void ClassInitialize(void);
static void ClassPartInitialize(
                        WidgetClass widgetclass);
static void Initialize(
                        Widget request_w,
                        Widget new_w,
                        ArgList args,
                        Cardinal *num_args );
static void Destroy (
                        Widget w );
static void Resize (
                        Widget w );
static void AlignmentDirection(
                        Widget w );
static Boolean SetValues (
                        Widget old_w,
                        Widget request_w,
                        Widget new_w,
                        ArgList args,
                        Cardinal *num_args );
static XtGeometryResult QueryGeometry (
                        Widget w,
                        XtWidgetGeometry *request,
                        XtWidgetGeometry *reply);
static void DrawVisual (
                        Widget w );
static void CalcVisualSize (
                        Widget w );
static void CreateGC ( 
                        Widget w );
static Boolean WidgetBaselines (
                        Widget w,
                        Dimension **baselines,
                        int *line_count);
static Boolean WidgetDisplayRect (
                        Widget       w,
                        XRectangle  *displayrect);
static void StringSetValue(
                        Widget w, 
                        XtPointer s, 
                        int format);
static XtPointer StringGetValue(
                        Widget w, 
                        int format); 
static int StringPreferredFormat(
                        Widget w);
#endif


/* Define constants here. */ 
static XmConst int  FIND_NATURAL_SIZE = 0;
#define UNSUPPORTED_FORMAT "Someone is trying to get or set a value for \n\
ExmNcompoundString; however, the specified format is undefined.\n"



/* Define the translations string for the ExmString widget.
   All six actions will be handled by the XmPrimitive widget. */
static char defaultTranslations[] = 
"<EnterWindow>:		PrimitiveEnter()\n\
<LeaveWindow>:		PrimitiveLeave()\n\
:<Key>osfActivate:	PrimitiveParentActivate()\n\
:<Key>osfCancel:	PrimitiveParentCancel()\n\
:<Key>osfHelp:		PrimitiveHelp()\n\
~s ~m ~a <Key>Return:	PrimitiveParentActivate()";

/* No actions array needed. */ 


/* Define the resources for the ExmString widget.  */
static XtResource resources[] = 
{
   {
	XmNtraversalOn,
	XmCTraversalOn,
	XmRBoolean,
	sizeof (Boolean),
	XtOffsetOf( XmPrimitiveRec, primitive.traversal_on),
	XmRImmediate, 
	(XtPointer) False /* override the default. */
    },
    {    
	ExmNcompoundString,
	ExmCCompoundString,
	XmRXmString,
	sizeof(XmString),
	XtOffsetOf( ExmStringRec,string.compound_string),
	XmRImmediate,
	(XtPointer) NULL
    },
    { 
	XmNrenderTable, 
	XmCRenderTable,
	XmRRenderTable,
	sizeof(XmRenderTable),
	XtOffsetOf( ExmStringRec,string.render_table),
	XtRCallProc,
	(XtPointer) DefaultFont
    },
    {
	XmNalignment,
	XmCAlignment,
	XmRAlignment,
	sizeof(unsigned char),
	XtOffsetOf( ExmStringRec,string.alignment),
	XmRImmediate, 
	(XtPointer) XmALIGNMENT_CENTER
    },
   {
        XmNrecomputeSize,
        XmCRecomputeSize,
        XmRBoolean,
        sizeof(Boolean),
        XtOffsetOf( ExmStringRec,string.recompute_size),
        XmRImmediate,
        (XtPointer) True
   },
};


/* Provide a synthetic resource for ExmNcompoundString. */ 
static XmSyntheticResource syn_resources[] =
{
   {
        ExmNcompoundString, 
        sizeof(XmString),
        XtOffsetOf(ExmStringRec, string.compound_string),
        GetValuesCompoundString, 
        NULL  
   }
};


/* Here is the primitive class extension record. */
static XmPrimitiveClassExtRec primClassExtRec = {
    /* next_extension */             NULL,
    /* record_type */                NULLQUARK,
    /* version */                    XmPrimitiveClassExtVersion,
    /* record_size */                sizeof(XmPrimitiveClassExtRec),
    /* widget_baseline */            WidgetBaselines, 
    /* widget_display_rect */        WidgetDisplayRect,
    /* widget_margins */             NULL,
};

externaldef (exmstringclassrec) ExmStringClassRec exmStringClassRec = {
  {    
    /* superclass */                 (WidgetClass)&exmSimpleClassRec,
    /* class_name */                 "ExmString",
    /* widget_size */                sizeof(ExmStringRec),
    /* class_initialize */           ClassInitialize,
    /* class_part_initialize */      ClassPartInitialize,
    /* class_inited */               FALSE,
    /* initialize */                 Initialize,
    /* initialize_hook */            NULL,
    /* realize */                    XtInheritRealize,
    /* actions */                    NULL,
    /* num_actions */                0,
    /* resources */                  resources,
    /* num_resources */              XtNumber(resources),
    /* xrm_class */                  NULLQUARK,
    /* compress_motion */            TRUE,
    /* compress_exposure */          XtExposeCompressMaximal,
    /* compress_enterleave */        TRUE,
    /* visible_interest */           FALSE,
    /* destroy */                    Destroy,
    /* resize */                     Resize,
    /* expose */                     XtInheritExpose,
    /* set_values */                 SetValues,
    /* set_values_hook */            NULL,
    /* set_values_almost */          XtInheritSetValuesAlmost,
    /* get_values_hook */            NULL,
    /* accept_focus */               NULL,
    /* version */                    XtVersion,
    /* callback_private */           NULL,
    /* tm_table */                   defaultTranslations,
    /* query_geometry */             QueryGeometry,
    /* display_accelerator */        NULL,
    /* extension */                  NULL,
  },    
  { /* XmPrimitive */        
    /* border_highlight */           XmInheritBorderHighlight,
    /* border_unhighlight */         XmInheritBorderUnhighlight,
    /* translations */               XtInheritTranslations,
    /* arm_and_activate */           NULL,
    /* syn_resources */              syn_resources, 
    /* num_syn_resources */          XtNumber(syn_resources),
    /* extension */                  (XtPointer)&primClassExtRec, 
  },    
  { /* ExmSimple */                  
    /* draw_visual */                DrawVisual,
    /* draw_shadow */                ExmInheritDrawShadow,
    /* create_text_gc */             CreateGC,
    /* destroy_text_gc */            ExmInheritDestroyGC,
    /* select_text_gc */             ExmInheritSelectGC,
    /* calc_visual_size */           CalcVisualSize,
    /* calc_widget_size */           ExmInheritCalcWidgetSize,
    /* reconfigure */                ExmInheritReconfigure,
    /* extension */                  NULL,
  },    
  { /* ExmString */  
    /* default_render_table_type */  XmLABEL_RENDER_TABLE,
    /* extension */                  NULL,
  }    
};    

/* Establish the widget class name as an externally accessible symbol.
   Use the "externaldef" macro for OS-independent global definitions. */
externaldef( exmstringwidgetclass) WidgetClass exmStringWidgetClass =
                                  (WidgetClass) &exmStringClassRec;


/* Define static representation type variables here. */
static XmRepTypeId alignmentId;


/* Define trait structure variables here. */
/* Since ExmString displays a primary parcel of text, the ExmString 
   widget must install the XmQTaccessTextual trait.  The following
   declaration is of a trait structure variable named StringATT. */
static XmConst XmAccessTextualTraitRec StringATT = {
  0,  				/* version */
  StringGetValue,
  StringSetValue,
  StringPreferredFormat,
};

/*******************************************************************************
 *
 *  DefaultFont:
 *      Called by the Intrinsics to establish a default value for the
 *      XmNrenderTable resource. 
 *
 ******************************************************************************/
static void
#ifdef _NO_PROTO
DefaultFont (w, offset, value)
        Widget w;
        int offset;
        XrmValue *value;
#else
DefaultFont (
        Widget w,
        int offset,
        XrmValue *value
            )
#endif
{
 ExmStringWidgetClass wc = (ExmStringWidgetClass)XtClass(w);
 static XmRenderTable  f1;

 /* Find the default render table associated with the default 
    render table type. */
   f1 = XmeGetDefaultRenderTable (w, 
                                  wc->string_class.default_render_table_type);

   value->addr = (XtPointer)&f1;
   value->size = sizeof(f1);
}


/************************************************************************
 *
 * GetValuesCompoundString
 *	This is a synthetic resource function called by Motif when
 *      an application calls XtGetValues to access the value of  
 *      ExmNcompoundString. 
 *
 ***********************************************************************/

/*ARGSUSED*/
static void 
#ifdef _NO_PROTO
GetValuesCompoundString(w, resource, value)
        Widget w;
        int resource;		/* unused */
        XtArgVal *value;
#else
GetValuesCompoundString(
        Widget w,
        int resource,	/* unused */
        XtArgVal *value)
#endif /* _NO_PROTO */
{
 ExmStringWidget sw = (ExmStringWidget) w;
 XmString  string;
 
 /* All Motif widgets are responsible for making a copy of an XmString
    resource whenever an application accesses the resource through a call
    to XtGetValues. */ 
   string = XmStringCopy(sw->string.compound_string);

   *value = (XtArgVal) string;
}


/*******************************************************************************
 *
 *  ClassInitialize
 *      Called by the Intrinsics the first time a widget of this class is 
 *      instantiated.
 *
 ******************************************************************************/
static void
#ifdef _NO_PROTO
ClassInitialize()
#else
ClassInitialize(void)
#endif
{
 /* Use existing Motif representation types for XmNalignment. */
   alignmentId = XmRepTypeGetId (XmRAlignment);
   if (alignmentId == XmREP_TYPE_INVALID)
     XmeWarning(NULL, "The value of XmNalignment is illegal.");
}

/************************************************************************
 *
 *  ClassPartInitialize
 *      Called by the Intrinsics when this widget or a subclass of this
 *      widget is instantiated.
 *
 ************************************************************************/
static void
#ifdef _NO_PROTO
ClassPartInitialize( widgetclass )
        WidgetClass widgetclass ;
#else
ClassPartInitialize(
        WidgetClass widgetclass )
#endif
{
 /* Install the XmQTaccessTextual trait on the ExmString class and all
    its subclasses. */
   XmeTraitSet((XtPointer) widgetclass, XmQTaccessTextual,
               (XtPointer) &StringATT);
}


/*******************************************************************************
 *
 *  Initialize
 *      Called when this widget is instantiated.
 *
 ******************************************************************************/
static void
#ifdef _NO_PROTO
Initialize (request_w, new_w, args, num_args)
        Widget request_w;
        Widget new_w;
        ArgList args;
        Cardinal *num_args;
#else
Initialize (
        Widget request_w,
        Widget new_w,
        ArgList args,
        Cardinal *num_args
           )
#endif
{
  ExmStringWidgetClass wc = (ExmStringWidgetClass)XtClass(new_w);
  ExmStringWidget nw = (ExmStringWidget)new_w;
  unsigned char stringDirection;
  Arg dirArgs[1];

  /* Copy the compound string and render table. */
  nw->string.compound_string = XmStringCopy(nw->string.compound_string);
  nw->string.render_table = XmRenderTableCopy(nw->string.render_table,
					      NULL, 0);

  /* Validate  XmNalignment */
  if (!XmRepTypeValidValue (alignmentId, nw->string.alignment, (Widget)nw))
    nw->string.alignment = XmALIGNMENT_CENTER;
    
  /* If the XmNstringDirection resource is set to XmSTRING_DIRECTION_DEFAULT,
     then we need to figure out what the default string direction is.
     If the parent is a manager, then we'll set the string direction of 
     ExmString to the string direction of the manager.  */

  AlignmentDirection((Widget)nw); 

  if (wc->simple_class.calc_visual_size)
    (*(wc->simple_class.calc_visual_size))(new_w);

  if (wc->simple_class.reconfigure)
    (*(wc->simple_class.reconfigure))(exmStringWidgetClass, new_w, NULL);
}



/*******************************************************************************
 *
 *  Destroy
 *      Called by the Intrinsics whenever this widget is deallocated.
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
Destroy (w)
       Widget w;
#else
Destroy (
       Widget w
        )
#endif
{
 ExmStringWidget sw = (ExmStringWidget)w;

 /* Free the memory used to hold the ExmNcompound_string and 
    XmNrenderTable resource values. */
   if (sw->string.compound_string != NULL)
     XmStringFree (sw->string.compound_string);

   if (sw->string.render_table != NULL)
     XmRenderTableFree (sw->string.render_table);
}



/*******************************************************************************
 *
 * Resize
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
Resize (w)
        Widget w;
#else
Resize (
        Widget w 
       )
#endif
{
 ExmStringWidget sw = (ExmStringWidget)w;
 Dimension  mw, mh; 
 Dimension  window_decoration_thickness;

 /* Configure internal geometry using current size */
   if ((sw->simple.visual.width == FIND_NATURAL_SIZE) || 
       (sw->simple.visual.height == FIND_NATURAL_SIZE)) 
     return;

   window_decoration_thickness = sw->primitive.highlight_thickness  +
                                 sw->primitive.shadow_thickness;

 /* Determine where the string's bounding box should start. */
 
 /* First determine the X coordinate of the bounding box. */ 
  mw = window_decoration_thickness + sw->simple.margin_width;

  switch (sw->string.text_starts_here)
    {
        case ExmSTART_STRING_LEFT_SIDE :
          sw->simple.visual.x = mw;
          break; 
        case ExmSTART_STRING_RIGHT_SIDE :
          sw->simple.visual.x = sw->core.width - (mw + sw->simple.visual.width +
                                                  window_decoration_thickness);
          break;
        case ExmCENTER_STRING :
          sw->simple.visual.x = (sw->core.width - sw->simple.visual.width)/2; 
          break;
    };


 /* Now do the same for the vertical dimension. */
   mh = window_decoration_thickness + sw->simple.margin_height;

   /* If the widget has enough vertical space to display all the lines in 
      the string, then center the string. */
   if (sw->core.height > 
           ((2 * window_decoration_thickness) + sw->simple.visual.height)) {
     sw->simple.visual.y = (sw->core.height - sw->simple.visual.height)/2;
   }
   else if (sw->core.height > 2 * window_decoration_thickness) {
    /* Space is very tight.  We will eliminate the top margin altogether and 
       start the first line of the compound string snug against the bottom of 
       the top edge of the window decorations. */ 
     sw->simple.visual.y = window_decoration_thickness;
   }
  else
    /* Space is so tight that we do not have enough space to display even 
       one pixel of the visual. */ 
     sw->simple.visual.y = window_decoration_thickness;

}

/*******************************************************************************
 * 
 * AlignmentDirection:
 *     Called by Initialize and by SetValues. 
 *
 ******************************************************************************/ 
static void
#ifdef _NO_PROTO
AlignmentDirection(w)
        Widget  w;
#else
AlignmentDirection(
        Widget w
                     )
#endif 
{
 ExmStringWidget sw = (ExmStringWidget)w;

 /* This method determines where the text starts.  The text could 
      * be centered. 
      * start at the left side of the widget. 
      * start at the right side of the widget. 
 */ 
   if (sw->string.alignment == XmALIGNMENT_CENTER)
   /* The string will be centered. */ 
     sw->string.text_starts_here = ExmCENTER_STRING;
    
   else if (
            (XmDirectionMatch(sw->primitive.layout_direction, XmLEFT_TO_RIGHT) &&  
	     sw->string.alignment == XmALIGNMENT_BEGINNING)
                                ||
            (XmDirectionMatch(sw->primitive.layout_direction, XmRIGHT_TO_LEFT) &&
             sw->string.alignment == XmALIGNMENT_END)
           )
   /* The string will start at the left side of the widget. */ 
     sw->string.text_starts_here = ExmSTART_STRING_LEFT_SIDE;

   else if (
            (XmDirectionMatch(sw->primitive.layout_direction, XmLEFT_TO_RIGHT) &&
             sw->string.alignment == XmALIGNMENT_END) 
                                ||
            (XmDirectionMatch(sw->primitive.layout_direction, XmRIGHT_TO_LEFT) &&
             sw->string.alignment == XmALIGNMENT_BEGINNING)
           )
   /* The string will start at the right side of the widget. */ 
     sw->string.text_starts_here = ExmSTART_STRING_RIGHT_SIDE;
}   



/*******************************************************************************
 *
 *  SetValues
 *
 ******************************************************************************/
static Boolean 
#ifdef _NO_PROTO
SetValues (old_w, request_w, new_w, args, num_args)
        Widget old_w;
        Widget request_w;
        Widget new_w;
        ArgList args;
        Cardinal *num_args;
#else
SetValues (
        Widget old_w,
        Widget request_w,
        Widget new_w,
        ArgList args,
        Cardinal *num_args
          )
#endif
{
  ExmStringWidgetClass wc = (ExmStringWidgetClass)XtClass(new_w);
  ExmStringWidget cw = (ExmStringWidget)old_w;
  ExmStringWidget nw = (ExmStringWidget)new_w;
  Boolean redisplayFlag = False;

  /* Copy ExmNcompoundString if its value has changed */
  if (nw->string.compound_string != cw->string.compound_string) {
    nw->string.compound_string = XmStringCopy(nw->string.compound_string);
    XmStringFree(cw->string.compound_string);
    cw->string.compound_string = (XmString) NULL;
    nw->simple.need_to_reconfigure = True;
  }

  /* Update XmNcompound_string whenever XmNrenderTable changes */
  if (nw->string.render_table != cw->string.render_table) {
    nw->string.render_table = XmRenderTableCopy(nw->string.render_table,
						NULL, 0);
    XmRenderTableFree (cw->string.render_table);
    cw->string.render_table = (XmRenderTable) NULL;
    nw->simple.need_to_reconfigure = True;
  }

  /* Validate any changes to the value of the XmNalignment resource. 
     If the requested new value is not valid, then reset the value of the
     XmNalignment resource to the old value. */
  if (nw->string.alignment != cw->string.alignment) {
    if (!XmRepTypeValidValue(alignmentId, nw->string.alignment, (Widget)nw))
      nw->string.alignment = cw->string.alignment;
    else nw->simple.need_to_reconfigure = True;
  }

  /* If the XmNrecomputeSize resource used to be False but is now True, then
     we will have to set in motion the series of calls that will lead to
     an appropriate resize of the widget. */ 
  if ((nw->string.recompute_size == True) && 
      (cw->string.recompute_size == False)) {
    nw->simple.need_to_reconfigure = True;

    if (nw->core.width == cw->core.width)
      nw->core.width = FIND_NATURAL_SIZE;
    if (nw->core.height == cw->core.height)
      nw->core.height = FIND_NATURAL_SIZE;
  }

  /* If the Alignment has changed or the layout direction has changed,
     then the widget needs to determine a new starting position for
     the bounding text box. */ 
  if ( nw->string.alignment != cw->string.alignment ||
      nw->primitive.layout_direction != cw->primitive.layout_direction)
    AlignmentDirection((Widget)nw);

  /* Determine whether or not the widget needs to be reconfigured.  Just
     about any change to a resource will necessitate a reconfiguration.
     If the widget does need to be reconfigured, call Reconfigure. */ 
  if (nw->simple.need_to_reconfigure == True) {
    if (wc->simple_class.reconfigure)
      (*(wc->simple_class.reconfigure))(exmStringWidgetClass, new_w, old_w);

    redisplayFlag = True;
  }

  return (redisplayFlag);
}


/*******************************************************************************
 *
 *  QueryGeometry
 *     Called by the Intrinsics in response to a proposed changed in geometry.
 *
 ******************************************************************************/
static XtGeometryResult 
#ifdef _NO_PROTO
QueryGeometry( w, request, reply )
        Widget w ;
        XtWidgetGeometry *request;
        XtWidgetGeometry *reply;
#else
QueryGeometry(
        Widget w,
        XtWidgetGeometry *request,
        XtWidgetGeometry *reply )
#endif /* _NO_PROTO */
{
  ExmStringWidgetClass swc = (ExmStringWidgetClass)XtClass(w);
  ExmStringWidget sw = (ExmStringWidget) w ;

  if (!XtIsRealized(w)) {
    /* Widget has not been realized yet. */ 
    reply->width  = XtWidth(w);   /* might be 0 */
    reply->height = XtHeight(w);  /* might be 0 */
  } else {
    if (sw->string.recompute_size) {
      /* The user will allow the ExmString widget to change size, so 
	 let's call CalcWidgetSize to calculate the widget's 
	 preferred size. */ 
      int save_w, save_h;

      save_w = XtWidth(w);
      save_h = XtHeight(w);
      if (swc->simple_class.calc_widget_size)
	(*(swc->simple_class.calc_widget_size))((Widget)sw);
      sw -> simple.pref_width = XtWidth(w);
      sw -> simple.pref_height = XtHeight(w);
      XtWidth(w) = save_w;
      XtHeight(w) = save_h;
    }
    reply->width  = sw -> simple.pref_width;
    reply->height = sw -> simple.pref_height;
  }

  /* Return our preferred size */
  return XmeReplyToQueryGeometry(w, request, reply);
}

/*******************************************************************************
 *
 *  DrawVisual
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
DrawVisual (w)
        Widget w;
#else
DrawVisual (
        Widget w
           )
#endif
{
 ExmStringWidgetClass wc = (ExmStringWidgetClass)XtClass(w);
 ExmStringWidget sw = (ExmStringWidget)w;

 /* If the compound string is not NULL and if there is enough space in the
    widget to draw at least a little portion of the compound string, then 
    render the string with XmStringDraw. */
   if (sw->string.compound_string &&
      (sw->simple.visual.width != 0) &&
      (sw->simple.visual.height != 0)) {
     XmStringDraw (XtDisplay(sw), XtWindow(sw),
                   sw->string.render_table, 
                   sw->string.compound_string,
		   wc->simple_class.select_gc(w),
		   sw->simple.visual.x, sw->simple.visual.y,
		   sw->simple.visual.width, sw->string.alignment,
                   sw->primitive.layout_direction, NULL); 
     XmeClearBorder(XtDisplay(sw), XtWindow(sw),
                    (int)0, (int)0, 
                    (Dimension)sw->core.width, (Dimension)sw->core.height, 
                    (Dimension)(sw->primitive.highlight_thickness +
                                sw->primitive.shadow_thickness)
                   );
   }
}



/*******************************************************************************
 *
 *  CreateGC:
 *      Called by the Initialize method of the base class (ExmSimple).
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
CreateGC (w)
        Widget w;
#else
CreateGC (
        Widget w
         )
#endif
{
 ExmStringWidget sw = (ExmStringWidget)w;
 XGCValues    values;
 XtGCMask     valueMask;
 XFontStruct *fs = (XFontStruct *) NULL;
 Arg          args[2];
 Pixmap       insensitiveStippleBitmap;

 /* This function creates two GC's: one to render a sensitive widget
    and the other to render an insensitive widget. */

 /* First, create the sensitive GC (named normal_gc). */ 
   valueMask = GCForeground | GCBackground | GCGraphicsExposures;
   values.foreground = sw->primitive.foreground;
   values.background = sw->core.background_pixel;
   values.graphics_exposures = False;

 /* In order to set the GCFont field of the GC, we must gather XFontStruct 
    information out of the render table. This is only to get a reasonable
    initial value. XmStringDraw will pick the necessary fonts from the
    render table, so we will not need to update the GC when the render 
    table changes. */ 
   XmeRenderTableGetDefaultFont(sw->string.render_table, &fs);
   if (fs != NULL) {
     values.font = fs->fid;
     valueMask |= GCFont;
   }

   sw->simple.normal_gc = XtGetGC ((Widget)sw, valueMask, &values);

 /* Next, create the insensitive GC.  This GC will share the same
    foreground, background, font, and graphics exposures as the sensitive
    GC, but will hold a different fill style and stipple pattern. */ 
   valueMask |= GCFillStyle | GCStipple;
   values.fill_style = FillStippled;

/* Gather the Motif-appropriate insensitive stipple bitmap. */
   XtSetArg(args[0], XmNinsensitiveStippleBitmap, &insensitiveStippleBitmap);
   XtGetValues(XmGetXmScreen(XtScreen(w)), args, 1);
   values.stipple = insensitiveStippleBitmap;

   sw->simple.insensitive_gc = XtGetGC((Widget) sw, valueMask, &values);
}



/*******************************************************************************
 *
 * CalcVisualSize
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
CalcVisualSize (w)
        Widget w;
#else
CalcVisualSize (
        Widget w
               )
#endif
{
 ExmStringWidget sw = (ExmStringWidget)w;

 /* Ideally, how much space would the compound string require? */
   if (sw->string.compound_string && !XmStringEmpty(sw->string.compound_string))
     XmStringExtent (sw->string.render_table, sw->string.compound_string,
                     &(sw->simple.visual.width), &(sw->simple.visual.height));
   else {
 /* The string is empty, so it requires no space. */
     sw->simple.visual.width = 0;
     sw->simple.visual.height = 0;
   }
}


/*******************************************************************************
 *
 * WidgetBaselines:
 *      Called by manager widgets needing to align text-based visuals.
 *      This method can also be called directly by an application through
 *      the XmWidgetGetBaselines function. 
 *
 ******************************************************************************/
static Boolean
#ifdef _NO_PROTO
WidgetBaselines(w, baselines, line_count)
        Widget w;
        Dimension **baselines;
        int *line_count;
#else
WidgetBaselines(
        Widget w,
        Dimension **baselines,
        int *line_count)
#endif /* _NO_PROTO */
{
 XmStringContext context = NULL;
 XmString        current_string;

 XmString string, string2;
 XmString string1 = NULL;
 char* text1;
 char* text2;
 XmStringCharSet char_set1, char_set2;
 XmStringDirection direction1, direction2;
 /* XmFontList FontList; */
 XmRenderTable RenderTable; 
 Boolean separator1, separator2;
 Dimension *base_array;
 Dimension Offset;
 int index;
 ExmStringWidget sw = (ExmStringWidget)w;

 /* This function returns True to indicate that the widget is displaying
    text, or False to indicate that the widget is not displaying text.
    If the widget is displaying text, this function calculates the baseline 
    of each displayed line of text. */

   index = 0;
   RenderTable = sw->string.render_table;

 /* Initialize the string context.  If the XmStringInitContext call returns
    False, then no string context could be found which suggests that no
    text is being displayed in the widget. */
   current_string = sw->string.compound_string;
   if (!XmStringInitContext (&context, current_string))
     return (False);

 /* Determine how many lines are in the displayed string. */
   *line_count = XmStringLineCount(current_string);

    base_array = (Dimension *)XtMalloc((sizeof(Dimension) * (*line_count)));
/*    Offset = ((ExmStringWidget) w)->string.visual.y;  */
    Offset = sw->simple.visual.y;
    
 /* Go through the compound string, segment by segment. */
   while (XmStringGetNextSegment (context, &text1, &char_set1, &direction1,
                                   &separator1)) {
      if (string1)
	XmStringFree(string1);

      string1 = XmStringCreate(text1, char_set1);
      XtFree(text1);

      if (separator1)
      {
        while (XmStringPeekNextComponent(context)== XmSTRING_COMPONENT_SEPARATOR) {
	   XmStringGetNextComponent (context, &text1, &char_set1, &direction1,
                                     NULL, NULL, NULL);
           base_array[index++] = Offset + XmStringBaseline (RenderTable, string1);
           Offset += XmStringHeight (RenderTable, string1);
	}
      }
      else if (XmStringGetNextSegment (context, &text2, &char_set2, &direction2,
                                       &separator2)) {
        if (separator2)
        {
          string2 = XmStringCreate(text2, char_set2);
          string1 = XmStringConcat(string1, string2);
          base_array[index++] = Offset + XmStringBaseline (RenderTable, string1);
          Offset += XmStringHeight (RenderTable, string1);
        }
        else
        {
          string2 = XmStringCreate(text2, char_set2);
          string1 = XmStringConcat(string1, string2);
        }

	XtFree(text2);
	XmStringFree(string2);
	XtFree(char_set2);
      }
      else
      {
	XtFree(char_set1);
	break;
      }

      XtFree(char_set1);
    } /* end of outer while loop */

    base_array[index++] = Offset + XmStringBaseline (RenderTable, string1);

    XmStringFree(string1);

    *baselines = base_array;

    XmStringFreeContext(context);
    XmStringFree(string);
    
    return (True);   
}


/*******************************************************************************
 *
 *  WidgetDisplayRect:
 *      Called by several Motif managers to determine how to align the visuals 
 *      drawn by primitives.  In addition, an application can access this 
 *      method by calling XmWidgetGetDisplayRect. 
 *
 ******************************************************************************/
static Boolean  
#ifdef _NO_PROTO
WidgetDisplayRect(w, displayrect)
        Widget       w;
        XRectangle  *displayrect;
#else
WidgetDisplayRect(
        Widget       w,
        XRectangle  *displayrect
                 )
#endif
{
 ExmStringWidget  my_widget = (ExmStringWidget) w;

   if ((my_widget->simple.visual.width > 0 && 
        my_widget->simple.visual.height > 0)) {
     displayrect->x =       my_widget->simple.visual.x; 
     displayrect->y =       my_widget->simple.visual.y; 
     displayrect->width =   my_widget->simple.visual.width; 
     displayrect->height =  my_widget->simple.visual.height; 
     return True;  /* Yes, this widget contains something displayable. */
   }
   else  {
     return False; /* this widget is not currently displaying a visual. */
   }
}

/*******************************************************************************
 *
 *  Trait Methods: 
 *      We now provide the code for the three methods defined by the
 *      XmQTaccessTextual trait. 
 *
 ******************************************************************************/


/*******************************************************************************
 *
 *  StringGetValue: Called by another widget (generally a parent of 
 *     an ExmString).  This trait method must return the currently 
 *     displayed text string in the format that the caller requests. 
 *
 ******************************************************************************/
static XtPointer
#ifdef _NO_PROTO
StringGetValue(w, format)
     Widget w;
     int format;
#else
StringGetValue(
     Widget w, 
     int format) 
#endif
{
 ExmStringWidget  string_w = (ExmStringWidget) w;
 XmString     value;
 int          n;
 Arg          args[4];
 XmParseTable map[2];
 XmString     separator;
 XtPointer    result;
 XmTextType   output_type;
  
 /* Get the string that the ExmString widget is currently displaying. */
 value = XmStringCopy(string_w -> string.compound_string);

 /* The "value" variable know holds the string in XmString format.  */
  
   switch (format)   {
      case XmFORMAT_XmSTRING:  
         /* If the caller wants "value" returned as a 
            compound string, no conversion is necessary. */
           return (XtPointer) value;

      case XmFORMAT_MBYTE: 
      case XmFORMAT_WCS:
         /* If the caller wants "value" returned as a multibyte string
            or as a wide character string, then we have to convert it. */
           if (format == XmFORMAT_MBYTE)
             output_type = XmMULTIBYTE_TEXT;
           else
             output_type = XmWIDECHAR_TEXT;

         /* Create a very simple parse table consisting of two 
            parse mappings. */
           separator = XmStringSeparatorCreate();
         
           n = 0;
           XtSetArg( args[n], XmNpattern, "\n"); n++;
           XtSetArg( args[n], XmNpatternType, output_type ); n++;
           XtSetArg( args[n], XmNsubstitute, separator ); n++;
           XtSetArg( args[n], XmNincludeStatus, XmINSERT ); n++; 
           map[0] = (XmParseMapping  *) XmParseMappingCreate( args, n );  
           XmStringFree(separator);

           separator = XmStringComponentCreate(
                                 XmSTRING_COMPONENT_TAB, 0, NULL);
           n = 0;
           XtSetArg( args[n], XmNpattern, "\t"); n++;
           XtSetArg( args[n], XmNpatternType, output_type ); n++;
           XtSetArg( args[n], XmNsubstitute, separator ); n++;
           XtSetArg( args[n], XmNincludeStatus, XmINSERT ); n++; 
           map[1] = (XmParseMapping  *) XmParseMappingCreate( args, n );  
           XmStringFree(separator);

         /* Unparse "value" into either MULTIBYTE or WCS format. */
           result = XmStringUnparse (value, 
                                     (XmStringTag) NULL,
                                     (XmTextType)NULL, 
                                     (XmTextType)output_type, 
                                     (XmParseTable)map, 
                                     XtNumber(map), 
                                     XmOUTPUT_ALL);

         /* Variable "result" now holds the text of the string in either
            MULTIBYTE or WCS format. */
           return (XtPointer)result;

      default:
           XmeWarning((Widget)w, UNSUPPORTED_FORMAT);
           return NULL;
   }


}

/*******************************************************************************
 *
 *  StringSetValue:
 *       Called by another widget to set the value of the ExmNcompoundString
 *       resource.   
 *
 ******************************************************************************/
static void 
#ifdef _NO_PROTO
StringSetValue(w, string, format)
     Widget w;
     XtPointer string;
     int format;
#else
StringSetValue(
     Widget w, 
     XtPointer string, 
     int format)
#endif
{
 Arg       args[1];
 XmString  temp;
 Boolean   freetemp;
 int       length;
 char     *str;
 wchar_t  *str2;

  /* The caller will pass a new value for ExmNcompoundString.  This new
     value will be passed in the "string" argument.  However, there is
     no guarantee that the input "string" will be passed in XmString format.
     If the input "string" is passed in WCS or MULTIBYTE format, then we
     must convert the "string" into XmString format.  Once the "string"
     is in XmString format, we can use it as the new value of 
     ExmNcompoundString. */ 
    switch (format)    {
        case XmFORMAT_XmSTRING: temp = (XmString) string;
                                freetemp = False;
                                break;

        case XmFORMAT_WCS:      str2 = (wchar_t *) string;
	                      /* How long is str2? */ 
                                length = 0;
	                        while (str2[length] != 0)
	                           length++;
                              /* malloc enough space to hold str */
                                str = (char*) XtMalloc(MB_CUR_MAX * (length+1));
                                wcstombs(str, str2, MB_CUR_MAX * (length+1));
                                string = str;
    
        case XmFORMAT_MBYTE:    temp = XmStringCreateLocalized(string);
                                freetemp = True;
                                break;

        default:                XmeWarning((Widget)w, UNSUPPORTED_FORMAT);
                                return; 
    }
  
    XtSetArg(args[0], ExmNcompoundString, temp); 
    XtSetValues(w, args, 1);
  
    if (freetemp) 
      XmStringFree(temp);
}

/*******************************************************************************
 *
 *  StringPreferredFormat
 *      Called by another widget to determine the preferred string format of 
 *      this widget.  The possible returned formats are:
 *           * XmFORMAT_XmSTRING  (Motif compound string format)
 *           * XmFORMAT_MBYTE     (Multibyte format)
 *           * XmFORMAT_WCS       (Wide character string format)
 *
 ******************************************************************************/
static int
#ifdef _NO_PROTO
StringPreferredFormat(w)
     Widget w;
#else
StringPreferredFormat(
     Widget w)
#endif
{
 /* Choose XmFORMAT_XmSTRING because the ExmString widget holds its displayed
    text in XmString format (as opposed to Multibyte or WCS format). */
   return(XmFORMAT_XmSTRING);
}


/*******************************************************************************
 *
 *  ExmCreateString
 *      Externally accessable function for creating a String widget
 *
 ******************************************************************************/
Widget
#ifdef _NO_PROTO
ExmCreateString (parent, name, arglist, argCount)
        Widget parent;
        char *name;
        Arg *arglist;
        Cardinal argCount;
#else
ExmCreateString (
        Widget parent,
        char *name,
        Arg *arglist,
        Cardinal argCount
                )
#endif
{
   return (XtCreateWidget(name,exmStringWidgetClass,parent,arglist,argCount));
}

