/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: String.h,v $
 * Revision 1.1.2.1  1994/06/02  15:33:14  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:18  marty]
 *
 * Revision 1.1.4.1  1994/03/25  18:56:26  rosenberg
 * 	Added API _NO_PROTOs for CR 8387
 * 	[1994/03/25  18:22:09  rosenberg]
 * 
 * Revision 1.1.2.1  1993/10/05  21:01:08  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:01:07  yak]
 * 
 * Revision 1.1.2.5  1993/07/21  20:43:29  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:21:16  yak]
 * 
 * Revision 1.1.2.4  1993/06/30  20:29:24  rosenberg
 * 	Minor commenting changes.
 * 	[1993/06/30  20:28:22  rosenberg]
 * 
 * Revision 1.1.2.3  1993/05/26  21:46:52  rosenberg
 * 	Added comments.
 * 	[1993/05/26  18:14:24  rosenberg]
 * 
 * Revision 1.1.2.2  1993/02/26  21:07:53  al
 * 	Initial version
 * 	[1993/02/26  20:52:35  al]
 * 
 * $EndLog$
 */

/*******************************************************************************
 *
 * String.h: The widget public header file for the ExmString demonstration
 *            widget.
 *
 ******************************************************************************/


/* Ensure that the file be included only once. */
#ifndef _ExmString_h
#define _ExmString_h


/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif


/* Include appropriate files. */
#include <Exm/Simple.h>  /* public header file for the ExmSimple widget */


/* Define the widget class and widget record. */
externalref WidgetClass exmStringWidgetClass;

typedef struct _ExmStringClassRec *ExmStringWidgetClass;
typedef struct _ExmStringRec *ExmStringWidget;


/* Define an IsSubclass macro. */
#ifndef ExmIsString
#define ExmIsString(w) XtIsSubclass(w, exmStringWidgetClass)
#endif


/* Define string equivalents of new resource names. */
#define ExmNcompoundString "compoundString"
#define ExmCCompoundString "CompoundString"


/* Specify the API for this widget. */
#ifdef _NO_PROTO
extern Widget ExmCreateString();
#else
extern Widget ExmCreateString(Widget    parent,
                              char     *name,
                              Arg      *arglist,
                              Cardinal  argCount);
#endif /* _NO_PROTO */ 


/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


/* Ensure that the file be included only once. */
#endif /* _ExmString_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */

