/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: StringP.h,v $
 * Revision 1.1.2.1  1994/06/02  15:33:16  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:19  marty]
 *
 * Revision 1.1.6.1  1994/05/23  16:54:12  drand
 * 	Fix 8632 - string_direction is obsolete
 * 	[1994/05/23  16:53:58  drand]
 * 
 * Revision 1.1.4.3  1994/03/26  18:23:20  daniel
 * 	add resolve part Index
 * 	[1994/03/26  18:22:09  daniel]
 * 
 * Revision 1.1.4.2  1994/03/11  14:55:03  rosenberg
 * 	Removed #include <stdlib.h>
 * 	[1994/03/11  14:54:39  rosenberg]
 * 
 * Revision 1.1.4.1  1994/02/02  17:16:04  rosenberg
 * 	Added #include <stdlib.h>.
 * 	[1994/02/02  17:07:59  rosenberg]
 * 
 * Revision 1.1.2.1  1993/10/05  21:01:10  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:01:08  yak]
 * 
 * Revision 1.1.2.6  1993/07/21  20:43:31  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:21:20  yak]
 * 
 * Revision 1.1.2.5  1993/06/30  20:29:26  rosenberg
 * 	Eliminated clip field.
 * 	[1993/06/30  20:28:38  rosenberg]
 * 
 * Revision 1.1.2.4  1993/06/14  22:14:12  rosenberg
 * 	Experimenting with a new 'clip' field.
 * 	[1993/06/14  22:13:53  rosenberg]
 * 
 * 	Changed #include <StringP.h> to #include <Exm/StringP.h>
 * 	[1993/06/11  19:12:55  rosenberg]
 * 
 * Revision 1.1.2.3  1993/05/26  21:47:41  rosenberg
 * 	Added comments.
 * 	[1993/05/26  21:47:26  rosenberg]
 * 
 * Revision 1.1.2.2  1993/02/26  21:07:59  al
 * 	Initial version
 * 	[1993/02/26  20:52:41  al]
 * 
 * $EndLog$
 */

/*******************************************************************************
 *
 * StringP.h: The widget private header file for the ExmString demonstration
 *            widget.
 *
 ******************************************************************************/

/* Ensure that the file be included only once. */
#ifndef _ExmStringP_h
#define _ExmStringP_h

/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif


/* Include appropriate files. */
#include <Exm/String.h>  /* public header file for the ExmString widget */
#include <Exm/SimpleP.h> /* private header file for the ExmSimple widget */

/* No new inheritable methods. */

/* Define the widget class part. */
typedef struct _ExmStringClassPart
{
	unsigned char 		default_render_table_type;
	XtPointer		extension;
} ExmStringClassPart;


/* Define the full class record. */
typedef struct _ExmStringClassRec
{
	CoreClassPart		core_class;
	XmPrimitiveClassPart	primitive_class;
	ExmSimpleClassPart	simple_class;
	ExmStringClassPart	string_class;
} ExmStringClassRec;


/* Make the full class record externally accessible. */
externalref ExmStringClassRec exmStringClassRec;

/* Define a new enumerated type. */
typedef enum { ExmCENTER_STRING, ExmSTART_STRING_LEFT_SIDE,
                     ExmSTART_STRING_RIGHT_SIDE} ExmHowAligned;


/* Define the widget instance part. */
typedef struct _ExmStringPart
{
 /* Provide space for the five resources of ExmString. */
	XmString		compound_string;
	unsigned char		alignment;
        XmRenderTable           render_table;
        Boolean                 recompute_size;
        ExmHowAligned           text_starts_here; 
} ExmStringPart;

/* Define the full instance record. */
typedef struct _ExmStringRec
{
	CorePart		core;
	XmPrimitivePart		primitive;
	ExmSimplePart		simple;
	ExmStringPart		string;
} ExmStringRec;

/* Define the subclassing level index to be used with ResolvePartOffset */
#define ExmStringIndex (ExmSimpleIndex + 1)

/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

/* Ensure that the file be included only once. */
#endif /* _ExmStringP_h */
