/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: StringTrans.h,v $
 * Revision 1.1.2.1  1994/06/02  15:33:19  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:20  marty]
 *
 * Revision 1.1.4.1  1994/03/25  18:56:32  rosenberg
 * 	Added API _NO_PROTOs for CR 8387
 * 	[1994/03/25  18:22:12  rosenberg]
 * 
 * Revision 1.1.2.1  1993/10/05  21:01:15  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:01:14  yak]
 * 
 * Revision 1.1.2.3  1993/07/21  20:43:36  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:21:31  yak]
 * 
 * Revision 1.1.2.2  1993/07/08  21:36:26  rom
 * 	First version of ExmStringTransfer widget.
 * 	[1993/07/08  21:27:51  rom]
 * 
 * $EndLog$
 */
/*******************************************************************************
 *
 * StringTrans.h: The widget public header file for the ExmStringTransfer
 *                uniform transfer model demonstration widget.
 *
 ******************************************************************************/


/* Ensure that the file be included only once. */
#ifndef _ExmStringTrans_h
#define _ExmStringTrans_h


/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif


/* Include appropriate files. */
#include <Exm/String.h>  /* public header file for the ExmString widget */


/* Define the widget class and widget record. */
externalref WidgetClass exmStringTransferWidgetClass;

typedef struct _ExmStringTransferClassRec *ExmStringTransferWidgetClass;
typedef struct _ExmStringTransferRec *ExmStringTransferWidget;


/* Define an IsSubclass macro. */
#ifndef ExmIsStringTransfer
#define ExmIsStringTransfer(w) XtIsSubclass(w, exmStringTransferWidgetClass)
#endif


/* No string equivalents of new resource names. */


/* Specify the API for this widget. */
#ifdef _NO_PROTO
extern Widget ExmCreateStringTransfer();
#else
extern Widget ExmCreateStringTransfer(Widget    parent,
                                      char     *name,
                                      Arg      *arglist,
                                      Cardinal  argCount);
#endif /* _NO_PROTO */


/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


#endif /* _ExmStringTrans_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */

