/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: StringTransP.h,v $
 * Revision 1.1.2.1  1994/06/02  15:33:20  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:21  marty]
 *
 * Revision 1.1.4.3  1994/04/04  15:33:30  drand
 * 	Remove SNAPSHOT handling
 * 	[1994/04/04  15:33:04  drand]
 * 
 * Revision 1.1.4.2  1994/03/26  18:23:21  daniel
 * 	add resolve part Index
 * 	[1994/03/26  18:22:10  daniel]
 * 
 * Revision 1.1.4.1  1994/03/01  18:16:27  drand
 * 	Added Primary and Clipboard transfer functions to StringTransfer
 * 	[1994/03/01  18:15:26  drand]
 * 
 * Revision 1.1.2.1  1993/10/05  21:01:16  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:01:15  yak]
 * 
 * Revision 1.1.2.3  1993/07/21  20:43:38  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:21:37  yak]
 * 
 * Revision 1.1.2.2  1993/07/08  21:36:31  rom
 * 	First version of ExmStringTransfer widget.
 * 	[1993/07/08  21:27:56  rom]
 * 
 * $EndLog$
 */
/*******************************************************************************
 *
 * StringTransP.h: The widget private header file for the ExmStringTransfer 
 *                 uniform transfer model demonstration widget.
 *
 ******************************************************************************/

/* Ensure that the file be included only once. */
#ifndef _ExmStringTransP_h
#define _ExmStringTransP_h

/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif


/* Include appropriate files. */
#include <Exm/StringTrans.h> /* public header file for the ExmStringTransfer widget */
#include <Exm/StringP.h> /* private header file for the ExmString widget */

/* No new inheritable methods. */

/* Define the widget class part. */
typedef struct _ExmStringTransferClassPart
{
	XtPointer		extension;
} ExmStringTransferClassPart;


/* Define the full class record. */
typedef struct _ExmStringTransferClassRec
{
	CoreClassPart		core_class;
	XmPrimitiveClassPart	primitive_class;
	ExmSimpleClassPart	simple_class;
	ExmStringClassPart	string_class;
	ExmStringTransferClassPart	string_transfer_class;
} ExmStringTransferClassRec;


/* Make the full class record externally accessible. */
externalref ExmStringTransferClassRec exmStringTransferClassRec;

/* Define the widget instance part. */
typedef struct _ExmStringTransferPart
{
  /* Fields and resources for ExmStringTransfer. */
	XtCallbackList		               destination_callback;
	Boolean				       own_primary;
} ExmStringTransferPart;

/* Define the full instance record. */
typedef struct _ExmStringTransferRec
{
	CorePart		core;
	XmPrimitivePart		primitive;
	ExmSimplePart		simple;
	ExmStringPart		string;
	ExmStringTransferPart	string_transfer;
} ExmStringTransferRec, *ExmStringTransfer;


/* Define the subclassing level index to be used with ResolvePartOffset */
#define ExmStringTransferIndex (ExmStringIndex + 1)

/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

/* Ensure that the file be included only once. */
#endif /* _ExmStringTransP_h */
