/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: TabB.h,v $
 * Revision 1.1.2.2  1994/06/03  18:38:16  daniel
 * 	fix resource reptype naming
 * 	[1994/06/03  18:38:03  daniel]
 *
 * Revision 1.1.2.1  1994/06/02  15:33:22  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:22  marty]
 * 
 * Revision 1.1.4.1  1994/03/25  18:56:38  rosenberg
 * 	Added API _NO_PROTOs for CR 8387
 * 	[1994/03/25  18:22:16  rosenberg]
 * 
 * Revision 1.1.2.1  1993/10/05  21:01:18  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:01:19  yak]
 * 
 * Revision 1.1.2.6  1993/07/21  20:43:42  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:21:48  yak]
 * 
 * Revision 1.1.2.5  1993/06/11  21:58:47  rosenberg
 * 	Added <Exm/ prefix to #include directive.
 * 	[1993/06/11  21:58:30  rosenberg]
 * 
 * Revision 1.1.2.4  1993/05/26  21:48:39  rosenberg
 * 	Added comments.
 * 	[1993/05/26  18:14:55  rosenberg]
 * 
 * Revision 1.1.2.3  1993/05/18  21:30:33  daniel
 * 	more work
 * 	[1993/05/18  21:30:07  daniel]
 * 
 * Revision 1.1.2.2  1993/05/03  21:17:53  daniel
 * 	add ExmTabButton
 * 	[1993/05/03  21:16:27  daniel]
 * 
 * $EndLog$
 */

/*******************************************************************************
 *
 * TabB.h: The widget public header file for the ExmTabButton demonstration
 *         widget.
 *
 ******************************************************************************/


/* Ensure that the file be included only once. */
#ifndef _ExmTabB_h
#define _ExmTabB_h


/* Include appropriate files. */
#include <Exm/CommandB.h>  /* public header file for ExmCommandButton */
#include <Xm/JoinSideT.h> /* contains defs. needed by ExmNopenSide resource */


/* Define the widget class and widget record. */
externalref WidgetClass exmTabButtonWidgetClass;

typedef struct _ExmTabButtonClassRec *ExmTabButtonWidgetClass;
typedef struct _ExmTabButtonRec *ExmTabButtonWidget;


/* Define an IsSubclass macro. */
#ifndef ExmIsTabButton
#define ExmIsTabButton(w) XtIsSubclass(w, exmTabButtonWidgetClass)
#endif


/* Define string equivalents of new resource names. */
#define ExmNopenSide  "openSide"
#define ExmCOpenSide  "OpenSide"
#define ExmROpenSide  "ExmOpenSide"


/* Specify the API for this widget. */
#ifdef _NO_PROTO
extern Widget ExmCreateTabButton();
#else
extern Widget ExmCreateTabButton(Widget    parent,
                                 char     *name,
                                 Arg      *arglist,
                                 Cardinal  argCount);
#endif /* _NO_PROTO */


/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


/* Ensure that the file be included only once. */
#endif /* _ExmTabB_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
