/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: TabBP.h,v $
 * Revision 1.1.2.2  1994/06/22  19:05:30  knight
 * 	Added joinSide trait behavior to maintain separate joinSide
 * 	shadowThickness (of the manager) from the primitive shadowThickness).
 * 	[1994/06/22  19:05:04  knight]
 *
 * Revision 1.1.2.1  1994/06/02  15:33:24  marty
 * 	This file has been moved from demos/widgets/Exm/lib. Refer to that directory for prior history.
 * 	[1994/06/01  20:54:22  marty]
 * 
 * Revision 1.1.4.3  1994/04/15  14:35:27  knight
 * 	Fix joinSide shadow drawing when join shadow thickness
 * 	is set to zero.
 * 	[1994/04/14  21:42:30  knight]
 * 
 * Revision 1.1.4.2  1994/03/26  21:05:16  daniel
 * 	fix Index
 * 	[1994/03/26  21:04:03  daniel]
 * 
 * Revision 1.1.4.1  1994/03/26  18:23:23  daniel
 * 	add resolve part Index
 * 	[1994/03/26  18:22:11  daniel]
 * 
 * Revision 1.1.2.1  1993/10/05  21:01:19  yak
 * 	Moved the file from demos/widgets/Exm
 * 	[1993/10/05  17:01:20  yak]
 * 
 * Revision 1.1.2.5  1993/07/21  20:43:44  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:21:53  yak]
 * 
 * Revision 1.1.2.4  1993/06/11  22:01:41  rosenberg
 * 	Added <Exm prefix to #include directive.
 * 	[1993/06/11  22:01:21  rosenberg]
 * 
 * Revision 1.1.2.3  1993/05/26  21:49:36  rosenberg
 * 	Added comments.
 * 	[1993/05/26  21:49:16  rosenberg]
 * 
 * Revision 1.1.2.2  1993/05/03  21:17:59  daniel
 * 	add ExmTabButton
 * 	[1993/05/03  21:16:34  daniel]
 * 
 * $EndLog$
 */

/*******************************************************************************
 *
 * TabBP.h: The widget private header file for the ExmTabButton demonstration
 *          widget.
 *
 ******************************************************************************/

/* Ensure that the file be included only once. */
#ifndef _ExmTabBP_h
#define _ExmTabBP_h

/* Include appropriate files. */
#include <Exm/TabB.h> /* public header file for ExmTabButton */
#include <Exm/CommandBP.h> /* private header file for ExmCommandButton */

/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif

/* This widget does not provide any inheritable methods. */


/* Define the widget class part. */
typedef struct _ExmTabButtonClassPart
{
        XtPointer		extension;
} ExmTabButtonClassPart;


/* Define the full class record. */
typedef struct _ExmTabButtonClassRec
{
	CoreClassPart		core_class;
	XmPrimitiveClassPart	primitive_class;
	ExmSimpleClassPart	simple_class;
	ExmStringClassPart	string_class;
	ExmCommandButtonClassPart command_button_class;
	ExmTabButtonClassPart   tab_button_class;
} ExmTabButtonClassRec;

/* Define the subclassing level index to be used with ResolvePartOffset */
#define ExmTabButtonIndex (ExmCommandButtonIndex + 1)

/* Make the full class record externally accessible. */
externalref ExmTabButtonClassRec exmTabButtonClassRec;


/* Define the widget instance part. */
typedef struct _ExmTabButtonPart
{
 /* Provide space for the one resource of ExmTabButton. */
	XtEnum  open_side;
 /* Provide space for the size of the join shadow_thickness */
	Dimension join_shadow_thickness;
} ExmTabButtonPart;


/* Define the full instance record. */
typedef struct _ExmTabButtonRec
{
	CorePart		core;
	XmPrimitivePart		primitive;
	ExmSimplePart		simple;
	ExmStringPart		string;
	ExmCommandButtonPart	command_button;
	ExmTabButtonPart	tab_button;
} ExmTabButtonRec;

/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


/* Ensure that the file be included only once. */
#endif /* _ExmTabBP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
