/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: wsm_funcs.h,v $
 * Revision 1.1.2.1  1994/06/02  15:34:03  marty
 * 	File moved from demos/workspace/wsmLib
 * 	[1994/06/01  21:08:55  marty]
 *
 * 	This file has been moved from demos/workspace/wsmlib.  Refer to that directory for prior history
 *
 * Revision 1.1.2.1  1994/03/23  17:59:20  deblois
 * 	Split wsm library code into mwm and wsm dirs.
 * 	[1994/03/23  17:57:29  deblois]
 * 
 * $EndLog$
 */

#ifndef _WSM_FUNCS_
#define _WSM_FUNCS_

/************************************************************
 *
 *  All function Prototypes for non static functions.
 *
 * Those that begin with _WSM are "private" for whatever that
 * is worth...
 *
 ************************************************************/

/*
 * disp.c
 */

WSMDispInfo * _WSMGetDispInfo(
#ifndef _NO_PROTO
Display *
#endif
);

WSMScreenInfo * _WSMGetScreenInfo(
#ifndef _NO_PROTO
Display *, int
#endif
);


void _WSMClearConfigScreenInfo(
#ifndef _NO_PROTO
Display *, int
#endif
);

WSMConfigFormatData * _WSMGetConfigFormat(
#ifndef _NO_PROTO
Display *, int, WSMConfigFormatType
#endif
);

Atom _WSMGetSelectionAtom(
#ifndef _NO_PROTO
Display *, int, WSMClientType
#endif
);

/*
 * free.c
 */

void FreeRequest(
#ifndef _NO_PROTO
WSMRequest *request
#endif
);

void FreeReply(
#ifndef _NO_PROTO
WSMReply *reply
#endif
);

/*
 * pack.c
 */

MessageData _WSMPackRequest(
#ifndef _NO_PROTO
Display *, int, WSMRequest *, unsigned long *, WSMErrorCode *
#endif
);

MessageData _WSMPackReply(
#ifndef _NO_PROTO
Display *, int, WSMReply *, unsigned long *
#endif
);

void _WSMUnpackRequest(
#ifndef _NO_PROTO
Display *, int, MessageData, unsigned long, WSMRequestType, WSMRequest *
#endif
);

void _WSMUnpackReply(
#ifndef _NO_PROTO
Display *, int, MessageData, unsigned long, WSMRequestType, WSMReply *
#endif
);

MessageData PackString(
#ifndef _NO_PROTO
MessageData, String
#endif
);

String UnpackString(
#ifndef _NO_PROTO
MessageData *
#endif
);

MessageData PackCARD32(
#ifndef _NO_PROTO
MessageData, CARD32
#endif
);

CARD32 UnpackCARD32(
#ifndef _NO_PROTO
MessageData *
#endif
);

/*
 * recv.c
 */

Boolean WSMDefaultOwnSelection(
#ifndef _NO_PROTO
Widget, WSMClientType, WSMRequestCallbackFunc, XtPointer
#endif
);

void WSMRegisterRequestCallback(
#ifndef _NO_PROTO
Display *, int, WSMRequestCallbackFunc, XtPointer
#endif
);

Boolean WSMIsKnownTarget(
#ifndef _NO_PROTO
Widget, Atom
#endif
);

Atom * GetTargetList(
#ifndef _NO_PROTO
Widget, Boolean, unsigned long *
#endif
);

Boolean WSMProcessProtoTarget(
#ifndef _NO_PROTO
Widget, Atom, XtPointer, unsigned long, 
int, Atom *, XtPointer *, unsigned long *, int *
#endif
);

/*
 * send.c
 */

Boolean WSMSendMessage(
#ifndef _NO_PROTO
Widget, WSMClientType, WSMRequest *, WSMReplyCallbackFunc, XtPointer
#endif
);

/*
 * utils.c
 */

String _WSMReqTypeToName(
#ifndef _NO_PROTO
WSMRequestType
#endif
);

WSMRequestType _WSMTargetToReqType(
#ifndef _NO_PROTO
Display *, Atom
#endif
);

Atom _WSMReqTypeToTarget(
#ifndef _NO_PROTO
Display *, WSMRequestType
#endif
);

Boolean _WSMRequiresConfigFormat(
#ifndef _NO_PROTO
WSMRequestType
#endif
);

WSMConfigFormatType _WSMGetConfigFormatType(
#ifndef _NO_PROTO
Window
#endif
);

WSMAttribute * _WSMGetMatchingAttr(
#ifndef _NO_PROTO
XrmQuark, WSMConfigFormatData *
#endif
);

WSMWinData * _WSMGetMatchingWinData(
#ifndef _NO_PROTO
WSMWinData *, int, XrmQuark
#endif
);

#endif /* DO NOT ADD ANYTHING AFTER THIS LINE */
