/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: Help.h,v $
 * Revision 1.1.2.3  1994/07/27  20:59:17  drand
 * 	Fix CR 9877 - Problems with help widget
 * 	[1994/07/27  20:58:52  drand]
 *
 * Revision 1.1.2.2  1994/06/02  20:45:22  drand
 * 	Rename widgets to use Xmd prefix
 * 	[1994/06/02  20:29:57  drand]
 * 
 * Revision 1.1.2.1  1994/06/02  15:34:10  marty
 * 	File moved from demos/utils
 * 	[1994/06/01  21:10:22  marty]
 * 
 * Revision 1.1.2.3  1994/05/11  17:01:23  drand
 * 	More updates
 * 	[1994/05/11  17:01:05  drand]
 * 
 * Revision 1.1.2.2  1994/04/22  20:14:04  drand
 * 	Checkpoint
 * 	[1994/04/22  20:13:36  drand]
 * 
 * Revision 1.1.2.1  1994/04/22  17:24:53  drand
 * 	Initial coding
 * 	[1994/04/22  17:24:30  drand]
 * 
 * $EndLog$
 */

/* Ensure that the file be included only once. */
#ifndef _XmdHelp_h
#define _XmdHelp_h


/* Include appropriate files. */
#include <Xm/Xm.h> /* widget public header file for XmManager */


/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif

/* Define the widget class and widget record. */
externalref WidgetClass xmdHelpWidgetClass;

typedef struct _XmdHelpClassRec * XmdHelpWidgetClass;
typedef struct _XmdHelpRec      * XmdHelpWidget;

/* Define an IsSubclass macro. */
#ifndef XmdIsHelp
#define XmdIsHelp(w) XtIsSubclass(w, XmdHelpWidgetClass)
#endif

#define XmdNhelpFile		"helpFile"
#define XmdCHelpFile		"HelpFile"
#define XmdNhelpPath		"helpPath"
#define XmdCHelpPath		"HelpPath"
#define XmdNboldFontName	"boldFontName"
#define XmdNemphasisFontName	"emphasisFontName"
#define XmdNdefaultFontName	"defaultFontName"
#define XmdNheadingFontName	"headingFontName"
#define XmdNtitleFontName	"titleFontName"

/* Specify the API for this widget. */
#ifdef _NO_PROTO
extern Widget XmdCreateHelp();
extern Widget XmdCreateHelpDialog();
extern void XmdGotoHelpItem();
#else
extern Widget XmdCreateHelp(
			Widget parent,
			char   *name,
			ArgList arglist,
			Cardinal argcount);
extern Widget XmdCreateHelpDialog(
			Widget parent,
			char   *name,
			ArgList arglist,
			Cardinal argcount);
/* XtCallbackProc for use with help callbacks, don't forget to
   include the help widget in the call */
extern void XmdGotoHelpItem(Widget w, int item, Widget help);
#endif

/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


/* Ensure that the file be included only once. */
#endif /* _XmdHelp_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */

