/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: HelpP.h,v $
 * Revision 1.1.2.2  1994/06/02  20:45:24  drand
 * 	Rename widgets to use Xmd prefix
 * 	[1994/06/02  20:29:58  drand]
 *
 * Revision 1.1.2.1  1994/06/02  15:34:11  marty
 * 	File moved from demos/utils
 * 	[1994/06/01  21:10:25  marty]
 * 
 * Revision 1.1.2.6  1994/05/11  17:01:25  drand
 * 	More updates
 * 	[1994/05/11  17:01:06  drand]
 * 
 * Revision 1.1.2.5  1994/05/02  18:47:50  drand
 * 	Made help widget use rendertable
 * 	[1994/05/02  18:47:22  drand]
 * 
 * Revision 1.1.2.4  1994/04/27  21:22:20  drand
 * 	Make subclass of XmManager
 * 	[1994/04/27  21:22:03  drand]
 * 
 * Revision 1.1.2.3  1994/04/27  18:47:16  drand
 * 	Changed to use Notebook
 * 	[1994/04/27  18:46:56  drand]
 * 
 * Revision 1.1.2.2  1994/04/22  20:14:05  drand
 * 	Checkpoint
 * 	[1994/04/22  20:13:37  drand]
 * 
 * Revision 1.1.2.1  1994/04/22  17:24:55  drand
 * 	Initial coding
 * 	[1994/04/22  17:24:31  drand]
 * 
 * $EndLog$
 */

/* Ensure that the file be included only once. */
#ifndef _XmdHelpP_h
#define _XmdHelpP_h


/* Include appropriate files. */
#include "Help.h" 
#include <Xm/ManagerP.h>

/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  XtPointer		extension;
} XmdHelpClassPart;

/* Define the full class record. */
typedef struct _XmdHelpClassRec
{
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	XmManagerClassPart	manager_class;
	XmdHelpClassPart	help_class;
} XmdHelpClassRec;

externalref XmdHelpClassRec xmdHelpClassRec;

/* Define the widget instance part. */
typedef struct
{
	char*			help_path;
	char*			help_file;
	XmRenderTable		rendertable;
	Dimension		spacing;
  	/* Internal instance fields */
 	Cardinal		num_titles;
	Cardinal		allocated_titles;
  	XmStringTable		titles;
	XmStringTable		help_text;
	/* Internal widgets (but in child list) */
	Widget			notebook;
	Widget			text_display;
	Widget			dismiss;
} XmdHelpPart;

/* Define the full instance record. */
typedef struct _XmdHelpRec
{
	CorePart		core;
	CompositePart		composite;
	ConstraintPart		constraint;
	XmManagerPart		manager;
	XmdHelpPart		help;
} XmdHelpRec;

/* Define the subclassing level index to be used with ResolvePartOffset */
#define XmdHelpIndex (XmManagerIndex + 1)

/* Define the constraint part structure. */
typedef struct _XmdHelpConstraintPart
{
  int		dummy;
} XmdHelpConstraintPart, * XmdHelpConstraint;

/* Define the full constraint structure. */
typedef struct _XmdHelpConstraintRec
{
	XmManagerConstraintPart	manager;
	XmdHelpConstraintPart	help;
} XmdHelpConstraintRec, * XmdHelpConstraintPtr;

/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


/* Ensure that the file be included only once. */
#endif /* _XmdHelpP_h */

