/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: Print.h,v $
 * Revision 1.1.2.2  1994/06/02  20:45:35  drand
 * 	Rename widgets to use Xmd prefix
 * 	[1994/06/02  20:30:06  drand]
 *
 * Revision 1.1.2.1  1994/06/02  15:34:18  marty
 * 	File moved from demos/utils
 * 	[1994/06/01  21:10:27  marty]
 * 
 * Revision 1.1.2.1  1994/04/29  19:35:00  drand
 * 	Initial work complete
 * 	[1994/04/29  19:34:09  drand]
 * 
 * 	Initial coding
 * 	[1994/04/28  21:54:32  drand]
 * 
 * $EndLog$
 */

/* Ensure that the file be included only once. */
#ifndef _XmdPrint_h
#define _XmdPrint_h


/* Include appropriate files. */
#include <Xm/Xm.h> /* widget public header file for XmManager */

/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif

/* Define the widget class and widget record. */
externalref WidgetClass xmdPrintWidgetClass;

typedef struct _XmdPrintClassRec * XmdPrintWidgetClass;
typedef struct _XmdPrintRec      * XmdPrintWidget;

/* Define an IsSubclass macro. */
#ifndef XmdIsPrint
#define XmdIsPrint(w) XtIsSubclass(w, XmdPrintWidgetClass)
#endif

#define XmdNprinterList		"printerList"
#define XmdCPrinterList		"PrinterList"
#define XmdNprintAll		"printAll"
#define XmdCPrintAll		"PrintAll"
#define XmdNtwoSided		"twoSided"
#define XmdCTwoSided		"TwoSided"
#define XmdNreverseOrder	"reverseOrder"
#define XmdCReverseOrder	"ReverseOrder"
#define XmdNfromPage		"fromPage"
#define XmdCFromPage		"FromPage"
#define XmdNtoPage		"toPage"
#define XmdCToPage		"ToPage"
#define XmdNnumberOfCopies	"numberOfCopies"
#define XmdCNumberOfCopies	"NumberOfCopies"
#define XmdNprintCallback	"printCallback"

/* Print callback */
typedef struct _XmdPrintCallbackStruct {
  int		reason; 	/* Always XmCR_OK */
  XEvent	*event;		/* Always NULL */
  Boolean	two_sided;	/* True if should print double sided */
  Boolean	reverse_order;	/* True if should reverse order */
  Boolean	to_printer;	/* True if output should go to printer */
  int		first;		/* First page to print.  If first==last==0 */
  int		last;		/* then print all pages */
  int		copies;		/* how many copies to print */
  char*		printer;	/* Name of printer or path of file */
} XmdPrintCallbackStruct;

/* Specify the API for this widget. */
#ifdef _NO_PROTO
extern Widget XmdCreatePrint();
extern Widget XmdCreatePrintDialog();
extern void XmdPrintDocument();
#else
extern Widget XmdCreatePrint(
			Widget parent,
			char   *name,
			ArgList arglist,
			Cardinal argcount);
extern Widget XmdCreatePrintDialog(
			Widget parent,
			char   *name,
			ArgList arglist,
			Cardinal argcount);
extern void XmdPrintDocument(char* pathname,
			     XmdPrintCallbackStruct* cb);
#endif

/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


/* Ensure that the file be included only once. */
#endif /* _XmdPrint_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */

