/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: PrintP.h,v $
 * Revision 1.1.2.2  1994/06/02  20:45:36  drand
 * 	Rename widgets to use Xmd prefix
 * 	[1994/06/02  20:30:08  drand]
 *
 * Revision 1.1.2.1  1994/06/02  15:34:19  marty
 * 	File moved from demos/utils
 * 	[1994/06/01  21:10:28  marty]
 * 
 * Revision 1.1.2.1  1994/04/29  19:35:04  drand
 * 	Initial work complete
 * 	[1994/04/29  19:34:06  drand]
 * 
 * 	Initial coding
 * 	[1994/04/29  17:53:26  drand]
 * 
 * $EndLog$
 */

/* Ensure that the file be included only once. */
#ifndef _XmdPrintP_h
#define _XmdPrintP_h

/* Include appropriate files. */
#include "Print.h" 
#include <Xm/FormP.h>

/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  XtPointer		extension;
} XmdPrintClassPart;

/* Define the full class record. */
typedef struct _XmdPrintClassRec
{
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	XmManagerClassPart	manager_class;
	XmBulletinBoardClassPart  bulletin_board_class;
	XmFormClassPart     	form_class;
	XmdPrintClassPart	print_class;
} XmdPrintClassRec;

externalref XmdPrintClassRec xmdPrintClassRec;

/* Define the widget instance part. */
typedef struct
{
	char*			printer_list;
	Boolean			two_sided;
	Boolean			reverse_order;
	Boolean			print_all;
	int			from_page;
	int			to_page;
	int			number_of_copies;
	XtCallbackList		print_callback;
  	/* Internal instance fields */
 	Cardinal		num_printers;
	char**			printers;
	Boolean*		is_printer;
	Boolean			adding_printer;
	/* Internal widgets which require access */
	Widget			copies_tf;
	Widget			two_sided_toggle;
	Widget			reverse_order_toggle;
	Widget			from_all_rc;
	Widget			from_tf;
	Widget			to_tf;
	Widget			from_toggle;
	Widget			all_toggle;
	Widget			destination_om;
	Widget			destination_pd;
	Widget			new_printer_dialog;
	Cardinal		num_om_items;
	WidgetList		om_items;
} XmdPrintPart;

/* Define the full instance record. */
typedef struct _XmdPrintRec
{
	CorePart		core;
	CompositePart		composite;
	ConstraintPart		constraint;
	XmManagerPart		manager;
	XmBulletinBoardPart 	bulletin_board;
	XmFormPart     		form;
	XmdPrintPart		print;
} XmdPrintRec;

/* Define the constraint part structure. */
typedef struct _XmdPrintConstraintPart
{
  int		dummy;
} XmdPrintConstraintPart, * XmdPrintConstraint;

/* Define the full constraint structure. */
typedef struct _XmdPrintConstraintRec
{
	XmManagerConstraintPart	manager;
	/* No bulletin board constraint part */
	XmFormConstraintPart    form;
	XmdPrintConstraintPart	print;
} XmdPrintConstraintRec, * XmdPrintConstraintPtr;

/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


/* Ensure that the file be included only once. */
#endif /* _XmdPrintP_h */

