/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: onHelp.c,v $
 * Revision 1.1.2.2  1994/06/02  20:45:38  drand
 * 	Rename widgets to use Xmd prefix
 * 	[1994/06/02  20:30:09  drand]
 *
 * Revision 1.1.2.1  1994/06/02  15:34:27  marty
 * 	File moved from demos/utils
 * 	[1994/06/01  21:10:21  marty]
 * 
 * Revision 1.1.2.4  1994/05/11  17:01:27  drand
 * 	More updates
 * 	[1994/05/11  17:01:08  drand]
 * 
 * Revision 1.1.2.3  1994/05/02  18:47:53  drand
 * 	Made help widget use rendertable
 * 	[1994/05/02  18:47:25  drand]
 * 
 * Revision 1.1.2.2  1994/04/25  21:29:32  drand
 * 	Use Xmd menu creation
 * 	[1994/04/25  21:28:44  drand]
 * 
 * Revision 1.1.2.1  1994/04/22  20:14:09  drand
 * 	Checkpoint
 * 	[1994/04/22  20:13:40  drand]
 * 
 * $EndLog$
 */

#include <Xm/Xm.h>
#include "Help.h"

void quitCB( widget, tag, callback_data )
     Widget	widget;
     char       *tag;
     XmAnyCallbackStruct *callback_data;
{
  exit(0);
}

/*
 *  Main program
 */
int main(argc, argv)
     int    argc;
     String argv[];
{
  Arg	args[10];
  XtAppContext app_context;
  int n;
  Widget toplevel, help;
  Cardinal size;
  XmRendition rend[10];
  XmRenderTable rt;
  int i;
  XmTab tabs[5];
  XmTabList tablist;
  Widget dismiss;

  toplevel = XtVaAppInitialize(&app_context, "HelpOnHelp", NULL, 0, 
			       &argc, argv, NULL, 0);
  n = 0;
  XtSetArg(args[n], XmdNhelpFile, "helpOn"); n++;
  help = XmdCreateHelp(toplevel, "help", args, n);
  dismiss = XtNameToWidget(help, "*Dismiss");
  XtAddCallback(dismiss, XmNactivateCallback,
		(XtCallbackProc) quitCB, NULL);
  /* Get the rendertable and add some new renditions */
  XtVaGetValues(help, XmNrenderTable, &rt, NULL, NULL);
  /* Make the tabs for the tables */
  n = 0;
  tabs[n] = XmTabCreate(2.0, XmINCHES, XmABSOLUTE,
			XmALIGNMENT_BEGINNING, NULL); n++;
  tabs[n] = XmTabCreate(4.0, XmINCHES, XmABSOLUTE,
			XmALIGNMENT_BEGINNING, NULL); n++;
  tablist = XmTabListInsertTabs(NULL, tabs, n, 0);
  for(i = 0; i < n; i++) XmTabFree(tabs[i]);

  /* Add extra renditions needed for the help file */
  n = 0; i = 0;
  XtSetArg(args[n], XmNtabList, tablist); n++;
  rend[i] = XmRenditionCreate(help, "table", args, n); i++;
  n = 0;
  XtSetArg(args[n], XmNfontName, "*courier-medium-r-*-12-*"); n++;
  XtSetArg(args[n], XmNfontType, XmFONT_IS_FONT); n++;
  rend[i] = XmRenditionCreate(help, "program", args, n); i++; 
  n = 0;
  XtSetArg(args[n], XmNunderlineType, XmSINGLE_LINE); n++;
  rend[i] = XmRenditionCreate(help, "underline", args, n); i++; 
  /* Make a copy so that setvalues will work correctly */
  rt = XmRenderTableCopy(rt, NULL, 0);
  rt = XmRenderTableAddRenditions(rt, rend, i, XmMERGE_NEW);
  for(n = 0; n < i; n++) XmRenditionFree(rend[n]);

  XtVaSetValues(help, XmNrenderTable, rt, NULL, NULL);
  XmRenderTableFree(rt);

  XtManageChild(help);

  XtRealizeWidget(toplevel);

  XtAppMainLoop(app_context);
}
