/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: exm_in_c.c,v $
 * Revision 1.1.2.1  1994/07/21  15:13:29  drand
 * 	Updated for final
 * 	[1994/07/21  15:13:04  drand]
 *
 * Revision 1.1.2.1  1994/06/07  14:42:09  marty
 * 	file moved from emos/widgets/Exm/exm_app_in_c
 * 	[1994/06/07  14:41:47  marty]
 * 
 * Revision 1.1.8.1  1994/05/23  15:38:34  drand
 * 	Fix build errors
 * 	[1994/05/23  15:38:12  drand]
 * 
 * Revision 1.1.6.7  1994/05/17  15:57:23  yak
 * 	Fixed a compile error on Sun
 * 	[1994/05/17  15:52:55  yak]
 * 
 * Revision 1.1.6.6  1994/04/04  15:33:26  drand
 * 	Fix arglist for CreateTemplateDialog
 * 	[1994/04/04  15:32:12  drand]
 * 
 * Revision 1.1.6.5  1994/03/31  16:05:27  rosenberg
 * 	Added XmNdefaultButton on MessageBox to test CommandButton
 * 	[1994/03/31  16:04:25  rosenberg]
 * 
 * Revision 1.1.6.4  1994/03/15  21:58:32  drand
 * 	Added use of mnemonic and accelerators for menubutton
 * 	[1994/03/15  21:58:14  drand]
 * 
 * Revision 1.1.6.3  1994/03/15  16:59:57  rosenberg
 * 	Placed the ExmCommandButton widgets inside a Template MessageBox.
 * 	[1994/03/15  16:59:38  rosenberg]
 * 
 * Revision 1.1.6.2  1994/03/11  15:25:42  rosenberg
 * 	Removed two ExmSimple widgets;
 * 	Removed ExmExercisePannerWidgets routine (just
 * 	exercise Panner from main).
 * 	[1994/03/11  15:25:19  rosenberg]
 * 
 * Revision 1.1.6.1  1994/02/02  21:50:35  rosenberg
 * 	Added a help system to the program
 * 	[1994/02/02  21:50:12  rosenberg]
 * 
 * Revision 1.1.4.5  1993/11/17  19:59:33  rosenberg
 * 	Added code to demonstrate ExmPanner.
 * 	[1993/11/17  19:32:22  rosenberg]
 * 
 * Revision 1.1.4.4  1993/11/04  21:06:55  rosenberg
 * 	Checked in ahead of disk swap
 * 	[1993/11/04  21:06:38  rosenberg]
 * 
 * Revision 1.1.4.3  1993/10/05  17:42:10  rosenberg
 * 	Reorganized the application.
 * 	[1993/10/05  17:41:54  rosenberg]
 * 
 * Revision 1.1.4.2  1993/09/14  22:23:53  rosenberg
 * 	Changed organization of program; started calling exmMenuButton
 * 	[1993/09/14  22:23:26  rosenberg]
 * 
 * Revision 1.1.2.6  1993/07/27  17:25:35  drk
 * 	Fixup prototypes.
 * 	[1993/07/27  14:30:57  drk]
 * 
 * Revision 1.1.2.5  1993/07/21  20:43:46  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:22:00  yak]
 * 
 * Revision 1.1.2.4  1993/07/08  21:36:32  rom
 * 	Convert two String widgets to be StringTransfer widgets instead.
 * 	[1993/07/08  21:20:19  rom]
 * 
 * Revision 1.1.2.3  1993/06/25  18:37:24  rosenberg
 * 	Demonstrates ExmSimple, ExmString, ExmGrid, ExmCommandButton.
 * 	The ExmPanner, ExmTabButton, and ExmMenuButton widgets will be
 * 	demonstrated in a later version of this demo.
 * 	[1993/06/25  18:37:03  rosenberg]
 * 
 * Revision 1.1.2.2  1993/05/26  22:26:15  rosenberg
 * 	First cut; it demonstrates just how screwed up geometry management
 * 	is in the ExmGrid widget.
 * 	[1993/05/26  22:25:53  rosenberg]
 * 
 * 	Daniel created this program to instantiate the Exm widgets.
 * 	[1993/05/21  19:08:23  rosenberg]
 * 
 * $EndLog$
 */


/*******************************************************************************
 *
 * AllExmDemo.c: This is a sample application written in C that instantiates
 *               all of the Exm widgets. 
 *
 ******************************************************************************/

#include <Xm/Xm.h>
#include <Xm/CascadeB.h>
#include <Xm/MainW.h>
#include <Xm/MessageB.h>
#include <Xm/Notebook.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrollFrameT.h>
#include <Exm/Simple.h>
#include <Exm/String.h>
#include <Exm/StringTrans.h>
#include <Exm/CommandB.h>
#include <Exm/Grid.h>
#include <Exm/TabB.h>
#include <Exm/Panner.h>
#include <Exm/MenuB.h>


#ifdef _NO_PROTO
void CreateMenus();
void ExerciseExmSimpleWidgets();
void ExerciseExmStringWidgets(); 
void ExerciseExmStringTransferWidgets();
void ExerciseExmCommandButtonWidgets();
void ExerciseExmTabButtonWidget();
void QuitCB();
void HelpCB();
void DanceCB();
void YesCB(); 
void NoCB(); 
#else
void CreateMenus(Widget);
void ExerciseExmSimpleWidgets(Widget);
void ExerciseExmStringWidgets(Widget); 
void ExerciseExmStringTransferWidgets(Widget);
void ExerciseExmCommandButtonWidgets(Widget);
void ExerciseExmTabButtonWidget(Widget);
void QuitCB(Widget, XtPointer, XtPointer);
void HelpCB(Widget, XtPointer, XtPointer);
void DanceCB(Widget, XtPointer, XtPointer);
void YesCB(Widget, XtPointer, XtPointer); 
void NoCB(Widget, XtPointer, XtPointer); 
#endif /* _NO_PROTO */

Widget   top_level, MainWindow;
enum WidgetN {SimpleH=0, StringH, StringTransferH, CommandButtonH,
              TabButtonH, PannerH, MenuButtonH, GridH};

int 
#ifdef _NO_PROTO
main(argc, argv)
     int argc;
     char **argv;
#else
main(int argc, char **argv)
#endif /* _NO_PROTO */
{
 static Widget  Frame1; 
 XtAppContext   app_context;
 Arg            MainWindowArgs[6];
 Arg            args[12];
 Cardinal       n;
 Widget         Grid;
 Widget         Panner1;
 Widget         Label1;
   
   top_level = XtAppInitialize(&app_context, "Test", NULL, 0,
                               &argc, argv, NULL, NULL, 0);

   n=0;
   XtSetArg(MainWindowArgs[n], XmNscrollingPolicy, XmAUTOMATIC); n++;
   XtSetArg(MainWindowArgs[n], XmNwidth, 400); n++;
   XtSetArg(MainWindowArgs[n], XmNheight, 400); n++;
   MainWindow = (Widget)XmCreateMainWindow(top_level, "MainWindow", 
                                           MainWindowArgs, n);
   XtManageChild (MainWindow);

   CreateMenus(MainWindow);

 /* An ExmGrid manager widget will manage most of the Exm primitives. */
   Grid = XtVaCreateManagedWidget ("Grid",
                                   exmGridWidgetClass, MainWindow,
                                   XmNrows, 3,
                                   XmNcolumns, 4,
                                   NULL);
   XtAddCallback (Grid, XmNhelpCallback, 
                  HelpCB, (XtPointer)GridH);

   ExerciseExmSimpleWidgets(Grid);
   ExerciseExmStringWidgets(Grid); 
   ExerciseExmStringTransferWidgets(Grid);
   ExerciseExmTabButtonWidget(Grid);
   
   
 /* This section exercises the ExmPanner widget. */
   n=0;
   XtSetArg(args[n], XmNwidth, 150); n++;
   XtSetArg(args[n], XmNheight, 150); n++;
   XtSetArg(args[n], XmNscrolledWindowChildType, XmMESSAGE_WINDOW); n++;
   /* XtSetArg(args[n], ExmNresize, False); n++; */
   Panner1 = XtCreateWidget ("Panner1", exmPannerWidgetClass, MainWindow,
                              args, n); 
   XtAddCallback(Panner1, XmNhelpCallback, HelpCB, (XtPointer)PannerH);
   XtManageChild(Panner1);

   {
    XmScrollFrameTrait  sf_trait = 
        (XmScrollFrameTrait) XmeTraitGet((XtPointer)XtClass(MainWindow),
                                         XmQTscrollFrame);
    sf_trait->addNavigator(MainWindow, Panner1, 
                           NavigDimensionX|NavigDimensionY);
   }


   XtRealizeWidget(top_level);
   XtAppMainLoop(app_context);
}


/*******************************************************************************
 *
 * CreateMenus: 
 *      This function generates the menu bar and the submenus. 
 *      It exercises the ExmMenuButton widget.
 *
 ******************************************************************************/
void 
#ifdef _NO_PROTO
CreateMenus (parent_of_menu_bar)
     Widget parent_of_menu_bar;
#else
CreateMenus(Widget parent_of_menu_bar)
#endif
{
 static Widget  PullDownFromFile, PullDownFromHelp;
 static Widget  HelpWidget, menu_bar, QuitWidget;
 char           menu_button_name[24];
 static Widget  MenuButtonWidget[8];
 XmString       file_string, quit_string, help_cs, menu_as_a_cs,
                acc_string;
 int            menu_num;
 static char          *menu_help_string[] = {
                                 "ExmSimple",
                                 "ExmString",
                                 "ExmStringTransfer",
                                 "ExmCommandButton",
                                 "ExmTabButton",
                                 "ExmPanner",
                                 "ExmMenuButton",
                                 "ExmGrid"
                                };
 static char		menu_help_mnemonics[] = "ESTCBPMG";
 int            n;
 Arg            args[10] ;
 

 /* Create a MenuBar in MainWindow. */
   n = 0;
   menu_bar = (Widget)XmCreateMenuBar (parent_of_menu_bar, "menu_bar", 
                                       args, n); 
   XtManageChild (menu_bar);

 /* Create a context for the pulldown menu. */ 
   n = 0;
   PullDownFromFile = (Widget)XmCreatePulldownMenu (menu_bar, "file_pane", args, n);

 /* Place the "File" cascade button at the top of the pulldown. */ 
   file_string = XmStringCreateSimple("File");
   XtVaCreateManagedWidget("File", xmCascadeButtonWidgetClass, menu_bar,
                           XmNlabelString, file_string,
			   XmNmnemonic, 'F',
                           XmNsubMenuId, PullDownFromFile,  
                           NULL);

 /* Create the entries pulled down by pressing "File" */ 
   quit_string = XmStringCreateSimple("Quit");
   acc_string = XmStringCreateSimple("Alt-q");

   QuitWidget = XtVaCreateManagedWidget("Quit", 
					exmMenuButtonWidgetClass, 
					PullDownFromFile,
					ExmNcompoundString, quit_string,
					XmNmnemonic, 'Q',
					XmNacceleratorText, acc_string,
					XmNaccelerator, "Alt<Key>q",
					NULL);
   XtAddCallback (QuitWidget, XmNactivateCallback, QuitCB, NULL);
   XmStringFree(file_string);
   XmStringFree(quit_string);
   XmStringFree(acc_string);


 /* Create "Help" PulldownMenu with Help button.  */
   n = 0;
   PullDownFromHelp = (Widget)(XmCreatePulldownMenu (menu_bar, "help_pane", 
                                                     args, n));

 /* Place the "Help" cascade button at the top of the pulldown. */ 
   help_cs = XmStringCreateSimple("Help");
   HelpWidget = XtVaCreateManagedWidget("Help", xmCascadeButtonWidgetClass, 
                                        menu_bar,
                                        XmNlabelString, help_cs,
					XmNmnemonic, 'H',
                                        XmNsubMenuId, PullDownFromHelp,  
                                        NULL);
 /* Make sure that the "Help" button appears in the appropriate place within
    the menubar. */
   XtVaSetValues(menu_bar, XmNmenuHelpWidget, HelpWidget, NULL);


   for (menu_num=0; menu_num<8; menu_num++)   {
      char mnemonic_char;

      sprintf(menu_button_name, "Menu Button %d", menu_num);
      menu_as_a_cs = XmStringCreateSimple(menu_help_string[menu_num]);
      mnemonic_char = menu_help_mnemonics[menu_num];
      MenuButtonWidget[menu_num] = 
	XtVaCreateManagedWidget(menu_button_name,
                                exmMenuButtonWidgetClass, PullDownFromHelp,
                                ExmNcompoundString, menu_as_a_cs, 
				XmNmnemonic, mnemonic_char,
                                NULL);
      XtAddCallback (MenuButtonWidget[menu_num], XmNactivateCallback, 
                     HelpCB, (XtPointer)menu_num);
      XmStringFree(menu_as_a_cs);
   }

}



/*******************************************************************************
 *
 * ExerciseExmSimpleWidgets: 
 *       This function instantiates two ExmSimple widgets.
 *
 ******************************************************************************/
void
#ifdef _NO_PROTO
ExerciseExmSimpleWidgets(parent_handle)
     Widget parent_handle;
#else
ExerciseExmSimpleWidgets(Widget parent_handle)
#endif
{
 Widget       Simple1, Simple2;
 Arg          args[10];
 Cardinal     n = 0;

 /* Instantiate two ExmSimple widgets. */
   Simple1 = ExmCreateSimple(parent_handle, "Simple1", args, 0);
   XtAddCallback(Simple1, XmNhelpCallback, HelpCB, (XtPointer)SimpleH);

   Simple2 = ExmCreateSimple(parent_handle, "Simple3", args, 0);
   XtVaSetValues (Simple2,
                  ExmNsimpleShape, ExmSHAPE_RECTANGLE,
                  XmNunitType,     Xm100TH_MILLIMETERS,
                  XmNsensitive,    False,
                  XmNmarginWidth,  300,
                  XmNmarginHeight, 2000,
                  NULL);
   XtAddCallback(Simple2, XmNhelpCallback, HelpCB, (XtPointer)SimpleH);

   XtManageChild(Simple1);  XtManageChild(Simple2); 
}


/*******************************************************************************
 *
 * ExerciseExmStringWidgets: 
 *       This function instantiates four ExmString widgets.
 *
 ******************************************************************************/
void
#ifdef _NO_PROTO
ExerciseExmStringWidgets(parent_handle)
     Widget parent_handle;
#else
ExerciseExmStringWidgets(Widget parent_handle)
#endif
{
 Widget       String1, String2;
 XmString     a_compound_string;

  a_compound_string = XmStringCreateLtoR("A Multiline Compound String\nIn an\n\
ExmString widget.\0", XmFONTLIST_DEFAULT_TAG);


/* Instantiate two ExmString widgets. */
  String1 = XtVaCreateManagedWidget("String1",
                                    exmStringWidgetClass, parent_handle,
                                    ExmNcompoundString,  a_compound_string, 
                                    NULL);
  
  String2 = XtVaCreateManagedWidget("String2",
                                    exmStringWidgetClass, parent_handle,
                                    XmNalignment,        XmALIGNMENT_BEGINNING,
                                    ExmNcompoundString,  a_compound_string,
                                    NULL);
}


/*******************************************************************************
 *
 * ExerciseExmStringTransferWidgets: 
 *       This function instantiates two ExmStringTransfer widgets.
 *
 ******************************************************************************/
void
#ifdef _NO_PROTO
ExerciseExmStringTransferWidgets(parent_handle)
     Widget parent_handle;
#else
ExerciseExmStringTransferWidgets(Widget parent_handle)
#endif
{
 XmString     transfer_cstring_1, transfer_cstring_2;
 Widget       StringTransfer1, StringTransfer2;

  transfer_cstring_1 = XmStringCreateLocalized("ExmStringTransfer 1");
  transfer_cstring_2 = XmStringCreateLocalized("ExmStringTransfer 2");

  StringTransfer1 = XtVaCreateManagedWidget("StringTransfer1",
                             exmStringTransferWidgetClass, parent_handle,
                             XmNstringDirection,  XmSTRING_DIRECTION_L_TO_R,
                             ExmNcompoundString,  transfer_cstring_1,
                             NULL);
  XtAddCallback(StringTransfer1, XmNhelpCallback, 
                HelpCB, (XtPointer)StringTransferH);
  
  StringTransfer2 = XtVaCreateManagedWidget("StringTransfer2",
                             exmStringTransferWidgetClass, parent_handle,
                             XmNalignment,        XmALIGNMENT_END,
                             ExmNcompoundString,  transfer_cstring_2,
                             NULL);
  XtAddCallback(StringTransfer2, XmNhelpCallback, 
                HelpCB, (XtPointer)StringTransferH);
}


/*******************************************************************************
 *
 * ExerciseExmTabButtonWidget: 
 *       This function instantiates one ExmTabButton widget and one
 *       XmNotebook function.  The ExmTabButton will serve as the tab
 *       of the XmNotebook. 
 *
 ******************************************************************************/
void
#ifdef _NO_PROTO
ExerciseExmTabButtonWidget(parent_handle)
     Widget parent_handle;
#else
ExerciseExmTabButtonWidget(Widget parent_handle)
#endif
{
 Widget  Notebook1, TabButton1;
 XmString  tab_button_string;

/* Instantiate an XmNotebook widget. */
  Notebook1 = XtVaCreateManagedWidget("Notebook1", 
                                    xmNotebookWidgetClass, parent_handle,
                                    NULL);

/* Instantiate an ExmTabButton widget hanging off the XmNotebook. */ 
  tab_button_string = XmStringCreateLocalized("Tab But");
  TabButton1 = XtVaCreateManagedWidget("TabButton1",
                                    exmTabButtonWidgetClass, Notebook1, 
                                    ExmNcompoundString, tab_button_string,
                                    ExmNopenSide, XmLEFT,
                                    NULL); 
  XtAddCallback(TabButton1, XmNhelpCallback, HelpCB, (XtPointer)TabButtonH);
}


/*******************************************************************************
 *
 * ExerciseExmCommandButtonWidgets: 
 *       This function instantiates two ExmCommandButton widgets.
 *
 ******************************************************************************/
void
#ifdef _NO_PROTO
ExerciseExmCommandButtonWidgets(parent_handle)
     Widget parent_handle;
#else
ExerciseExmCommandButtonWidgets(Widget parent_handle)
#endif
{
 XmString  really_quit, yes, no, dance, help;
 Widget    String1, TemplateDialog;
 Widget    CommandButton1, CommandButton2, CommandButton3, CommandButton4;
 Arg       arg[3];

  really_quit = XmStringCreateLtoR("Do you really want to quit?\0",
                                             XmFONTLIST_DEFAULT_TAG);

  yes = XmStringCreateLtoR("Yes\0", XmFONTLIST_DEFAULT_TAG);
  no  = XmStringCreateLtoR("No\0", XmFONTLIST_DEFAULT_TAG);
  dance = XmStringCreateLtoR("No, I want to\ndance instead.\0",
                                             XmFONTLIST_DEFAULT_TAG);
  help = XmStringCreateLtoR("Help\0", XmFONTLIST_DEFAULT_TAG);


 /* Create a MessageBox to which we can attach ExmCommandButton's. */ 
  TemplateDialog = XmCreateTemplateDialog(parent_handle, "QuitNow?", NULL, 0);

  String1 = XtVaCreateManagedWidget("String1",
                                    exmStringWidgetClass,
                                    TemplateDialog,
				    XmNshadowThickness, 0,	
                                    ExmNcompoundString,  really_quit, 
                                    NULL);

  CommandButton1 = XtVaCreateManagedWidget("CommandButton1",
                                    exmCommandButtonWidgetClass, 
                                    TemplateDialog,
                                    ExmNcompoundString,  yes, 
                                    NULL);
  XtAddCallback(CommandButton1, XmNactivateCallback, YesCB, NULL);
  XtAddCallback(CommandButton1, XmNhelpCallback, HelpCB, (XtPointer)CommandButtonH);
 /* Make CommandButton1 the initial default button of the MessageBox. */ 
  XtVaSetValues(TemplateDialog, 
                XmNdefaultButton, CommandButton1,
                NULL);

  CommandButton2 = XtVaCreateManagedWidget("CommandButton2",
                                    exmCommandButtonWidgetClass, 
                                    TemplateDialog,
                                    ExmNcompoundString,  no, 
                                    NULL);
  XtAddCallback(CommandButton2, XmNactivateCallback, NoCB, NULL);
  XtAddCallback(CommandButton2, XmNhelpCallback, HelpCB, (XtPointer)CommandButtonH);

  CommandButton3 = XtVaCreateManagedWidget("CommandButton3",
                                    exmCommandButtonWidgetClass, 
                                    TemplateDialog,
                                    XmNalignment,        XmALIGNMENT_BEGINNING,
                                    ExmNcompoundString,  dance, 
                                    NULL);
  XtAddCallback(CommandButton3, XmNactivateCallback, DanceCB, NULL);
  XtAddCallback(CommandButton3, XmNhelpCallback, HelpCB, (XtPointer)CommandButtonH);

  CommandButton4 = XtVaCreateManagedWidget("CommandButton4",
                                    exmCommandButtonWidgetClass, 
                                    TemplateDialog,
                                    ExmNcompoundString,  help, 
                                    NULL);
  XtAddCallback(CommandButton4, XmNactivateCallback, HelpCB, (XtPointer)CommandButtonH);
  XtAddCallback(CommandButton4, XmNhelpCallback, HelpCB, (XtPointer)CommandButtonH);

  XtManageChild(TemplateDialog);
}


/*******************************************************************************
 *
 * QuitCB: 
 *     Callback that causes application to exit. 
 *
 ******************************************************************************/
void
#ifdef _NO_PROTO
QuitCB(w, cd, cb)
     Widget w;
     XtPointer cd;
     XtPointer cb;
#else
QuitCB(Widget w, 
       XtPointer cd, 
       XtPointer cb)
#endif 
{
  ExerciseExmCommandButtonWidgets(top_level);
}



/*******************************************************************************
 *
 * HelpCB: 
 *     Callback that causes application to exit. 
 *
 ******************************************************************************/
void
#ifdef _NO_PROTO
HelpCB(w, cd, cb)
     Widget w;
     XtPointer cd;
     XtPointer cb;
#else
HelpCB(Widget w, 
       XtPointer cd, 
       XtPointer cb)
#endif 
{
 int       what_kind_of_help = (int)cd;  
static char      *messages[] = {
"ExmSimple displays one oval or rectangle.\n",
"ExmString displays one compound string.\n", 
"ExmStringTransfer demonstrates Drag and Drop.\
 To transfer text between two ExmStringTransfer widgets:\n\
   1. Place the cursor anywhere inside the widget, \n\
   2. Depress M2.\n\
   3. Move the cursor to another ExmStringTransferWidget.\n\
   4. Release M2.",
"ExmCommandButton displays a compound string.  \n\
This widget can serve as a button inside a dialog box.",
"ExmTabButton displays a compound string.  It can affix itself\n\
to one side of a suitable host widget (like an XmNotebook).", 
"ExmPanner is a two-dimensional navigator widget.\n\
To navigate with the ExmPanner,\n\
  1. Place the cursor over the rectangular slider.\n\
  2. Depress M1.\n\
  3. Move the cursor around.  As you do, the viewport will change.\n\
  4. Release M1 to stop navigating.\n\
Note that there are additional ways to navigate.", 
"ExmMenuButton displays a compound string.  This widget can serve\n\
as a button inside a menu.", 
"ExmGrid is a sample Manager widget.  In this application, ExmGrid\n\
 manages two ExmSimple widgets, two ExmString widgets, two\n\
 ExmStringTransfer widgets, and one XmNotebook widget."
                         }; 
 XmString  message_as_a_cs; 
 Widget    help_dialog; 
 Arg       arg[3];

   message_as_a_cs = XmStringCreateLtoR(messages[(int)cd], 
                                        XmFONTLIST_DEFAULT_TAG);
   
   XtSetArg(arg[0], XmNmessageString, message_as_a_cs);
   help_dialog = XmCreateMessageDialog(top_level, "message", arg, 1);
   XmStringFree(message_as_a_cs);
 
   XtManageChild(help_dialog);
}



/*******************************************************************************
 *
 * YesCB: 
 *     Callback associated with CommandButton1. 
 *
 ******************************************************************************/
void 
#ifdef _NO_PROTO
YesCB(w, cd, cb)
   Widget w;
   XtPointer cd;
   XtPointer cb;
#else
YesCB(Widget w,
	   XtPointer cd,
	   XtPointer cb)
#endif /* _NO_PROTO */
{
  exit(0);
} 


/*******************************************************************************
 *
 * NoCB: 
 *     Callback associated with CommandButton2. 
 *
 ******************************************************************************/
void 
#ifdef _NO_PROTO
NoCB(w, cd, cb)
   Widget w;
   XtPointer cd;
   XtPointer cb;
#else
NoCB(Widget w,
	   XtPointer cd,
	   XtPointer cb)
#endif /* _NO_PROTO */
{
  /* no op */ 
} 


/*******************************************************************************
 *
 * DanceCB: 
 *     Callback associated with CommandButton3. 
 *
 ******************************************************************************/
void 
#ifdef _NO_PROTO
DanceCB(w, cd, cb)
   Widget w;
   XtPointer cd;
   XtPointer cb;
#else
DanceCB(Widget w,
	    XtPointer cd,
	    XtPointer cb)
#endif /* _NO_PROTO */
{
 XmString  everybody_dance_now;
 Arg       arg[2];
 Widget    MsgBox1;

 everybody_dance_now = XmStringCreateSimple("Everybody Dance Now!");
 XtSetArg(arg[0], XmNmessageString, everybody_dance_now);
 
 MsgBox1 = XmCreateMessageDialog(w, "MsgBox1",  arg, 1);
 XmStringFree(everybody_dance_now);

 XtManageChild(MsgBox1);
} 

