/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: exm_in_uil.c,v $
 * Revision 1.1.2.2  1994/07/15  20:40:52  rosenberg
 * 	Changed file held by mrmFiles
 * 	[1994/07/15  17:12:35  rosenberg]
 *
 * Revision 1.1.2.1  1994/07/08  18:38:26  rosenberg
 * 	moved AllExmDemo.c to new filename
 * 	[1994/07/08  18:26:04  rosenberg]
 * 
 * $EndLog$
 */

/*******************************************************************************
 *
 * exm_in_uil.c - main routine and C callbacks for exm_in_uil program.
 *
 ******************************************************************************/

#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/MessageB.h>
#include <Mrm/MrmPublic.h>
#include <Exm/ExmMrm.h>

#ifdef _NO_PROTO
static void ManageCb();
static void ExitCb();
#else
static void ManageCb(Widget, String, XtPointer);
static void ExitCb(Widget, XtPointer, XtPointer);
#endif /* _NO_PROTO */

static MrmHierarchy mrmId;
static MrmCode mrmClass;
static char *mrmFiles[]={"exm_in_uil.uid"};
static MRMRegisterArg mrmNames[] = {
        {"ManageCb", (caddr_t)ManageCb },
        {"ExitCb", (caddr_t)ExitCb }
};

static Display *display;
static Widget shell;

int 
#ifdef _NO_PROTO
main(argc, argv)
     int argc;
     char **argv;
#else
main(int argc,
     char **argv)
#endif
{
Widget appMain;
XtAppContext appContext;

    MrmInitialize();
    ExmMrmInitialize();	/* register Exm widgets with Mrm */
    XtToolkitInitialize();
    appContext = XtCreateApplicationContext();
    display = XtOpenDisplay(appContext, NULL, "exmdemo", "ExmDemo", NULL, 0,
                            &argc, argv);
    if (display == NULL) {
	fprintf(stderr, "Can't open display\n");
	exit(1);
    }
    shell = XtAppCreateShell("demo", NULL, applicationShellWidgetClass,
						display, NULL, 0);
    if (MrmOpenHierarchy (1, mrmFiles, NULL, &mrmId) != MrmSUCCESS) 
      exit(1);
    MrmRegisterNames(mrmNames, XtNumber(mrmNames));
    MrmFetchWidget (mrmId, "appMain", shell, &appMain, &mrmClass);
    XtManageChild(appMain);
    XtRealizeWidget(shell);
    XtAppMainLoop(appContext);
    exit(0);
}



/*
 * ManageCb - Manage widget passed as client_data.
 */
static void 
#ifdef _NO_PROTO
ManageCb(w, id, cb)
    Widget w;
    String id;
    XtPointer cb;
#else
ManageCb(Widget w,
	 String id,
	 XtPointer cb)
#endif /* _NO_PROTO */
{
    XtManageChild (XtNameToWidget(shell, id));
}


/*
 * ExitCb - Exit application.
 */
static void 
#ifdef _NO_PROTO
ExitCb(w, cd, cb)
    Widget w;
    XtPointer cd;
    XtPointer cb;
#else
ExitCb(Widget w,
       XtPointer cd,
       XtPointer cb)
#endif /* _NO_PROTO */
{
    exit(0);
}
