/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: convert.c,v $
 * Revision 1.1.2.3  1994/06/15  17:00:26  drand
 * 	Added ANSI prototypes
 * 	[1994/06/15  17:00:06  drand]
 *
 * Revision 1.1.2.2  1994/06/10  21:55:15  drand
 * 	Much added, much fixed
 * 	[1994/06/10  21:54:54  drand]
 * 
 * Revision 1.1.2.1  1994/06/02  15:35:34  marty
 * 	File moved from ./demos directory.
 * 	[1994/06/02  14:25:16  marty]
 * 
 * Revision 1.1.2.3  1993/11/16  22:16:24  drand
 * 	Made some functional enhancements.  Added views
 * 	[1993/11/16  22:15:55  drand]
 * 
 * Revision 1.1.2.2  1993/11/10  21:49:45  drand
 * 	Implemented convert side.
 * 	[1993/11/10  21:48:23  drand]
 * 
 * Revision 1.1.2.1  1993/10/25  20:19:00  drand
 * 	Navigation works
 * 	[1993/10/25  20:18:31  drand]
 * 
 * $EndLog$
 */

#include <Xm/Xm.h>
#include <Xm/Container.h>
#include <Xm/Transfer.h>
#include "filemanager.h"

void 
#ifdef _NO_PROTO
targetConvertCallback(wid, ignore, cs) 
     Widget wid;
     XtPointer ignore;
     XmConvertCallbackStruct *cs;
#else
targetConvertCallback(Widget wid, XtPointer ignore,
		      XmConvertCallbackStruct *cs)
#endif /* _NO_PROTO */
{
  Atom XA_TARGETS = XInternAtom(XtDisplay(wid), XmSTARGETS, False);
  Atom XA_FILE = XInternAtom(XtDisplay(wid), XmSFILE, False);
  Atom XA_FILENAME = XInternAtom(XtDisplay(wid), XmSFILE_NAME, False);
  Atom XA_MOTIF_EXPORTS = 
    XInternAtom(XtDisplay(wid), XmS_MOTIF_EXPORT_TARGETS, False);
  Atom XA_MOTIF_REQUIRED = 
    XInternAtom(XtDisplay(wid), XmS_MOTIF_CLIPBOARD_TARGETS, False);
  Atom XA_MOTIF_DROP =
    XInternAtom(XtDisplay(wid), XmS_MOTIF_DROP, False);

  if (cs -> selection == XA_MOTIF_DROP &&
      (cs -> target == XA_TARGETS ||
       cs -> target == XA_MOTIF_EXPORTS ||
       cs -> target == XA_MOTIF_REQUIRED)) {
    Atom *targs;
    targs = (Atom *) XtMalloc(sizeof(Atom) * 2);
    targs[0] = XA_FILE;
    targs[1] = XA_FILENAME;
    cs -> value = (XtPointer) targs;
    cs -> length = 2;
    cs -> type = XA_ATOM;
    cs -> format = 32;
    cs -> status = XmCONVERT_MERGE;
  } else if (cs -> target == XA_FILE ||
	     cs -> target == XA_FILENAME) {
    if (cs -> location_data == NULL) {
      WidgetList selected;
      Cardinal count;
      int i;

      /* First get list of selected items. */
      XtVaGetValues(fileviewer, 
		    XmNselectedObjects, &selected,
		    XmNselectedObjectCount, &count,
		    NULL, NULL);

      if (count > 0) {
	char *rval = NULL;
	int curpos = 0;

	for(i = 0; i < count; i++) {
	  char *path;
	  int pathlen;

	  path = getPathFromIcon(selected[i]);
	  pathlen = strlen(path) + 1;
	  rval = XtRealloc(rval, curpos + pathlen);
	  /* This will include the terminating NULL byte.  Important,
	     do not remove this NULL byte,  it acts as a separator */
	  strncpy(rval, path, pathlen);
	  curpos += pathlen;
	}
	cs -> format = 8;
	cs -> length = curpos - 1;
	cs -> type = XA_STRING;
	cs -> status = XmCONVERT_DONE;
      } else {
	cs -> status = XmCONVERT_REFUSE;
      }
    } else {
      char *path;

      path = getPathFromIcon(cs -> location_data);

      cs -> value = path;
      if (path != NULL)
	cs -> length = strlen(path);
      else
	cs -> length = 0;
      cs -> format = 8;
      cs -> type = XA_STRING;
      cs -> status = XmCONVERT_DONE;
    }
  } 
}

void 
#ifdef _NO_PROTO
targetDestinationCallback(w, ignore, cs)
     Widget w;
     XtPointer ignore;
     XmDestinationCallbackStruct *cs;
#else
targetDestinationCallback(Widget w, XtPointer ignore,
			  XmDestinationCallbackStruct *cs)
#endif /* _NO_PROTO */
{
  /* Later */
}
