/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: filemanager.c,v $
 * Revision 1.1.2.10  1994/07/07  17:25:31  drand
 * 	Change app class to follow naming convention
 * 	[1994/07/07  17:09:10  drand]
 *
 * Revision 1.1.2.9  1994/06/17  19:21:56  drand
 * 	Returning to default pixmaps for col/exp
 * 	[1994/06/17  19:21:30  drand]
 * 
 * Revision 1.1.2.8  1994/06/15  17:00:27  drand
 * 	Added ANSI prototypes
 * 	[1994/06/15  17:00:07  drand]
 * 
 * Revision 1.1.2.7  1994/06/14  14:36:26  drand
 * 	Fix build problems
 * 	[1994/06/14  14:36:04  drand]
 * 
 * Revision 1.1.2.6  1994/06/10  21:55:16  drand
 * 	Much added, much fixed
 * 	[1994/06/10  21:54:55  drand]
 * 
 * Revision 1.1.2.5  1994/06/09  21:56:46  drand
 * 	Fix options for default text editor
 * 	[1994/06/09  21:56:22  drand]
 * 
 * Revision 1.1.2.4  1994/06/09  21:52:49  drand
 * 	Added configurable actions and icons
 * 	[1994/06/09  21:51:13  drand]
 * 
 * Revision 1.1.2.3  1994/06/09  19:58:07  drand
 * 	Added fallbacks for heading tabs
 * 	[1994/06/09  19:57:51  drand]
 * 
 * Revision 1.1.2.2  1994/06/09  19:52:06  drand
 * 	Updated to use fallback resources
 * 	[1994/06/09  19:50:24  drand]
 * 
 * Revision 1.1.2.1  1994/06/02  15:35:39  marty
 * 	File moved from ./demos directory.
 * 	[1994/06/02  14:25:33  marty]
 * 
 * Revision 1.1.4.6  1994/04/20  18:41:42  drand
 * 	Fix silly uninitialized variable
 * 	[1994/04/20  18:41:27  drand]
 * 
 * Revision 1.1.4.5  1994/04/20  18:34:03  drand
 * 	Fix bugs,  and update functionality
 * 	[1994/04/20  18:33:40  drand]
 * 
 * Revision 1.1.4.4  1994/04/06  19:06:30  drand
 * 	Changed interface to C base.  Added a little online help
 * 	[1994/04/06  19:05:57  drand]
 * 
 * Revision 1.1.4.3  1994/03/30  22:47:48  drand
 * 	Fix vasetvalues bug
 * 	[1994/03/30  22:47:20  drand]
 * 
 * Revision 1.1.4.2  1994/02/08  18:11:35  drand
 * 	Fix sizing of Container
 * 	[1994/02/08  16:54:05  drand]
 * 
 * Revision 1.1.4.1  1994/02/02  20:49:18  drand
 * 	fix error reporting
 * 	[1994/02/02  20:48:55  drand]
 * 
 * Revision 1.1.2.1  1993/10/20  20:51:14  drand
 * 	Initial revision.
 * 	[1993/10/20  20:50:50  drand]
 * 
 * $EndLog$
 */

#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$RCSfile: filemanager.c,v $ $Revision: 1.1.2.10 $ $Date: 1994/07/07 17:25:31 $"
#endif
#endif

#include <stdlib.h>
#include <stdio.h>
#include <Xm/Xm.h>           /* Motif Toolkit */
#include "filemanager.h"

Display  	*display;
XtAppContext  	app_context;
Widget toplevel, mainW, dirOM, fileviewer;
Widget gotoDialog, displayLabel;

#ifdef _NO_PROTO
static int ErrorHandler();
static void UpdateDir();
#else
static int ErrorHandler(Display *display, XErrorEvent *event);
static void UpdateDir(XtPointer, XtIntervalId*);
#endif /* _NO_PROTO */

#define APP_CLASS "XmdFilemanager"
time_t ltm = 0;
unsigned int updateTime;
char *deleteCommand;
XrmQuark app_class_quark;
XrmQuark app_quark;

char * fallback_resources[] = {
"*updateTime:				2000", /* Check on directory every two seconds */
"*deleteCommand:			rm %s",
"*types.o.largeIcon:			obj.xpm",
"*types.c.largeIcon:			code.xpm",
"*types.h.largeIcon:			code.xpm",
"*types.xpm.largeIcon:			pix.xpm",
"*types.xpm.smallIcon:			s_pix.xpm",
"*types.xpm.action:			vueicon -f %s",
"*types.filemanager.action:		%s",
"*types.default_file.largeIcon:		file.xpm",
"*types.default_file.smallIcon:		s_file.xpm",
"*types.default_dir.largeIcon:		dir.xpm",
"*types.default_dir.smallIcon:		s_dir.xpm",
"*types.default_exec.largeIcon:		exec.xpm",
"*types.default_exec.smallIcon:		s_exec.xpm",
"*types.default_none.largeIcon:		none.xpm",
"*types.default_none.smallIcon:		s_none.xpm",
"*types.default_file.action:		$EDITOR %s",
"*types.default_exec.action:		xterm -e %s",
"*XmContainer.OutlineButton.shadowThickness: 0",
/* "*XmContainer.OutlineButton*armPixmap:	arm.xpm", */
"*XmContainer*foreground:		black",
"*XmContainer*background:		gray90",
"*XmContainer.selectColor:		lightblue",
"*XmContainer.outlineIndentation:	30",
"*XmContainer.outlineColumnWidth:	6cm",
"*XmContainer.detailTabList:		+3cm,+3cm,+3cm",
"*XmIconGadget.renderTable:		*helvetica-bold-r-*-10-*",
"*XmIconGadget.shadowThickness:		0",
"*show_hidden.labelString:		Show Hidden Files",
"*show_hidden.indicatorOn:		XmINDICATOR_CHECK",
"*show_hidden.indicatorSize:		15",
"*help_manager.helpFile:		filemanager",
NULL
};

/*
 *  Main program
 */
int
#ifdef _NO_PROTO
main(argc, argv)
     int    argc;
     char* argv[];
#else
main(int argc, char* argv[])
#endif /* _NO_PROTO */
{
  Arg		args[10];
  int 		n = 0;
  Pixel		fg, bg;
  Display	*display;
  int		time;
  char		*str;
  int 		i;

  XtSetArg(args[n], XmNallowShellResize, True);  n++;
  toplevel = XtVaAppInitialize(&app_context, APP_CLASS, NULL, 0, &argc, argv,
			       fallback_resources, 0);

  app_class_quark = XrmStringToQuark(APP_CLASS);
  app_quark = XrmStringToQuark(argv[0]);

  mainW = CreateInterface("main", toplevel);

  /* First try the resource database,  then use the fallbacks below */
  str = XGetDefault(XtDisplay(toplevel), APP_CLASS, "updateTime");
  if (str == NULL)
    str = XGetDefault(XtDisplay(toplevel), argv[0], "updateTime");
  if (str == NULL)
    updateTime = 2000;
  else
    updateTime = atoi(str);

  str = XGetDefault(XtDisplay(toplevel), APP_CLASS, "deleteCommand");
  if (str == NULL)
    str = XGetDefault(XtDisplay(toplevel), argv[0], "deleteCommand");
  if (str == NULL)
    deleteCommand = "rm %s";
  else
    deleteCommand = str;

  /* Find the widgets in the hierarchy */
  dirOM = XtNameToWidget(mainW, "*dirOM");

  dirLabel = (Widget *) XtMalloc(sizeof(Widget) * ndirLabel);
  for (i = 0; i < ndirLabel; i++) {
    char buf[16];
    sprintf(buf, "*l%d", i);
    dirLabel[i] = XtNameToWidget(mainW, buf);
    paths[i] = NULL;
  }

  fileviewer = XtNameToWidget(mainW, "*container");
  gotoDialog = XtNameToWidget(mainW, "*gotoDialog");
  
  displayLabel = XtNameToWidget(mainW, "*Where");

  XtVaGetValues(fileviewer, XmNforeground, &bg,	
		XmNbackground, &fg, NULL, NULL);

  XtManageChild(mainW);

  /* Install our special error handler */
  XSetErrorHandler((XErrorHandler) ErrorHandler);

  /* Add the UTM callbacks on the container area */
  XtAddCallback(fileviewer, XmNdestinationCallback, 
		(XtCallbackProc) targetDestinationCallback, NULL);
  XtAddCallback(fileviewer, XmNconvertCallback, 
		(XtCallbackProc) targetConvertCallback, NULL);
  XtAddCallback(XtParent(fileviewer), XmNresizeCallback,
		fixViewerSize, NULL);

  readdirCB(fileviewer, ".", NULL);

  XtRealizeWidget(toplevel);

  XmContainerRelayout(fileviewer);

  XtAppAddTimeOut(app_context, updateTime,
		  UpdateDir, (XtPointer) 0);

  XtAppMainLoop(app_context);
}

/* Adjust the size of the underlying container widget to be
   at least large enough to fit in the clipwindow */
void 
#ifdef _NO_PROTO
fixViewerSize(w, i1, i2) 
     Widget w;
     XtPointer i1, i2;
#else
fixViewerSize(Widget w, XtPointer i1, XtPointer i2) 
#endif /* _NO_PROTO */
{
  Dimension width, height, container_w, container_h;

  /* Get the correct dimensions of the clipwindow */
  XtVaGetValues(w, XtNwidth, &width, XtNheight, &height, NULL, NULL);

  /* Get the correct dimensions of the container */
  XtVaGetValues(fileviewer, XtNwidth, &container_w,
		XtNheight, &container_h, NULL, NULL);

  XtVaSetValues(fileviewer, XtNwidth, width, NULL, NULL);
  if (container_h < height) 
    XtVaSetValues(fileviewer, XtNheight, height, NULL, NULL);
}

/* Error handler for X protocol errors.  Continue after error */

static int 
#ifdef _NO_PROTO
ErrorHandler(display, event)
     Display *display;		/* unused */
     XErrorEvent *event;
#else
ErrorHandler(Display *display, XErrorEvent *event)
#endif /* _NO_PROTO */
{
  char errortext[100];
  XmString tmp;

  XGetErrorText(display, event -> error_code, errortext, 100);

  printf("X Protocol error: %s\n", errortext);
  printf("XID %d serial %d major %d minor %d\n",
	 event -> resourceid,
	 event -> serial,
	 event -> request_code,
	 event -> minor_code);

  return 0;
}

/* Check for modification of current directory.  We don't handle updates
   in subdirectories (at least yet),  but this *is* free software */
static void 
#ifdef _NO_PROTO
UpdateDir(data, id)
     XtPointer data;
     XtIntervalId *id;
#else
UpdateDir(XtPointer data, XtIntervalId *id) 
#endif /* _NO_PROTO */
{
  struct stat buf;

  XtAppAddTimeOut(app_context, updateTime, 
		  (XtTimerCallbackProc) UpdateDir, 0);

  if (stat(currentdir, &buf) != 0) {
    printf("Can't stat directory: %d\n", currentdir);
    return;
  }

  if (ltm != buf.st_ctime) {
    read_directory((Widget) NULL, ".");
  }
}

