/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: filemanager.h,v $
 * Revision 1.1.2.4  1994/06/15  17:00:30  drand
 * 	Added ANSI prototypes
 * 	[1994/06/15  17:00:10  drand]
 *
 * Revision 1.1.2.3  1994/06/10  21:55:18  drand
 * 	Much added, much fixed
 * 	[1994/06/10  21:54:55  drand]
 * 
 * Revision 1.1.2.2  1994/06/09  19:52:07  drand
 * 	Added field to file datastructure
 * 	[1994/06/09  19:51:00  drand]
 * 
 * Revision 1.1.2.1  1994/06/02  15:35:41  marty
 * 	File moved from ./demos directory.
 * 	[1994/06/02  14:25:37  marty]
 * 
 * Revision 1.1.4.3  1994/04/20  18:34:05  drand
 * 	Fix bugs,  and update functionality
 * 	[1994/04/20  18:33:41  drand]
 * 
 * Revision 1.1.4.2  1994/04/06  19:06:34  drand
 * 	Changed interface to C base.  Added a little online help
 * 	[1994/04/06  19:05:59  drand]
 * 
 * Revision 1.1.4.1  1994/02/08  18:11:36  drand
 * 	Fix sizing of Container
 * 	[1994/02/08  16:54:06  drand]
 * 
 * Revision 1.1.2.5  1993/11/16  22:16:26  drand
 * 	Made some functional enhancements.  Added views
 * 	[1993/11/16  22:15:57  drand]
 * 
 * Revision 1.1.2.4  1993/11/10  21:49:49  drand
 * 	Updated - added more global data, functions.
 * 	[1993/11/10  21:49:11  drand]
 * 
 * Revision 1.1.2.3  1993/11/04  19:27:20  drand
 * 	Minor changes
 * 	[1993/11/04  19:26:48  drand]
 * 
 * Revision 1.1.2.2  1993/10/27  20:05:30  drand
 * 	Directory list working,  show directory
 * 	[1993/10/27  20:05:06  drand]
 * 
 * Revision 1.1.2.1  1993/10/25  20:19:05  drand
 * 	Navigation works
 * 	[1993/10/25  20:18:34  drand]
 * 
 * $EndLog$
 */

#ifndef _filemanager_h
#define _filemanager_h

#include <dirent.h>
#include <sys/stat.h>

typedef struct _FileInfo {
  char *name;
  struct stat statbuf;
  Widget icon;      
  Boolean dirRead;
} FileInfoRec;

extern Widget fileviewer, dirOM, toplevel, mainW, gotoDialog;
extern char *currentdir;
extern Widget *dirLabel, displayLabel;
extern int ndirLabel;
extern char *paths[];
extern FileInfoRec *FI;
extern WidgetList IconGadgets;
extern int validFI;
extern Boolean showHidden;
extern time_t ltm;
extern char *deleteCommand;
extern XrmQuark app_class_quark;
extern XrmQuark app_quark;

#ifdef _NO_PROTO
extern Widget CreateInterface();
extern char* fullpath();
extern void readdirCB();
extern void outlineCB();
extern void manageCB();
extern void viewCB();
extern void gotoCB();
extern void selectCB();
extern void quitCB();
extern void newFolder();
extern void deleteItem();
extern void targetDestinationCallback();
extern void targetConvertCallback();
extern char *getPathFromIcon();
extern void fixViewerSize();
extern void showHiddenCB();
extern void read_directory();
extern int process_single_entry();
#else
extern Widget CreateInterface(char*, Widget);
extern char* fullpath(char*);
extern void readdirCB(Widget, char*, XmAnyCallbackStruct *);
extern void outlineCB(Widget, char*, XmContainerOutlineCallbackStruct *);
extern void manageCB(Widget, Widget, XtPointer);
extern void viewCB(Widget, char*, XtPointer);
extern void gotoCB(Widget widget, XtPointer i1, XtPointer cb);
extern void selectCB(Widget w, XtPointer ignore, XtPointer cb);
extern void quitCB(Widget, char*, XmAnyCallbackStruct*);
extern void newFolder(Widget widget, XtPointer ignore, XtPointer ignore2);
extern void deleteItem(Widget widget, XtPointer ignore, XtPointer ignore2);
extern void targetDestinationCallback(Widget, XtPointer,
				      XmDestinationCallbackStruct*);
extern void targetConvertCallback(Widget, XtPointer,
				  XmConvertCallbackStruct*);
extern char *getPathFromIcon(Widget);
extern void fixViewerSize(Widget w, XtPointer i1, XtPointer i2);
extern void showHiddenCB(Widget widget, XtPointer ignore,
			 XmToggleButtonCallbackStruct *callback_data);
extern void read_directory(Widget, char*);
extern int process_single_entry(Widget, char*, int, struct dirent*);
#endif /* _NO_PROTO */

#endif /* _filemanager_h */
