/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: setDate.c,v $
 * Revision 1.1.2.3  1994/07/07  17:25:32  drand
 * 	Change app class to follow naming convention
 * 	[1994/07/07  17:09:12  drand]
 *
 * Revision 1.1.2.2  1994/06/15  20:42:30  drand
 * 	Put defaults into fallback resources
 * 	[1994/06/15  20:42:17  drand]
 * 
 * Revision 1.1.2.1  1994/06/02  15:37:52  marty
 * 	File moved from ./demos directory.
 * 	[1994/06/02  14:25:02  marty]
 * 
 * Revision 1.1.7.2  1993/09/15  18:52:32  drand
 * 	Updated to SpinBox (drop from CA).
 * 	[1993/09/15  18:51:23  drand]
 * 
 * Revision 1.1.2.10  1993/07/23  21:09:07  montero
 * 	New, improved version from Bob Mackey
 * 	[1993/07/23  20:45:42  montero]
 * 
 * Revision 1.1.2.9  1993/07/22  18:32:20  drk
 * 	Added #ifdef _NO_PROTO, renamed arguments, fixed bogus argcount.
 * 	[1993/07/22  18:26:19  drk]
 * 
 * Revision 1.1.2.8  1993/07/21  20:38:42  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:13:46  yak]
 * 
 * Revision 1.1.2.7  1993/06/03  18:26:54  drand
 * 	Converted to use the real SpinButton.
 * 	[1993/06/02  20:18:37  drand]
 * 
 * Revision 1.1.2.6  1993/04/01  19:27:45  drand
 * 	Start converting to use the new SpinButton.
 * 	[1993/04/01  19:27:19  drand]
 * 
 * Revision 1.1.2.5  1992/12/30  16:13:46  drand
 * 	Fixed build warnings.
 * 	[1992/12/30  16:13:14  drand]
 * 
 * Revision 1.1.2.4  1992/11/05  22:58:58  drand
 * 	Made the demo more useful.  Now it actually looks up the current
 * 	time and shoves it into the values to display it.  It also prints
 * 	the right string for the date command now.
 * 	[1992/11/05  22:58:36  drand]
 * 
 * Revision 1.1.2.3  1992/10/21  20:15:57  drand
 * 	Misc.
 * 	[1992/10/21  20:15:28  drand]
 * 
 * Revision 1.1.2.2  1992/10/02  18:10:44  drand
 * 	Initial coding
 * 	[1992/10/02  18:07:47  drand]
 * 
 * $EndLog$
 */

#include <time.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/BulletinB.h>
#include <Xm/PanedW.h>
#include <Xm/RowColumn.h>
#include <Xm/PushB.h>
#include <Xm/Label.h>
#include <Xm/SpinB.h>
#include <Xm/TextF.h>

XtAppContext context;
#define APP_CLASS "XmdSetDate"

struct tm *thetime;
time_t timer;

Widget action, exitpb;
#ifdef _NO_PROTO
void ValueChanged();
void QuitAppl();
void Doit();
#else
void ValueChanged(Widget, XtPointer, XtPointer);
void QuitAppl(Widget, XtPointer, XtPointer);
void Doit(Widget, XtPointer, XtPointer);
#endif /* _NO_PROTO */

char * fallback_resources[] = {
"*SpinBoxs.orientation: XmHORIZONTAL",
"*SpinBoxs.packing:	XmPACK_TIGHT",
"*label2.labelString:	Date:",
"*label3.labelString:	Time:",
"*XmSpinBox.alignment:		XmALIGNMENT_END",
"*XmSpinBox.arrowLayout:	XmARROWS_SPLIT",
"*dateCommand:		echo %s",
NULL
};

int dy, yr, mn,  hr, mi;
Widget day, month, year, hour, minute;
char *dateCommand = NULL;

#ifndef _NO_PROTO
main(int argc, char **argv)
#else
main(argc, argv)
     int argc;
     char **argv;
#endif
{
  Widget        shell, panedw, rc, rc2, sb1, sb2;
  Widget	label, label2;
  Arg args[20];
  int argcount;
  int i;
  XmString months[12];
  char *monthstr[12];
  char buf[10];
  char *str;

  shell     = XtVaAppInitialize(&context, APP_CLASS, NULL, 0, &argc, argv,
				fallback_resources, 0);

  time(&timer);
  thetime = localtime(&timer);
  dy = thetime -> tm_mday;
  yr = thetime -> tm_year + 1900;
  mn = thetime -> tm_mon;
  hr = thetime -> tm_hour;
  mi = thetime -> tm_min;
  
  panedw    = XmCreatePanedWindow(shell, "BBoard", NULL, 0);
  XtManageChild(panedw);

  /* 
  XtSetArg(args[0], XmNlabelType, XmSTRING);
  XtSetArg(args[1], XmNlabelString, 
	   XmStringCreate("Set Current Date and Time", 
			  XmSTRING_DEFAULT_CHARSET));
  label = XmCreateLabel(panedw, "label1", args, 4);
  XtManageChild(label);
  */

  str = XGetDefault(XtDisplay(panedw), APP_CLASS, "dateCommand");
  if (str == NULL)
    str = XGetDefault(XtDisplay(panedw), argv[0], "dateCommand");
  if (str == NULL)
    dateCommand = "echo Default command, the date is: %s";
  else
    dateCommand = str;

  rc = XmCreateRowColumn(panedw, "SpinBoxs", NULL, 0);
  XtManageChild(rc);
  
  label = XmCreateLabel(rc, "label2", NULL, 0);
  XtManageChild(label);
  
  sb1 = XmCreateSpinBox(rc, "DateSB", NULL, 0);
  XtAddCallback(sb1, XmNvalueChangedCallback, ValueChanged, NULL);
  XtManageChild(sb1);

  XtSetArg(args[0], XmNspinBoxChildType, XmNUMERIC);
  XtSetArg(args[1], XmNmaximumValue, 31);
  XtSetArg(args[2], XmNminimumValue, 1);
  XtSetArg(args[3], XmNposition, dy - 1);
  XtSetArg(args[4], XmNcolumns, 3);
  day = XmCreateTextField(sb1, "Day", args, 5);
  XtManageChild(day);
   
  months[0]  = XmStringCreate("January", XmSTRING_DEFAULT_CHARSET);
  months[1]  = XmStringCreate("February", XmSTRING_DEFAULT_CHARSET);
  months[2]  = XmStringCreate("March", XmSTRING_DEFAULT_CHARSET);
  months[3]  = XmStringCreate("April", XmSTRING_DEFAULT_CHARSET);
  months[4]  = XmStringCreate("May", XmSTRING_DEFAULT_CHARSET);
  months[5]  = XmStringCreate("June", XmSTRING_DEFAULT_CHARSET);
  months[6]  = XmStringCreate("July", XmSTRING_DEFAULT_CHARSET);
  months[7]  = XmStringCreate("August", XmSTRING_DEFAULT_CHARSET);
  months[8]  = XmStringCreate("September", XmSTRING_DEFAULT_CHARSET);
  months[9]  = XmStringCreate("October", XmSTRING_DEFAULT_CHARSET);
  months[10]  = XmStringCreate("November", XmSTRING_DEFAULT_CHARSET);
  months[11]  = XmStringCreate("December", XmSTRING_DEFAULT_CHARSET);

  XtSetArg(args[0], XmNvalues, months);
  XtSetArg(args[1], XmNnumValues, 12);
  XtSetArg(args[2], XmNposition, mn);
  XtSetArg(args[3], XmNcolumns, 12);
  month = XmCreateTextField(sb1, "MonthSB", args, 4);
  XtManageChild(month);

  XtSetArg(args[0], XmNspinBoxChildType, XmNUMERIC);
  XtSetArg(args[1], XmNmaximumValue, 2020);
  XtSetArg(args[2], XmNminimumValue, 1992);
  XtSetArg(args[3], XmNposition, yr-1992);
  XtSetArg(args[4], XmNcolumns, 5);
  year = XmCreateTextField(sb1, "YearSB", args, 5);
  XtManageChild(year);

  label = XmCreateLabel(rc, "label3", NULL, 0);
  XtManageChild(label);
  
  XtSetArg(args[0], XmNy, 50);
  sb2 = XmCreateSpinBox(rc, "TimeSB", args, 1);
  XtAddCallback(sb2, XmNvalueChangedCallback, ValueChanged, NULL);
  XtManageChild(sb2);

  XtSetArg(args[0], XmNspinBoxChildType, XmNUMERIC);
  XtSetArg(args[1], XmNmaximumValue, 23);
  XtSetArg(args[2], XmNminimumValue, 0);
  XtSetArg(args[3], XmNposition, hr);
  XtSetArg(args[4], XmNcolumns, 3);
  hour = XmCreateTextField(sb2, "Hour", args, 5);
  XtManageChild(hour);
  
  XtSetArg(args[0], XmNlabelType, XmSTRING);
  XtSetArg(args[1], XmNlabelString, 
	   XmStringCreate(":", 
			  XmSTRING_DEFAULT_CHARSET));
  label = XmCreateLabel(sb2, "label4", args, 2);
  XtManageChild(label);
   
  XtSetArg(args[0], XmNspinBoxChildType, XmNUMERIC);
  XtSetArg(args[1], XmNmaximumValue, 59);
  XtSetArg(args[2], XmNminimumValue, 0);
  XtSetArg(args[3], XmNposition, mi);
  XtSetArg(args[4], XmNcolumns, 3);
  minute = XmCreateTextField(sb2, "Minute", args, 5);
  XtManageChild(minute);

  XtSetArg(args[0], XmNorientation, XmHORIZONTAL);
  XtSetArg(args[1], XmNpacking, XmPACK_TIGHT);
  rc2 = XmCreateRowColumn(panedw, "SpinBoxs2", args, 2);
  XtManageChild(rc2);

  action = XmCreatePushButton(rc2, "SetDate", NULL, 0);
  XtManageChild(action);
  XtAddCallback(action, XmNactivateCallback, Doit, "OK");

  exitpb = XmCreatePushButton(rc2, "Quit", NULL, 0);
  XtManageChild(exitpb);
  XtAddCallback(exitpb, XmNactivateCallback, QuitAppl, "OK");

  XtRealizeWidget(shell);

  XtAppMainLoop(context);
}

#ifdef _NO_PROTO
void ValueChanged(w, client_data, data)
Widget w;
XtPointer client_data;
XtPointer data;
#else
void ValueChanged(Widget w, XtPointer client_data, XtPointer data)
#endif /* _NO_PROTO */
{
XmSpinBoxCallbackStruct *call;

  call = (XmSpinBoxCallbackStruct *)data;

  if (call->widget == day)
    dy = call->position + 1;
  else if (call->widget == month)
    mn = call->position;
  else if (call->widget == year)
    yr = call->position + 1992;
  else if (call->widget == hour)
    hr = call->position;
  else if (call->widget == minute)
    mi = call->position;

}

#ifdef _NO_PROTO
void QuitAppl(w, i, data)
Widget w;
XtPointer i;
XtPointer data;
#else
void QuitAppl(Widget w, XtPointer i, XtPointer data)
#endif /* _NO_PROTO */
{
  XmPushButtonCallbackStruct *e = (XmPushButtonCallbackStruct *) data;
  exit(0);
}

#ifdef _NO_PROTO
void Doit(w, i, data)
Widget w;
XtPointer i;
XtPointer data;
#else
void Doit(Widget w, XtPointer client_data, XtPointer data)
#endif /* _NO_PROTO */
{
  XmPushButtonCallbackStruct *e = (XmPushButtonCallbackStruct *) data;
  char buffer[80];
  char date[32];

  sprintf(date, "%02d%02d%02d%02d%02d", (mn + 1), dy, 
	  hr, mi, yr - (100 * (yr / 100)));
  sprintf(buffer, dateCommand, date);
  system(buffer);
}


