/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/* 
 * HISTORY
 * $Log: actions.c,v $
 * Revision 1.1.2.4  1994/07/28  20:16:15  inca
 * 	If you set two args in the args list, better have space for it
 * 	[1994/07/28  20:14:17  inca]
 *
 * Revision 1.1.2.3  1994/07/21  22:04:19  drand
 * 	Update for 9832
 * 	[1994/07/21  21:55:49  drand]
 * 
 * Revision 1.1.2.2  1994/06/29  20:17:26  daniel
 * 	cr 9569: use TabButton and support \n in tab string
 * 	[1994/06/29  20:16:54  daniel]
 * 
 * Revision 1.1.2.1  1994/06/02  15:38:31  marty
 * 	File moved from ./demos directory.
 * 	[1994/06/02  14:27:39  marty]
 * 
 * Revision 1.1.7.3  1994/03/11  15:21:21  drand
 * 	Fix build warning
 * 	[1994/03/11  15:21:04  drand]
 * 
 * Revision 1.1.7.2  1994/03/10  15:42:02  drand
 * 	Fix build problems with using strdup
 * 	[1994/03/10  15:39:46  drand]
 * 
 * Revision 1.1.7.1  1994/01/20  15:48:03  drand
 * 	Fixed delete page problem with deleting last page
 * 	[1994/01/20  15:47:42  drand]
 * 
 * Revision 1.1.5.6  1993/10/13  15:12:24  yak
 * 	Added prototypes
 * 	[1993/10/13  15:11:50  yak]
 * 
 * Revision 1.1.5.5  1993/08/23  22:08:11  yak
 * 	Expanded copyright marker
 * 	[1993/08/23  21:14:54  yak]
 * 
 * Revision 1.1.5.4  1993/08/20  15:24:48  drand
 * 	Fix some problems.
 * 	[1993/08/20  15:19:14  drand]
 * 
 * Revision 1.1.5.3  1993/07/27  17:18:31  drk
 * 	Fixes from Motif2.0. Rev. 1.1.7.2, ancestor 1.1.2.3, file actions.c.
 * 	[1993/07/27  17:18:12  drk]
 * 
 * Revision 1.1.5.2  1993/07/15  18:43:19  drk
 * 	Updated to use the new notebook resource names.
 * 	[1993/07/13  17:06:53  drk]
 * 
 * Revision 1.1.2.2  1993/06/29  21:34:35  drand
 * 	Initial revision.
 * 	[1993/06/29  21:30:54  drand]
 * 
 * $EndLog$
 */ 

#ifdef REV_INFO
#ifndef lint
static char *rcsid = "$Header: /u1/rcs/motif/demos/programs/todo/actions.c,v 1.1.2.4 1994/07/28 20:16:15 inca Exp $";
#endif
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include <Xm/SelectioB.h>
#include <Xm/Notebook.h>
#include <Xm/Form.h>
#include <Xm/LabelG.h>
#include <Xm/PushBG.h>
#include <Xm/PushB.h>
#include <Xm/BulletinB.h>
#include <Xm/RowColumn.h>
#include <Xm/MessageB.h>
#include <Xm/TextF.h>
#include <Xm/Text.h>
#include <Exm/TabB.h>

#include "page.h"

extern Page pages[];
Widget editDialog = 0, deleteDialog = 0;

#ifdef _NO_PROTO
void SetPage();
void AdjustPages();
void FixPages();
void PageChange();
Page AllocPage();
char* Trim();
#else
void SetPage(int);
void AdjustPages(int, int);
void FixPages();
void PageChange(Widget w, XtPointer i, XmNotebookCallbackStruct *cs);
Page AllocPage();
char* Trim(char*);
#endif /* _NO_PROTO */

extern Widget shell, textw, labelw, notebook;
extern maxpages, currentPage, modified;

void 
#ifdef _NO_PROTO
NewPage(w, i, cs) 
     Widget w;
     XtPointer i;
     XmPushButtonCallbackStruct *cs;
#else
NewPage(Widget w, XtPointer i, XmPushButtonCallbackStruct *cs) 
#endif /* _NO_PROTO */
{
  Arg args[2];

  if (modified && pages[currentPage] != NULL) {
    if (pages[currentPage] -> page != NULL) 
      XtFree(pages[currentPage] -> page);
     pages[currentPage] -> page = XmTextGetString(textw);
  }
  AdjustPages(currentPage, 1);
  pages[currentPage] = AllocPage();
  FixPages();
  XtSetArg(args[0], XmNcurrentPageNumber, (currentPage + 1));
  XtSetArg(args[1], XmNlastPageNumber, (maxpages + 1));
  XtSetValues(notebook, args, 2);
  SetPage(currentPage);
}

void 
#ifdef _NO_PROTO
DoDeletePage(w, i, cs) 
     Widget w;
     XtPointer i;
     XmPushButtonCallbackStruct *cs;
#else
DoDeletePage(Widget w, XtPointer i, XmPushButtonCallbackStruct *cs) 
#endif /* _NO_PROTO */
{
  Arg args[2];

  if (pages[currentPage] != NULL) {
    if (pages[currentPage] -> page != NULL) XtFree(pages[currentPage] -> page);
    if (pages[currentPage] -> minorPB != (Widget) 0)
      XtDestroyWidget(pages[currentPage] -> minorPB);
    if (pages[currentPage] -> majorPB != (Widget) 0)
      XtDestroyWidget(pages[currentPage] -> majorPB);
    XtFree((XtPointer) pages[currentPage]);
  }
  pages[currentPage] = NULL;
  AdjustPages(currentPage, -1);

  /* If there are no more pages left,  then create a blank one */
  if (maxpages < 0) {
    pages[0] = AllocPage();
    pages[0] -> page = XtMalloc(2);
    pages[0] -> page[0] = 0;
    maxpages = 0;
  }

  FixPages();
  XtSetArg(args[0], XmNcurrentPageNumber, (currentPage + 1));
  XtSetArg(args[1], XmNlastPageNumber, (maxpages + 1));
  XtSetValues(notebook, args, 2);
  SetPage(currentPage);
}

void 
#ifdef _NO_PROTO
DeletePage(w, i, cs) 
     Widget w;
     XtPointer i;
     XmPushButtonCallbackStruct *cs;
#else
DeletePage(Widget w, XtPointer i, XmPushButtonCallbackStruct *cs) 
#endif /* _NO_PROTO */
{
  if (deleteDialog == 0) {
    Arg args[10];
    XmString okLabel, promptText, dialogTitle; 

    dialogTitle = XmStringCreateLocalized("Page Delete Dialog");
    okLabel = XmStringCreateLocalized("Delete");
    promptText = XmStringCreateLocalized("Really delete this page?");
    XtSetArg(args[0], XmNokLabelString, okLabel);
    XtSetArg(args[1], XmNmessageString, promptText);
    XtSetArg(args[2], XmNdialogTitle, dialogTitle);
    XtSetArg(args[3], XmNdialogStyle, XmDIALOG_PRIMARY_APPLICATION_MODAL);
    deleteDialog = XmCreateMessageDialog(shell, "DeletePage", 
					args, 4);
    XtAddCallback(deleteDialog, XmNokCallback, 
		  (XtCallbackProc) DoDeletePage, NULL);
    XmStringFree(dialogTitle);
    XmStringFree(okLabel);
    XmStringFree(promptText);
  }

  XtManageChild(deleteDialog);
}

Widget labelEditW, majorTabW, minorTabW;

void 
#ifdef _NO_PROTO
DoEditPage(w, ig, cs) 
     Widget w;
     XtPointer ig;
     XmPushButtonCallbackStruct *cs;
#else
DoEditPage(Widget w, XtPointer ig, XmPushButtonCallbackStruct *cs) 
#endif /* _NO_PROTO */
{
  char *temp;
  XmString tstr;
  Arg args[5];
  int i;

  pages[currentPage] -> label = XmTextFieldGetString(labelEditW);

  if (pages[currentPage] -> minorTab != NULL)
    XtFree(pages[currentPage] -> minorTab);
  temp = XmTextGetString(minorTabW);
  temp = Trim(temp);
  if (strlen(temp) > 0)
    pages[currentPage] -> minorTab = temp;
  else {
    XtFree(temp);
    pages[currentPage] -> minorTab = NULL;
    if (pages[currentPage] -> minorPB)
      XtUnmanageChild(pages[currentPage] -> minorPB);
  }

  if (pages[currentPage] -> majorTab != NULL)
    XtFree(pages[currentPage] -> majorTab);
  temp = XmTextGetString(majorTabW);
  temp = Trim(temp);
  if (strlen(temp) > 0) 
    pages[currentPage] -> majorTab = temp;
  else {
    XtFree(temp);
    pages[currentPage] -> majorTab = NULL;
    if (pages[currentPage] -> majorPB)
      XtUnmanageChild(pages[currentPage] -> majorPB);
  }

  if (pages[currentPage] -> majorTab != NULL) {
    if (pages[currentPage] -> majorPB == (Widget) 0) {
      i = 0;
      XtSetArg(args[i], XmNpageNumber, currentPage + 1); i++;
      XtSetArg(args[i], XmNnotebookChildType, XmMAJOR_TAB); i++;
      XtSetArg(args[i], XmNshadowThickness, 1); i++;
      pages[currentPage] -> majorPB =
	ExmCreateTabButton(notebook, "atab", args, i);
    }
    tstr = XmStringGenerate(pages[currentPage] -> majorTab, NULL, 
			    XmCHARSET_TEXT, NULL);
    XtSetArg(args[0], ExmNcompoundString, tstr);
    XtSetValues(pages[currentPage] -> majorPB, args, 1);
    XtManageChild(pages[currentPage] -> majorPB);
  }

  if (pages[currentPage] -> minorTab != NULL) {
    if (pages[currentPage] -> minorPB == (Widget) 0) {
      i = 0;
      XtSetArg(args[i], XmNpageNumber, currentPage + 1); i++;
      XtSetArg(args[i], XmNnotebookChildType, XmMINOR_TAB); i++;
      XtSetArg(args[i], XmNshadowThickness, 1); i++;
      pages[currentPage] -> minorPB =
	ExmCreateTabButton(notebook, "atab", args, i);
    }
    tstr = XmStringGenerate(pages[currentPage] -> minorTab, NULL, 
			    XmCHARSET_TEXT, NULL);
    XtSetArg(args[0], ExmNcompoundString, tstr);
    XtSetValues(pages[currentPage] -> minorPB, args, 1);
    XtManageChild(pages[currentPage] -> minorPB);
  }

  /* Get contents before update */
  XtFree(pages[currentPage] -> page);
  pages[currentPage] -> page = XmTextGetString(textw);

  SetPage(currentPage);
}

void 
#ifdef _NO_PROTO
EditPage(w, i, cs) 
     Widget w;
     XtPointer i;
     XmPushButtonCallbackStruct *cs;
#else
EditPage(Widget w, XtPointer i, XmPushButtonCallbackStruct *cs) 
#endif /* _NO_PROTO */
{
  if (pages[currentPage] == NULL) return;

  if (editDialog == 0) {
    Arg args[10];
    XmString promptText, dialogTitle, temp; 
    XmString okLabel, cancelLabel;
    Widget label, rc1, rc2;

    dialogTitle = XmStringCreateLocalized("Page Edit Dialog");
    promptText = XmStringCreateLocalized("Really edit this page?");
    okLabel = XmStringCreateLocalized("OK");
    cancelLabel = XmStringCreateLocalized("Cancel");
    XtSetArg(args[0], XmNselectionLabelString, promptText);
    XtSetArg(args[1], XmNdialogTitle, dialogTitle);
    XtSetArg(args[2], XmNdialogStyle, XmDIALOG_PRIMARY_APPLICATION_MODAL);
    XtSetArg(args[3], XmNokLabelString, okLabel);
    XtSetArg(args[4], XmNcancelLabelString, cancelLabel);
    editDialog = XmCreateTemplateDialog(shell, "EditPage", 
					args, 5);
    XtAddCallback(editDialog, XmNokCallback,
		  (XtCallbackProc) DoEditPage, NULL);

    XmStringFree(dialogTitle);
    XmStringFree(promptText);
    XmStringFree(okLabel);
    XmStringFree(cancelLabel);
    
    XtSetArg(args[0], XmNorientation, XmVERTICAL); 
    rc1 = XmCreateRowColumn(editDialog, "rc", args, 1);
    XtManageChild(rc1);

    XtSetArg(args[0], XmNorientation, XmHORIZONTAL);
    rc2 = XmCreateRowColumn(rc1, "rc2", args, 1);
    temp = XmStringCreateLocalized("Label:");
    XtSetArg(args[0], XmNwidth, 100);
    XtSetArg(args[1], XmNlabelString, temp);
    label = XmCreateLabelGadget(rc2, "label", args, 2);
    XtManageChild(label);
    XmStringFree(temp);
    XtManageChild(rc2);

    labelEditW = XmCreateTextField(rc2, "editTF", NULL, 0);
    XtManageChild(labelEditW);

    XtSetArg(args[0], XmNorientation, XmHORIZONTAL);
    rc2 = XmCreateRowColumn(rc1, "rc2", args, 1);
    temp = XmStringCreateLocalized("Major Tab:");
    XtSetArg(args[0], XmNwidth, 100);
    XtSetArg(args[1], XmNlabelString, temp);
    label = XmCreateLabelGadget(rc2, "label", args, 2);
    XtManageChild(label);
    XmStringFree(temp);

    majorTabW = XmCreateTextField(rc2, "majorTF", NULL, 0);
    XtManageChild(majorTabW);
    XtManageChild(rc2);

    XtSetArg(args[0], XmNorientation, XmHORIZONTAL);
    rc2 = XmCreateRowColumn(rc1, "rc2", args, 1);
    temp = XmStringCreateLocalized("Minor Tab:");
    XtSetArg(args[0], XmNwidth, 100);
    XtSetArg(args[1], XmNlabelString, temp);
    label = XmCreateLabelGadget(rc2, "label", args, 2);
    XtManageChild(label);
    XmStringFree(temp);

    minorTabW = XmCreateTextField(rc2, "minorTF", NULL, 0);
    XtManageChild(minorTabW);
    XtManageChild(rc2);
  }

  if (pages[currentPage] -> label != NULL)
    XmTextFieldSetString(labelEditW, pages[currentPage] -> label);
  else
    XmTextFieldSetString(labelEditW, "");

  if (pages[currentPage] -> majorTab != NULL)
    XmTextSetString(majorTabW, pages[currentPage] -> majorTab);
  else
    XmTextSetString(majorTabW, "");

  if (pages[currentPage] -> minorTab != NULL)
    XmTextSetString(minorTabW, pages[currentPage] -> minorTab);
  else
    XmTextSetString(minorTabW, "");

  XtManageChild(editDialog);
}

void 
#ifdef _NO_PROTO
SaveIt(w, i, e) 
     Widget w;
     char *i;
     XmPushButtonCallbackStruct *e;
#else
SaveIt(Widget w, char *i, XmPushButtonCallbackStruct *e) 
#endif /* _NO_PROTO */
{
  SaveDB(options.todoFile);
}

void 
#ifdef _NO_PROTO
SetPage(pageNumber) 
     int pageNumber;
#else
SetPage(int pageNumber) 
#endif /* _NO_PROTO */
{
  XmString tmp;
  char buf[80];
  Arg args[5];

  currentPage = pageNumber;
  if (pageNumber <= maxpages) {
    XtSetArg(args[0], XmNpageNumber, (pageNumber + 1));
    XtSetValues(XtParent(textw), args, 1);
  }
  if (pages[pageNumber] != NULL) {
    if (pages[pageNumber] -> page != NULL)
      XtSetArg(args[0], XmNvalue, pages[pageNumber] -> page);
    else
      XtSetArg(args[0], XmNvalue, "");
    XtSetValues(textw, args, 1);

    if (pages[pageNumber] -> label != NULL)
      tmp = XmStringCreateLocalized(pages[pageNumber] -> label);
    else {
      sprintf(buf, "Page %d", pageNumber + 1);
      tmp = XmStringCreateLocalized(buf);
    }
  }
  else {
    XtSetArg(args[0], XmNvalue, "");
    XtSetValues(textw, args, 1);
    sprintf(buf, "Page %d (Bad Page)", pageNumber + 1);
    tmp = XmStringCreateLocalized(buf);
  }

  XmTextSetTopCharacter(textw, pages[pageNumber] -> lasttoppos);
  XmTextSetInsertionPosition(textw, pages[pageNumber] -> lastcursorpos);
    
  XtSetArg(args[0], XmNpageNumber, (pageNumber + 1));
  XtSetArg(args[1], XmNlabelString, tmp);
  XtSetValues(labelw, args, 2);
  XmStringFree(tmp);
}

void 
#ifdef _NO_PROTO
PageChange(w, i, cs) 
     Widget w;
     XtPointer i;
     XmNotebookCallbackStruct *cs;
#else
PageChange(Widget w, XtPointer i, XmNotebookCallbackStruct *cs) 
#endif /* _NO_PROTO */
{
  if (modified && pages[currentPage] != NULL) {
    if (pages[currentPage] -> page != NULL) 
      XtFree(pages[currentPage] -> page);
    pages[currentPage] -> page = XmTextGetString(textw);
    pages[currentPage] -> lasttoppos = XmTextGetTopCharacter(textw);
    pages[currentPage] -> lastcursorpos = XmTextGetInsertionPosition(textw);
  }

  SetPage(cs -> page_number - 1);
}

void 
#ifdef _NO_PROTO
AdjustPages(startpage, ins) 
     int startpage;
     int ins;
#else
AdjustPages(int startpage, int ins) 
#endif /* _NO_PROTO */
{
  int i;

  /* ins is either +1 or -1 for insert or delete a page */

  if (ins > 0) {
    for(i = maxpages; i >= startpage; i--)
      pages[i + 1] = pages[i];
    maxpages += 1;
  } else {
    for(i = startpage; i <= maxpages; i++)
      pages[i] = pages[i + 1];
    maxpages -= 1;
  }
}

void FixPages() {
  int i;
  Arg args[2];

  /* Now scan the pages and fix the tabs */
  for (i = 0; i <= maxpages; i++) {
    XtSetArg(args[0], XmNpageNumber, (i + 1));
    if (pages[i] -> majorPB != (Widget) 0)
      XtSetValues(pages[i] -> majorPB, args, 1);
    if (pages[i] -> minorPB != (Widget) 0)
      XtSetValues(pages[i] -> minorPB, args, 1);
  }
}

/* This function removes leading and trailing whitespace.  It
   deallocates the original string and returns a brand new string */

char* 
#ifdef _NO_PROTO
Trim(str)
	char *str;
#else
Trim(char* str)
#endif /* _NO_PROTO */
{
  char *new;
  int first, last;
  int length;

  if (str == NULL) return(XtNewString(""));

  length = strlen(str);

  for(first = 0; first < length && isspace(str[first]); first++);
  for(last = length - 1; last > first && isspace(str[last]); last--);

  if (! isspace(str[last])) last++; /* Last needs to be adjusted */

  if (first == last) /* Empty */
    {
      free(str);
      return(strdup(""));
    }
  else
    {
      new = XtMalloc(last - first + 1); /* Don't forget last 0 */
      strncpy(new, &str[first], last - first);
      new[last - first] = 0;
      free(str);
      return(new);
    }
}
