/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/* 
 * HISTORY
 * $Log: todo.c,v $
 * Revision 1.1.2.6  1994/07/27  20:59:18  drand
 * 	Fix CR 9877 - Problems with help widget
 * 	[1994/07/27  20:58:53  drand]
 *
 * Revision 1.1.2.5  1994/07/21  22:04:24  drand
 * 	Update for 9832
 * 	[1994/07/21  21:55:53  drand]
 * 
 * Revision 1.1.2.4  1994/07/07  17:25:33  drand
 * 	Change app class to follow naming convention
 * 	[1994/07/07  17:09:13  drand]
 * 
 * Revision 1.1.2.3  1994/06/15  20:46:38  drand
 * 	Changed fallbacks
 * 	[1994/06/15  20:46:23  drand]
 * 
 * Revision 1.1.2.2  1994/06/02  21:05:55  drand
 * 	Rename Uxm to Xmd
 * 	[1994/06/02  21:05:39  drand]
 * 
 * Revision 1.1.2.1  1994/06/02  15:38:37  marty
 * 	File moved from ./demos directory.
 * 	[1994/06/02  14:27:53  marty]
 * 
 * Revision 1.1.7.3  1994/05/11  17:00:18  drand
 * 	Added more help
 * 	[1994/05/11  16:56:35  drand]
 * 
 * Revision 1.1.7.2  1994/05/06  20:23:04  drand
 * 	Fix minor print problems
 * 	[1994/05/06  20:22:44  drand]
 * 
 * Revision 1.1.7.1  1994/05/06  19:53:17  drand
 * 	Use print dialog and menu creator
 * 	[1994/05/06  19:53:06  drand]
 * 
 * Revision 1.1.5.8  1993/11/09  22:25:01  drand
 * 	Added a frame shadow around notebook.
 * 	[1993/11/09  22:24:45  drand]
 * 
 * Revision 1.1.5.7  1993/10/13  15:12:22  yak
 * 	Added prototypes
 * 	[1993/10/13  15:11:54  yak]
 * 
 * Revision 1.1.5.6  1993/08/30  14:16:42  yak
 * 	Removed duplicated includes.
 * 	[1993/08/30  14:16:20  yak]
 * 
 * Revision 1.1.5.5  1993/08/23  22:08:15  yak
 * 	Expanded copyright marker
 * 	[1993/08/23  21:15:05  yak]
 * 
 * Revision 1.1.5.4  1993/08/20  15:24:53  drand
 * 	Probably nothing.
 * 	[1993/08/20  15:19:51  drand]
 * 
 * Revision 1.1.5.3  1993/07/23  21:33:30  drk
 * 	Fixes from Motif2.0. Rev. 1.1.7.2, ancestor 1.1.2.3, file demos/todo/todo.c.
 * 	[1993/07/23  21:33:12  drk]
 * 
 * Revision 1.1.5.2  1993/07/15  18:44:30  drk
 * 	Updated to use the new notebook resource names.
 * 	[1993/07/13  17:07:33  drk]
 * 
 * Revision 1.1.2.2  1993/06/29  21:34:44  drand
 * 	Initial revision.
 * 	[1993/06/29  21:33:35  drand]
 * 
 * $EndLog$
 */

#ifdef REV_INFO
#ifndef lint
static char *rcsid = "$Header: /u1/rcs/motif/demos/programs/todo/todo.c,v 1.1.2.6 1994/07/27 20:59:18 drand Exp $";
#endif
#endif

#include <pwd.h>
#include <unistd.h>
/* X include files */
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xatom.h>
/* Motif include files */
#include <Xm/Xm.h>
#include <Xm/CascadeBG.h>
#include <Xm/FileSB.h>
#include <Xm/Label.h>
#include <Xm/MainW.h>
#include <Xm/Notebook.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrolledW.h>
#include <Xm/Separator.h>
#include <Xm/Text.h>
/* Demo include files */
#include <Xmd/Help.h>
#include <Xmd/Menus.h>
#include <Xmd/Print.h>

#include "page.h"

#define APP_CLASS "XmdTodo"

#define MAX(x,y) ((x) > (y) ? (x) : (y))
#define MIN(x,y) ((x) > (y) ? (y) : (x))

char * fallback_resources[] = {
"*text.rows: 24",
"*text.columns: 80",
"*print_manager.printerList: lp,./todo.txt",
"*help_manager.helpFile: todo",
"*notebook.frameShadowThickness: 2",
"*notebook.bindingType:	XmSPIRAL",
NULL
};

/* Options */
OptionsRec options;

#define Offset(field) XtOffsetOf(OptionsRec, field)

XtResource resources[] = {
  {"todoFile", "TodoFile", XtRString, sizeof(String), 
    Offset(todoFile), XtRImmediate, NULL}
};

#undef Offset

XrmOptionDescRec optionDesc[] = {
  {"-todoFile", "*todoFile", XrmoptionSepArg, (XtPointer) NULL}
};

#ifdef _NO_PROTO
static void QuitAppl();
static void TextChanged();

void PresentFDialog();
void New();
void Save();
void Open();
void Print();
void SaveIt();
void PageChange();
void NewPage();
void DeletePage();
void EditPage();
void manageCB();
void SetPage();
void help_cb();
#else
static void QuitAppl(Widget, char *, XmPushButtonCallbackStruct *);
static void TextChanged(Widget, XtPointer, XtPointer);

void manageCB(Widget, Widget, XtPointer);
void PresentFDialog(Widget, XtPointer, XmPushButtonCallbackStruct*);
void New(Widget, char*, XmPushButtonCallbackStruct *);
void Save(Widget, char*, XmFileSelectionBoxCallbackStruct *);
void Open(Widget, char*, XmFileSelectionBoxCallbackStruct *);
void Print(Widget, char*, XmdPrintCallbackStruct *);
void SaveIt(Widget, char*, XmPushButtonCallbackStruct *);
void PageChange(Widget, XtPointer, XmNotebookCallbackStruct *);
void NewPage(Widget, XtPointer, XmPushButtonCallbackStruct *);
void DeletePage(Widget, XtPointer, XmPushButtonCallbackStruct *);
void EditPage(Widget, XtPointer, XmPushButtonCallbackStruct *);
void SetPage(int);
void help_cb(Widget, XtPointer, XmAnyCallbackStruct *);
#endif /* _NO_PROTO */

#ifdef _NO_PROTO
extern void ReadDB();
extern void SaveDB();
#else
extern void ReadDB(char*);
extern void SaveDB(char*);
#endif /* _NO_PROTO */

extern Page pages[];

Widget shell, notebook, textw, labelw;
Widget help_widget, file_dialog;
int currentPage = 1;
int modified;
extern int maxpages;
struct passwd *user;

int 
#ifdef _NO_PROTO
main(argc, argv) 
     int argc;
     char* argv[];
#else
main(int argc, char* argv[]) 
#endif /* _NO_PROTO */
{
  Widget mainw, menubar;
  Widget *file_menu, *edit_menu, *selected_menu, *help_menu, temp;
  Widget print_widget;
  Cardinal size;
  XtAppContext context;
  Arg args[10];
  int n, i;
  XmString tmp;
  char temppath[256];

  if (argc == 2 && strcmp(argv[1], "-help") == 0) {
    printf("Usage: todo [-todoFile pathname]\n");
    return(0);
  }

  shell		= XtVaAppInitialize(&context, APP_CLASS,
				    optionDesc, XtNumber(optionDesc), 
				    &argc, argv,
				    fallback_resources, 0);

  XtGetApplicationResources(shell, (XtPointer) &options,
			    resources, XtNumber(resources), (Arg *) NULL, 0);

  mainw		= XmCreateMainWindow(shell, "mainw", NULL, 0);
  XtManageChild(mainw);

  menubar	= XmCreateMenuBar(mainw, "menub", NULL, 0);
  XtManageChild(menubar);

  n = 0;
  XtSetArg(args[n], XmNcurrentPageNumber, 1); n++;
  XtSetArg(args[n], XmNlastPageNumber, 100); n++;
  notebook	= XmCreateNotebook(mainw, "notebook", args, n);
  XtManageChild(notebook);
  XtAddCallback(notebook, XmNpageChangedCallback, 
		(XtCallbackProc) PageChange, NULL);

  n = 0;
  XtSetArg(args[n], XmNmenuBar, menubar); n++;
  XtSetValues(mainw, args, n);

  n = 0;
  XtSetArg(args[n], XmNpageNumber, 1); n++;
  XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT); n++;
  textw		= XmCreateScrolledText(notebook, "text", args, n);
  XtManageChild(textw);
  XtAddCallback(textw, XmNvalueChangedCallback, TextChanged, NULL);

  n = 0;
  XtSetArg(args[n], XmNnotebookChildType, XmSTATUS_AREA); n++;
  XtSetArg(args[n], XmNpageNumber, 1); n++;
  labelw	= XmCreateLabel(notebook, "label", args, n);
  XtManageChild(labelw);

  XmdCreateMenu(FILE_MENU, menubar, &file_menu, &size);
  XtAddCallback(file_menu[FILE_NEW], XmNactivateCallback, 
		(XtCallbackProc) New, NULL);
  XtAddCallback(file_menu[FILE_OPEN], XmNactivateCallback,
		(XtCallbackProc) PresentFDialog, (XtPointer) Open);
  XtAddCallback(file_menu[FILE_EXIT], XmNactivateCallback, 
		(XtCallbackProc) QuitAppl, NULL);
  XtAddCallback(file_menu[FILE_SAVE_AS], XmNactivateCallback,
		(XtCallbackProc) PresentFDialog, (XtPointer) Save);
  XtAddCallback(file_menu[FILE_SAVE], XmNactivateCallback,
		(XtCallbackProc) SaveIt, NULL);

  XmdCreateMenu(SELECTED_MENU, menubar, &selected_menu, &size);
  XtUnmanageChildren(selected_menu, size);
  XtManageChild(selected_menu[SELECTED_PROPERTIES]);
  XtAddCallback(selected_menu[SELECTED_PROPERTIES], 
		XmNactivateCallback, (XtCallbackProc) EditPage, NULL);
  XtManageChild(selected_menu[SELECTED_NEW]);
  XtAddCallback(selected_menu[SELECTED_NEW], 
		XmNactivateCallback, (XtCallbackProc) NewPage, NULL);
  XtManageChild(selected_menu[SELECTED_DELETE]);
  XtAddCallback(selected_menu[SELECTED_DELETE],
  		XmNactivateCallback, (XtCallbackProc) DeletePage, NULL);

  XmdCreateMenu(HELP_MENU, menubar, &help_menu, &size);
  XtUnmanageChildren(help_menu, size);
  XtManageChild(help_menu[HELP_OVERVIEW]);

  print_widget = XmdCreatePrintDialog(shell, "print_manager", NULL, 0);
  XtAddCallback(print_widget, XmdNprintCallback, (XtCallbackProc) Print, NULL);
  tmp = XmStringCreateLocalized("About Printing");

  XtAddCallback(file_menu[FILE_PRINT], XmNactivateCallback, 
		(XtCallbackProc) manageCB, (XtPointer) print_widget);

  help_widget = XmdCreateHelpDialog(shell, "help_manager", NULL, 0);
  XtAddCallback(help_menu[HELP_OVERVIEW], XmNactivateCallback,
		(XtCallbackProc) help_cb, (XtPointer) 0);
  XtAddCallback(print_widget, XmNhelpCallback,
		(XtCallbackProc) help_cb, (XtPointer) 1);

  n = 0;
  XtSetArg(args[n], XmNautoUnmanage, True); n++;
  file_dialog = XmCreateFileSelectionDialog(shell, "file_dialog", args, n);

  user = getpwuid(getuid());
  for (i = 0; i < MAXPAGES; i++) {
    pages[i] = NULL;
  }

  if (options.todoFile == NULL) {
    strcpy(temppath, user -> pw_dir);
    strcat(temppath, "/.todo");
    options.todoFile = XtNewString(temppath);
  } else {
    /* Copy the string for consistency */
    options.todoFile = XtNewString(options.todoFile);
  }

  XtVaSetValues(shell, XmNtitle, options.todoFile,
		XmNtitleEncoding, XA_STRING, NULL, NULL);  
  ReadDB(options.todoFile);
  SetPage(0);

  XtRealizeWidget(shell);

  XtAppMainLoop(context);
}

static void 
#ifdef _NO_PROTO
QuitAppl(w, i, e) 
     Widget w;
     char *i;
     XmPushButtonCallbackStruct *e;
#else
QuitAppl(Widget w, char *i, XmPushButtonCallbackStruct *e) 
#endif /* _NO_PROTO */
{
  exit(0);
}

static void 
#ifdef _NO_PROTO
TextChanged(w, i, i2) 
     Widget w;
     XtPointer i;
     XtPointer i2;
#else
TextChanged(Widget w, XtPointer i, XtPointer i2) 
#endif /* _NO_PROTO */
{
  modified = 1;
}

void manageCB( widget, w_to_manage, callback_data)
     Widget widget;
     Widget w_to_manage;
     XtPointer callback_data;
{
  if (w_to_manage != (Widget) NULL)
    XtManageChild(w_to_manage);
}

void
#ifdef _NO_PROTO
PresentFDialog(w, cb, cs)
     Widget w;
     XtPointer cb;
     XmPushButtonCallbackStruct *cs;
#else
PresentFDialog(Widget w, XtPointer cb, XmPushButtonCallbackStruct *cs)
#endif /* _NO_PROTO */
{
  XtRemoveAllCallbacks(file_dialog, XmNokCallback);
  XtAddCallback(file_dialog, XmNokCallback, (XtCallbackProc) cb, NULL);
  XtManageChild(file_dialog);
}

void
#ifdef _NO_PROTO 
New(w, ignore, cs)
     Widget w;
     char* ignore;
     XmPushButtonCallbackStruct *cs;
#else
New(Widget w, char* ignore, XmPushButtonCallbackStruct *cs)
#endif /* _NO_PROTO */
{
  char buf[128];
  char *str;
  Boolean found = False;
  int i = 0;
  
  while(! found) {
    sprintf(buf, "untitled%d.todo", i++);
    found = access(buf, F_OK) != 0;
  }

  str = XtNewString(buf);
  ReadDB(str);
  XtFree(options.todoFile);
  options.todoFile = str;
  XtVaSetValues(shell, XmNtitle, str, XmNtitleEncoding, 
		XA_STRING, NULL, NULL);
  SetPage(0);
}

void 
#ifdef _NO_PROTO
Save(w, i, i2)
	Widget w;
	char *i;
	XmFileSelectionBoxCallbackStruct *i2;
#else
Save(Widget w, char *i, XmFileSelectionBoxCallbackStruct *i2) 
#endif /* _NO_PROTO */
{
  char *str;
  if (str = XmStringUnparse(i2->value, NULL, XmCHARSET_TEXT, 
			    XmCHARSET_TEXT, NULL, 0, XmOUTPUT_ALL)) {
    SaveDB(str);
    XtFree(options.todoFile);
    options.todoFile = str;
    XtVaSetValues(shell, XmNtitle, str, XmNtitleEncoding, 
		  XA_STRING, NULL, NULL);
  }
}

void 
#ifdef _NO_PROTO
Open(w, i, i2)
	Widget w;
	char *i;
	XmFileSelectionBoxCallbackStruct *i2;
#else
Open(Widget w, char *i, XmFileSelectionBoxCallbackStruct *i2) 
#endif /* _NO_PROTO */
{
  char *str;
  if (str = XmStringUnparse(i2->value, NULL, XmCHARSET_TEXT, 
			    XmCHARSET_TEXT, NULL, 0, XmOUTPUT_ALL)) {
    ReadDB(str);
    XtFree(options.todoFile);
    options.todoFile = str;
    XtVaSetValues(shell, XmNtitle, str, XmNtitleEncoding, 
		  XA_STRING, NULL, NULL);
  }
}

void
#ifdef _NO_PROTO
help_cb(w, item, cb)
     Widget w;
     XtPointer item;
     XmAnyCallbackStruct *cb;
#else
help_cb(Widget w, XtPointer item, XmAnyCallbackStruct *cb)
#endif /* _NO_PROTO */
{
  XtManageChild(help_widget);
  XmdGotoHelpItem(w, (int) item, help_widget);
}

void 
#ifdef _NO_PROTO
Print(w, ignore, cb)
	Widget w;
	char *ignore;
	XmdPrintCallbackStruct *cb;
#else
Print(Widget w, char *ignore, XmdPrintCallbackStruct *cb)
#endif /* _NO_PROTO */
{
  int i;
  FILE *temp;
  int from, to;

  temp = fopen("/tmp/.todoout", "w");

  if (cb -> first == cb -> last &&
      cb -> first == 0) {
    from = 0; 
    to = maxpages - 1;
  } else {
    from = MAX(0, cb -> first - 1);
    to = MIN(maxpages, cb -> last - 1);
  }

  for (i = from; i <= to; i++) {
    if (pages[i] -> label != NULL) {
      fprintf(temp, "Subject: %s\n", pages[i] -> label);
      fprintf(temp, "---------------------------\n\n\n");
    }
    fprintf(temp, "%s", pages[i] -> page);
    if (i != (maxpages - 1)) fprintf(temp, "\f");
  }

  fclose(temp);
  XmdPrintDocument("/tmp/.todoout", cb);
}
