/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */ 
/*
 * HISTORY
 * $Log: transfer.h,v $
 * Revision 1.1.2.1  1994/06/02  15:38:51  marty
 * 	File moved from ./demos directory.
 * 	[1994/06/02  14:28:38  marty]
 *
 * Revision 1.1.6.1  1994/05/13  22:00:01  drand
 * 	Added functional prototypes and changed to use menu creation funcs
 * 	[1994/05/13  21:59:35  drand]
 * 
 * Revision 1.1.4.3  1994/04/11  15:26:42  drand
 * 	Updated to be able to mark targets deferred for Clipboard
 * 	[1994/04/11  15:26:23  drand]
 * 
 * Revision 1.1.4.2  1994/04/05  19:29:05  drand
 * 	Converted from UIL to C interface
 * 	[1994/04/05  19:26:49  drand]
 * 
 * Revision 1.1.4.1  1994/01/31  18:15:56  drand
 * 	Add testing for NamedAtom
 * 	[1994/01/31  18:15:40  drand]
 * 
 * Revision 1.1.2.5  1993/10/15  20:08:23  drand
 * 	Added new external widgets.
 * 	[1993/10/15  20:08:09  drand]
 * 
 * Revision 1.1.2.4  1993/09/28  20:45:29  drand
 * 	Added two more external widgets.
 * 	[1993/09/28  20:44:12  drand]
 * 
 * Revision 1.1.2.3  1993/09/22  20:33:37  drand
 * 	Added UseCSText flag.
 * 	[1993/09/22  20:32:06  drand]
 * 
 * Revision 1.1.2.2  1993/09/17  14:28:16  drand
 * 	Checkpoint for demo.
 * 	[1993/09/17  14:26:31  drand]
 * 
 * $EndLog$
 */

#ifdef REV_INFO
#ifndef lint
static char *rcsidtransferH = "$Header: /u1/rcs/motif/demos/programs/transfer/transfer.h,v 1.1.2.1 1994/06/02 15:38:51 marty Exp $";
#endif
#endif

#ifndef _Transfer_h
#define _Transfer_h

typedef enum { Mprimary, Msecondary, Mclipboard, Mnamed } TransferMode;

#define _NAMED "NAMED_TRANSFER_ATOM"

extern TransferMode Tmode;

extern Widget editBox;
extern Widget toplevel, list, target, text1, text2, typeOM;
extern Widget op, omd, onamed, defer, text_display;
extern Widget format_om, format_s, format_l, format_t,
  format_cs, format_id, format_ih;

#ifdef _NO_PROTO 
extern void targetDestinationCallback();
extern void targetConvertCallback();
extern void inputCallback();
extern void ListSelectItem();
extern void SetType();
extern void SetFormat();
extern void SetValue();
extern void RemoveValue();
extern void quitCB();
extern void setMode();
extern void cut();
extern void copy();
extern void paste();
extern void pasteMove();
extern void deferCB();
extern char* GetSafeAtom();
extern char* ConvertXmStringToString();
extern void EditItem();
extern void unmanageCB();
extern void manageCB();
#else
extern void targetDestinationCallback(Widget w, XtPointer ignore,
				      XmDestinationCallbackStruct *cs);
extern void targetConvertCallback(Widget w, XtPointer ignore,
				  XmConvertCallbackStruct *cs);
extern void inputCallback(Widget w, XtPointer ignore,
			  XmDrawingAreaCallbackStruct *cbstruct);
extern void ListSelectItem(Widget w, XtPointer ignore, 
			   XmListCallbackStruct *listcb);
extern void SetType(Widget w, char *in, XtPointer ignore);
extern void SetFormat(Widget, char, XtPointer);
extern void SetValue(Widget widget, char *ignore, 
		     XmAnyCallbackStruct *callback_data);
extern void RemoveValue(Widget widget, char *ignore, 
		     XmAnyCallbackStruct *callback_data);
extern void quitCB(Widget widget, char *ignore, 
		     XmAnyCallbackStruct *callback_data);
extern void setMode(Widget widget, int param, XmAnyCallbackStruct *);
extern void cut(Widget widget, char *ignore, XmAnyCallbackStruct *);
extern void copy(Widget widget, char *ignore, XmAnyCallbackStruct *);
extern void paste(Widget widget, char *ignore, XmAnyCallbackStruct *);
extern void pasteMove(Widget widget, char *ignore, XmAnyCallbackStruct *);
extern void deferCB(Widget widget, char *ignore,
		    XmToggleButtonCallbackStruct *callback_data);
extern char* GetSafeAtom(Display *display, Atom a);
extern char* ConvertXmStringToString(XmString);
extern void EditItem(Widget w, int param, XtPointer ignore);
extern void unmanageCB(Widget, Widget, XtPointer);
extern void manageCB(Widget, Widget, XtPointer);
#endif /* _NO_PROTO */

typedef struct _transferdatarec {
  Atom		target;
  Atom		type;
  unsigned long	length;
  int		format;
  XtPointer	value;
  Boolean	deferred;
} TransferDataRec, *TransferData;



#ifdef _NO_PROTO
extern Widget create_mainWindow_widget();
extern Widget create_editbox_widget();
#else
extern Widget create_mainWindow_widget(char * name,
				       Widget parent);
extern Widget create_editbox_widget(char * name,
				    Widget parent);
#endif /* _NO_PROTO */

#endif /* _Transfer_h */
