/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: Container.h,v $
 * Revision 1.1.2.1  1994/06/02  15:39:29  marty
 * 	File moved from demos/widgets/WidWithoutDoc
 * 	[1994/06/02  14:10:44  marty]
 *
 * Revision 1.1.2.2  1993/10/29  14:18:02  rosenberg
 * 	Updated with changes from Exm/lib.
 * 	[1993/10/29  14:17:15  rosenberg]
 * 
 * Revision 1.1.2.1  1993/10/13  20:33:35  rosenberg
 * 	Moved this file from /Exm/lib directory.
 * 	[1993/10/13  20:32:22  rosenberg]
 * 
 * $EndLog$
 */
/*****************************************************************************
 *
 * Container.h: The widget public header file.
 *
 ****************************************************************************/


/* Ensure that the file be included only once. */
#ifndef _ExmContainer_h
#define _ExmContainer_h


/* Include appropriate files. */
#include <Xm/Xm.h> /* widget public header file for XmManager */


/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif


/* Define the widget class and widget record. */
externalref WidgetClass exmContainerWidgetClass;

typedef struct _ExmContainerClassRec * ExmContainerWidgetClass;
typedef struct _ExmContainerRec      * ExmContainerWidget;


/* Define an IsSubclass macro. */
#ifndef ExmIsContainer
#define ExmIsContainer(w) XtIsSubclass(w, exmContainerWidgetClass)
#endif


/* Define string equivalents of new resource names. */
#define ExmNfirstColumnWidth "firstColumnWidth"
#define ExmCFirstColumnWidth "FirstColumnWidth"

#define ExmNdetailOrder "detailOrder"
#define ExmCDetailOrder "DetailOrder"

#define ExmNdetailOrderCount "detailOrderCount"
#define ExmCDetailOrderCount "DetailOrderCount"

#define ExmNdetailTabList "detailTabList"
#define ExmCDetailTabList "DetailTabList"

#define ExmNdetailHeader "detailHeader"
#define ExmCDetailHeader "DetailHeader"

#define ExmNdetailHeaderCount "detailHeaderCount"
#define ExmCDetailHeaderCount "DetailHeaderCount"

#define ExmNselectColor "selectColor"
#define ExmCSelectColor "SelectColor"

#define ExmNlayoutType "layoutType"
#define ExmCLayoutType "LayoutType"


/* Specify the API for this widget. */
extern Widget ExmCreateContainer();


/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


/* Ensure that the file be included only once. */
#endif /* _ExmContainer_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */

