/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: ContainerP.h,v $
 * Revision 1.1.2.1  1994/06/02  15:39:30  marty
 * 	File moved from demos/widgets/WidWithoutDoc
 * 	[1994/06/02  14:10:45  marty]
 *
 * Revision 1.1.2.2  1993/10/29  14:18:03  rosenberg
 * 	Updated with changes from Exm/lib.
 * 	[1993/10/29  14:17:19  rosenberg]
 * 
 * Revision 1.1.2.1  1993/10/13  20:33:36  rosenberg
 * 	Moved this file from /Exm/lib directory.
 * 	[1993/10/13  20:33:16  rosenberg]
 * 
 * $EndLog$
 */

/****************************************************************************
 *
 * ContainerP.h: The widget private header file for the ExmContainer widget.
 *
 ****************************************************************************/

/* Ensure that the file be included only once. */
#ifndef _ExmContainerP_h
#define _ExmContainerP_h


/* Include appropriate files. */
#include <Exm/Container.h>  /* public header file for ExmContainer */ 
#include <Exm/GridP.h>      /* private header file for Grid */


/* Allow for C++ compilation. */
#ifdef __cplusplus
extern "C" {
#endif


/* Define the widget class part. */
typedef struct
{
	XtPointer		extension;
} ExmContainerClassPart;


/* Define the full class record. */
typedef struct _ExmContainerClassRec
{
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	XmManagerClassPart	manager_class;
	ExmGridClassPart	grid_class;
	ExmContainerClassPart	container_class;
} ExmContainerClassRec;

externalref ExmContainerClassRec exmContainerClassRec;


/* Define the widget instance part. */
typedef struct
{
 /* Provide space for the values of the resources of ExmContainer. */
	Dimension		first_column_width;
	Cardinal *		detail_order;
	Cardinal 		detail_order_count;
	XmTabList               detail_tablist ;
	XmStringTable           detail_header ;
	Cardinal                detail_header_count;
	Pixel                   select_color;
	unsigned char           layout_type;

	Widget                  icon_header;

} ExmContainerPart;


/* Define the full instance record. */
typedef struct _ExmContainerRec
{
	CorePart		core;
	CompositePart		composite;
	ConstraintPart		constraint;
	XmManagerPart		manager;
	ExmGridPart	        grid;
	ExmContainerPart	container;
} ExmContainerRec;


/* Define the constraint part structure. */
typedef struct _ExmContainerConstraintPart
{
	char unused ;
} ExmContainerConstraintPart, * ExmContainerConstraint;


/* Define the full constraint structure. */
typedef struct _ExmContainerConstraintRec
{
	XmManagerConstraintPart	        manager;
	ExmGridConstraintPart	        grid;
	ExmContainerConstraintPart	container;
} ExmContainerConstraintRec, * ExmContainerConstraintPtr;


/* Allow for C++ compilation. */
#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif


/* Ensure that the file be included only once. */
#endif /* _ExmContainerP_h */
