/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: DogP.h,v $
 * Revision 1.1.2.1  1994/06/02  15:39:38  marty
 * 	File moved from demos/dogs
 * 	[1994/06/02  14:11:55  marty]
 *
 * Revision 1.5.8.2  1993/07/21  20:30:51  yak
 * 	Expended OSF Copyright marker
 * 	[1993/07/21  19:05:39  yak]
 * 
 * Revision 1.5.6.2  1993/01/09  20:28:30  al
 * 	Integrate Destroy fixes from Robert Belanger
 * 	[1993/01/09  20:17:38  al]
 * 
 * Revision 1.5.4.2  1992/07/09  21:29:55  yak
 * 	Changed type of DogClassPart.reserved;
 * 	from int to XtPointer
 * 	to fix warnings in OSF1 1.1 build.
 * 	[1992/07/09  21:10:29  yak]
 * 
 * Revision 1.5.2.2  1992/05/21  16:47:09  yak
 * 	Removed personal copyrights
 * 	[1992/05/21  15:09:51  yak]
 * 
 * Revision 1.5  1992/03/13  15:34:04  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: DogP.h,v $ $Revision: 1.1.2.1 $ $Date: 1994/06/02 15:39:38 $ */

/*****************************************************************************
*
*  DogP.H - widget private header file
*  
******************************************************************************/

#ifndef _DogP_h
#define _DogP_h

#include <Xm/PrimitiveP.h>
#include "Dog.h"

void _DogDrawPixmap();
void _DogPosition();

#define DogIndex (XmPrimitiveIndex + 1)

typedef struct _DogClassPart {
    XtPointer reserved;
} DogClassPart;

typedef struct _DogClassRec {
    CoreClassPart core_class;
    XmPrimitiveClassPart primitive_class;
    DogClassPart dog_class;
} DogClassRec;

extern DogClassRec dogClassRec;

typedef struct _DogPart {
    int wag_time;
    int bark_time;
    XtCallbackList bark_callback;

    Boolean wagging;
    Boolean barking;
    GC draw_GC;
    Pixmap up_pixmap;
    Pixmap down_pixmap;
    Pixmap bark_pixmap;
    Position pixmap_x;
    Position pixmap_y;
    Position draw_x;
    Position draw_y;
    Dimension draw_width;
    Dimension draw_height;
    int curr_px;
    Pixmap curr_pixmap;
    Dimension curr_width;
    Dimension curr_height;
    XtIntervalId wagId;
    XtIntervalId barkId;
} DogPart;

typedef struct _DogRec {
    CorePart core;
    XmPrimitivePart primitive;
    DogPart dog;
} DogRec;

#define UpPx 0
#define DownPx 1
#define BarkPx 2

#endif /* _DogP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
